/*
	ModifyDialogs.r	-	Resource definitions used by ModifyDialogs

	Version	When	Who		What
	------- ----	---		----
	2.0		4/22/91	Zz		Added Append2hdlg routine to support Help Manager
							balloons for the items appended to the dialog.
							
*/

	
#include "types.r"
#include "BalloonTypes.r"

/* This resource defines the contents of the balloon that will be	*/
/* shown when the user points to the application icon in Finder...	*/
resource 'hfdr' (128, purgeable) {
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
	HMSTRResItem {
		128
		}
	}
};

/* This resource defines the items that we want to append onto the	*/
/* Printing Manager dialog(s).										*/
resource 'DITL' (256, purgeable) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{8, 0, 24, 112},
		CheckBox {
			enabled,
			"First Box"
		};
		/* [2] */
		{8, 175, 24, 287},
		CheckBox {
			enabled,
			"Second Box"
		};
		/* [3] */
		{8, 350, 24, 462},
		CheckBox {
			enabled,
			"Third Box"
		}
	}
};

/* This is the Help Manager compliment of the above DITL resource.	*/
/* There is basically one item defined here for each item in the 	*/
/* DITL.															*/
resource 'hdlg' (256, purgeable) {
	HelpMgrVersion,
	0,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {

	},
	{	/* array HDialogArray: 3 elements */
		/* [1] */
		HMStringResItem {
			{0, 0},
			{0, 0, 0, 0},
			256,
			1,
			256,
			2,
			256,
			3,
			256,
			4
		},
		/* [2] */
		HMStringResItem {
			{0, 0},
			{0, 0, 0, 0},
			256,
			5,
			256,
			6,
			256,
			7,
			256,
			8
		},
		/* [3] */
		HMStringResItem {
			{0, 0},
			{0, 0, 0, 0},
			256,
			9,
			256,
			10,
			256,
			11,
			256,
			12
		}
	}
};


/* These strings are referenced by the hdlg resource above.  They	*/
/* define the contents of the Help Manager balloons for the dialog	*/
/* items.															*/
resource 'STR#' (256, purgeable) {
	{
	/* [01] */
	"Sample checkbox #1 - Clicking here will put a check in the box.";
	/* [02] */
	"Sample checkbox #1 - This item is currently disabled.";
	/* [03] */
	"Sample checkbox #1 - Clicking here will clear the check in the box.";
	/* [04] */
	"";						/* Can't 'mark' a checkbox!!! */
	/* [05] */
	"Sample checkbox #2 - Clicking here will put a check in the box.";
	/* [06] */
	"Sample checkbox #2 - This item is currently disabled.";
	/* [07] */
	"Sample checkbox #2 - Clicking here will clear the check in the box.";
	/* [08] */
	"";						/* Can't 'mark' a checkbox!!! */
	/* [09] */
	"Sample checkbox #3 - Clicking here will put a check in the box.";
	/* [10] */
	"Sample checkbox #3 - This item is currently disabled.";
	/* [11] */
	"Sample checkbox #3 - Clicking here will clear the check in the box.";
	/* [12] */
	"";						/* Can't 'mark' a checkbox!!! */
	}
};

resource 'STR ' (128, purgeable) {
	"Run this application with Help balloons on to see an example of adding "
	"help to items appended into the Page Setup and Print dialogs."
};
