/*	@(#)errlst.c	2.1 	*/
/*LINTLIBRARY*/
char	*sys_errlist[] = {
	"Error 0",				/* 0 */
	"Not owner",				/* 1 - EPERM */
	"No such file or directory",		/* 2 - ENOENT */
	"No such process",			/* 3 - ESRCH */
	"Interrupted system call",		/* 4 - EINTR */
	"I/O error",				/* 5 - EIO */
	"No such device or address",		/* 6 - ENXIO */
	"Arg list too long",			/* 7 - E2BIG */
	"Exec format error",			/* 8 - ENOEXEC */
	"Bad file number",			/* 9 - EBADF */
	"No child processes",			/* 10 - ECHILD */
	"No more processes",			/* 11 - EAGAIN */
	"Not enough space",			/* 12 - ENOMEM */
	"Permission denied",			/* 13 - EACCES */
	"Bad address",				/* 14 - EFAULT */
	"Block device required",		/* 15 - ENOTBLK */
	"Device busy",				/* 16 - EBUSY */
	"File exists",				/* 17 - EEXIST */
	"Cross-device link",			/* 18 - EXDEV */
	"No such device",			/* 19 - ENODEV */
	"Not a directory",			/* 20 - ENOTDIR */
	"Is a directory",			/* 21 - EISDIR */
	"Invalid argument",			/* 22 - EINVAL */
	"File table overflow",			/* 23 - ENFILE */
	"Too many open files",			/* 24 - EMFILE */
	"Not a typewriter",			/* 25 - ENOTTY */
	"Text file busy",			/* 26 - ETXTBSY */
	"File too large",			/* 27 - EFBIG */
	"No space left on device",		/* 28 - ENOSPC */
	"Illegal seek",				/* 29 - ESPIPE */
	"Read-only file system",		/* 30 - EROFS */
	"Too many links",			/* 31 - EMLINK */
	"Broken pipe",				/* 32 - EPIPE */

/* math software */
	"Argument out of domain",		/* 33 - EDOM */
	"Result too large",			/* 34 - ERANGE */
	"No message of desired type",		/* 35 - ENOMSG */
	"Identifier removed",			/* 36 - EIDRM */
	"Channel number out of range",		/* 37 - ECHRNG */
	"Level 2 not synchronized",		/* 38 - EL2NSYNC */
	"Level 3 halted",			/* 39 - EL3HLT */
	"Level 3 reset",			/* 40 - EL3RST */
	"Link number out of range",		/* 41 - ELNRNG */
	"Protocol driver not attached",		/* 42 - EUNATCH */
	"No CSI structure available",		/* 43 - ENOSI */
	"Level 2 halted",			/* 44 - EL2HLT */
	"Error 45",				/* 45 - XX */
	"Error 46",				/* 46 - XX */
	"Error 47",				/* 47 - XX */
	"Error 48",				/* 48 - XX */
	"Error 49",				/* 49 - XX */
	"Error 50",				/* 50 - XX */
	"Error 51",				/* 51 - XX */
	"Error 52",				/* 52 - XX */
	"Error 53",				/* 53 - XX */
	"Error 54",				/* 54 - XX */

/* non-blocking and interrupt i/o */
	"Operation would block",		/* 55 - EWOULDBLOCK */
	"Operation now in progress",		/* 56 - EINPROGRESS */
	"Operation already in progress",	/* 57 - EALREADY */

/* ipc/network software */

	/* argument errors */
	"Socket operation on non-socket",	/* 58 - ENOTSOCK */
	"Destination address required",		/* 59 - EDESTADDRREQ */
	"Message too long",			/* 60 - EMSGSIZE */
	"Protocol wrong type for socket",	/* 61 - EPROTOTYPE */
	"Protocol not available",		/* 62 - ENOPROTOOPT */
	"Protocol not supported",		/* 63 - EPROTONOSUPPORT */
	"Socket type not supported",		/* 64 - ESOCKTNOSUPPORT */
	"Operation not supported on socket",	/* 65 - EOPNOTSUPP */
	"Protocol family not supported",	/* 66 - EPFNOSUPPORT */
	"Address family not supported by protocol family",
						/* 67 - EAFNOSUPPORT */
	"Address already in use",		/* 68 - EADDRINUSE */
	"Can't assign requested address",	/* 69 - EADDRNOTAVAIL */

	/* operational errors */
	"Network is down",			/* 70 - ENETDOWN */
	"Network is unreachable",		/* 71 - ENETUNREACH */
	"Network dropped connection on reset",	/* 72 - ENETRESET */
	"Software caused connection abort",	/* 73 - ECONNABORTED */
	"Connection reset by peer",		/* 74 - ECONNRESET */
	"No buffer space available",		/* 75 - ENOBUFS */
	"Socket is already connected",		/* 76 - EISCONN */
	"Socket is not connected",		/* 77 - ENOTCONN */
	"Can't send after socket shutdown",	/* 78 - ESHUTDOWN */
	"Too many references: can't splice",	/* 79 - ETOOMANYREFS */
	"Connection timed out",			/* 80 - ETIMEDOUT */
	"Connection refused",			/* 81 - EREFUSED */
	"Too many levels of symbolic links",	/* 82 - ELOOP */
	"File name too long",			/* 83 - ENAMETOOLONG */
	"Host is down",				/* 84 - EHOSTDOWN */
	"Host is unreachable",			/* 85 - EHOSTUNREACH */
	"Directory not empty",			/* 86 - ENOTEMPTY */

/* Streams errors */

	"Device not a stream",			/* 87 - ENOSTR */
	"No data (for delay IO)",		/* 88 - ENODATA */
	"Timer expired",			/* 89 - ETIME */
	"Out of streams resources",		/* 90 - ENOSR */
	"Error 91",				/* 91 - XX */
	"Error 92",				/* 92 - XX */
	"Error 93",				/* 93 - XX */
	"Error 94",				/* 94 - XX */
	"Stale NFS file handle",		/* 95 - ESTALE */
	"Too many levels of remote in path",	/* 96 - EREMOTE */
	"Too many processes",			/* 97 - EPROCLIM */
	"Too many users",			/* 98 - EUSERS */
	"Disc quota exceeded",			/* 99 - EDQUOT */
	"Locking deadlock error"		/* 100 - EDEADLOCK */
};
int	sys_nerr = { sizeof(sys_errlist)/sizeof(sys_errlist[0]) };
