#ifndef sfntEnumIncludes
#define sfntEnumIncludes

typedef enum {
	plat_Unicode,
	plat_Macintosh,
	plat_ISO,
	plat_MS
} platformEnums;

#ifndef _ScriptMgr_
typedef enum {
	smRoman,
	smJapanese,
	smTradChinese,
	smChinese = smTradChinese,
	smKorean,
	smArabic,
	smHebrew,
	smGreek,
	smCyrillic,
	smRussian = smCyrillic,
	smRSymbol,
	smDevanagari,
	smGurmukhi,
	smGujarati,
	smOriya,
	smBengali,
	smTamil,
	smTelugu,
	smKannada,
	smMalayalam,
	smSinhalese,
	smBurmese,
	smKhmer,
	smThai,
	smLaotian,
	smGeorgian,
	smArmenian,
	smSimpChinese,
	smTibetan,
	smMongolian,
	smGeez,
	smEthiopic = smGeez,
	smAmharic = smGeez,
	smSlavic,
	smEastEurRoman = smSlavic,
	smVietnamese,
	smExtArabic,
	smSindhi = smExtArabic,
	smUninterp
} scriptEnums;
#endif

typedef enum {
	lang_English,
	lang_French,
	lang_German,
	lang_Italian,
	lang_Dutch,
	lang_Swedish,
	lang_Spanish,
	lang_Danish,
	lang_Portuguese,
	lang_Norwegian,
	lang_Hebrew,
	lang_Japanese,
	lang_Arabic,
	lang_Finnish,
	lang_Greek,
	lang_Icelandic,
	lang_Maltese,
	lang_Turkish,
	lang_Yugoslavian,
	lang_Chinese,
	lang_Urdu,
	lang_Hindi,
	lang_Thai
} languageEnums;

typedef enum {
	name_Copyright,
	name_Family,
	name_Subfamily,
	name_UniqueName,
	name_FullName,
	name_Version,
	name_Postscript,
	name_Trademark
} fontNameEnums;

#define tag_FontHeader			0x68656164	/* 'head' */
#define tag_HoriHeader			0x68686561	/* 'hhea' */
#define tag_VertHeader			0x76686561	/* 'vhea' */
#define tag_IndexToLoc			0x6c6f6361	/* 'loca' */
#define tag_MaxProfile			0x6d617870	/* 'maxp' */
#define tag_ControlValue			0x63767420	/* 'cvt ' */
#define tag_PreProgram			0x70726570	/* 'prep' */
#define tag_GlyphData			0x676c7966	/* 'glyf' */
#define tag_HorizontalMetrics		0x686d7478	/* 'hmtx' */
#define tag_VerticalMetrics		0x766d7478	/* 'vmtx' */
#define tag_CharToIndexMap		0x636d6170	/* 'cmap' */
#define tag_FontProgram			0x6670676d	/* 'fpgm' */

#define tag_Kerning				0x6b65726e	/* 'kern' */
#define tag_HoriDeviceMetrics		0x68646d78 	/* 'hdmx' */
#define tag_NamingTable			0x6e616d65	/* 'name' */
#define tag_PostScript			0x706f7374	/* 'post' */

#endif
