/**********************************************************************************
UDateTimeText.r
	This files contains the string list resource definitions required by the
	TDateEditText and TTimeEditText classes.
**********************************************************************************/

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#define		kInvalidDateTimeAlert	701

#define		kInvalidDateReasons		701
#define		kInvalidTimeReasons		702

resource 'STR#' (kInvalidDateReasons,
#if qNames
	"kInvalidDateReasons",
#endif
	purgeable) {
	{	/* [1] */	"Invalid date";		// default time error string
	
		/* [2] */	"The string contains leftover characters";
		/* [3] */	"The field separator is inappropriate";
		/* [4] */	"The order of the fields is inappropriate";
		/* [5] */	"The string contains extraneous characters";
		/* [6] */	"The string contains too many separators";
		/* [7] */	"The field separator is inconsistent";
		/* [8] */	"A token error occurred while parsing the string";
		/* [9] */	"The date utilities could not be read in";
		/* [10] */	"No date was found in the string";
		/* [11] */	"The date found was invalid"
	}
};  /* kInvalidDateReasons */

resource 'STR#' (kInvalidTimeReasons,
#if qNames
	"kInvalidTimeReasons",
#endif
	purgeable) {
	{	/* [1] */	"Invalid time";		// default time error string
	
		/* [2] */	"The string contains leftover characters";
		/* [3] */	"The field separator is inappropriate";
		/* [4] */	"The order of the fields is inappropriate";
		/* [5] */	"The string contains extraneous characters";
		/* [6] */	"The string contains too many separators";
		/* [7] */	"The field separator is inconsistent";
		/* [8] */	"A token error occurred while parsing the string";
		/* [9] */	"The time utilities could not be read in";
		/* [10] */	"No time was found in the string";
		/* [11] */	"The time found was invalid"
	}
};  /* kInvalidTimeReasons */


resource 'DITL' (kInvalidDateTimeAlert,
#if qNames
	"kInvalidDateTimeAlert",
#endif
	purgeable) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{90, 20, 110, 60},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 80, 110, 270},
		StaticText {
			disabled,
			"^0; previous value substituted.\n\nEnter using this format:\n^1"
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			0				// "Stop!" icon
		}
	}
};

resource 'ALRT' (kInvalidDateTimeAlert,
#if qNames
	"kInvalidDateTimeAlert",
#endif
	purgeable) {
	{90, 100, 210, 412},
	kInvalidDateTimeAlert,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent;
		/* [2] */
		OK, visible, silent;
		/* [3] */
		OK, visible, silent;
		/* [4] */
		OK, visible, silent
	}
};