/*****************************************************************************************

NTBDemo.h - constants and externs for NTBDemo

Written by Bryan K. Ressler (Beaker), 8/30/91

*****************************************************************************************/

/** INCLUDES ****************************************************************************/
#include "Headers.h"

/** DEFINES *****************************************************************************/
#define kTestDlgID			128			/* DLOG/DITL: The main test dialog */
#define kPerfAlrtID			129			/* ALRT/DITL: The performance results alert */
#define kNoCanDoAlrtID		130			/* ALRT/DITL: The "no can do full just" alert */
#define kDoPerfAlrtID		131			/* ALRT/DITL: The "do perf tests?" alert */
#define kShannonID			128			/* TEXT: The Shannon text for the NTB item */
#define kBarkerID			129			/* TEXT: Text from Clive Barker book */
#define kTestTextID			130			/* TEXT: The text used for speed test */
#define kStringsID			128			/* STR#: Text for the info box */

#define kQuitButton			1			/* Button: Quit */
#define kPerfButton			2			/* Button: Performance */
#define kTextArea			3			/* User item: Main text area */
#define kJustLeft			4			/* Radio button: Just left */
#define kJustCenter			5			/* Radio button: Just center */
#define kJustRight			6			/* Radio button: Just right */
#define kJustFull			7			/* Radio button: Just full */
#define kVariableHeight		8			/* Check box: Variable line height */
#define kAppFont			9			/* Radio button: Application font */
#define kTimes				10			/* Radio button: Times */
#define kHelvetica			11			/* Radio button: Helvetica */
#define kShannonText		12			/* Radio button: Shannon text */
#define kLiterature			13			/* Radio button: Clive Barker */
#define kValuesItem			14			/* Static text: Paramtext values */
#define kInfoItem			15			/* User item: informational text */
#define kBoxOne				16			/* User item: box */
#define kLastBox			17			/* Item number of last box */
#define kDividerOne			18			/* User item: gray divider line */
#define kLastDivider		20			/* Item number of last divider */

#define kOkayButton			1			/* OK button in alerts */

#define kStdInfo			1			/* Index to standard info string */
#define kCachingPass		2			/* Index to "Caching pass" string */
#define kTestingTextBox		3			/* Index to "Testing TextBox" string */
#define kTestingNeoTextBox	4			/* Index to "Testing NeoTextBox" string */

#define kTestIterations		200			/* Number of test iterations */

#define kTrueTypeTrap		0x54		/* The TrueType trap number */
#define kUnimplTrap			0x9f		/* The "unimplmented" trap num */

/** EXTERNALS ***************************************************************************/
extern SysEnvRec	gEnvironment;	/* Our operating environment */
extern Boolean		gHasTrueType;	/* Is TrueType around? */
extern short		gJustRadio;		/* Currently-set justification radio button */
extern short		gFontRadio;		/* Currently-set font radio button */
