#pragma once

/************************************
* included files
************************************/
#include "mapping.h"
#include "xform bitmap.h"

/************************************
* Konstants and typedefs
************************************/
#define PICTResID 1001

/************************************
* Prototypes
************************************/

/* DemoRoutines.c */
OSErr TestGetSetPixel(PicHandle pict);
OSErr TestBetterGetSetPixel(PicHandle pict);
OSErr TestFastGetSetPixel(PicHandle pict);
OSErr TestRedGreenInvert(PicHandle pict);
OSErr TestCalculateDelta(PicHandle pict);
OSErr TestCalculateDeltaFast(PicHandle pict);
OSErr TestBoxScale(PicHandle pict);
OSErr TestTentScale(PicHandle pict);
OSErr TestRotate(PicHandle pict);
OSErr TestWarp(PicHandle pict);
OSErr TestRectangleEffect(PicHandle pict);

/* AsmBasics.c */
long GWGet32PixelAsm(GWorldPtr src, short x, short y);
void GWSet32PixelAsm(GWorldPtr src, short x, short y, long pixelValue);
long FastGWGet32Pixel(PixMap *srcPixMap, long *srcBaseAddr, short x, short y);
void FastGWSet32Pixel(PixMap *srcPixMap, long *srcBaseAddr, short x, short y, long pixelValue);

/* CalcDeltasFast.c */
void FastCalculateDeltas(GWorldPtr src, GWorldPtr dst);

/* CalculateDeltas.c */
void CalculateDeltas(GWorldPtr src, GWorldPtr dst);
unsigned char CalcLuminance(long RGBval);

/* CBasics.c */
long GWGet32PixelC(GWorldPtr src, short x, short y);
void GWSet32PixelC(GWorldPtr src, short x, short y, long pixelValue);

/* FourBitScaler.c */
void Scale1BitTo4Bit(GWorldPtr src, GWorldPtr dst);

/* RectangleEffect.c */
void BlastRect(long value, Rect *rect, short x, short y, GWorldPtr dst);
void ImageBlastRect(Rect *rect, GWorldPtr dst);

/* RedGreenInvert.c */
void RedGreenInvert(GWorldPtr src);

/* xform bitmap.c */
void Assert(int assertion);
shortFrac ShortFracMul(shortFrac a, shortFrac b);
unsigned char ShortFracMulByte(shortFrac percent, unsigned char value);
Boolean ModelessPtInRect(Point p, Rect *r);
Boolean GetFractionalPixel(long *srcBaseAddr, long srcRowLongs, Rect *srcBounds, Fixed fx, Fixed fy, long *dstLong);
Boolean GetFractionalPixelBox(long* srcBaseAddr, long srcRowLongs, Rect* srcBounds, Fixed fx, Fixed fy, long* dstLong );
Boolean GetFractionalPixelTent(long* srcBaseAddr, long srcRowLongs, Rect* srcBounds, Fixed fx, Fixed fy, long* dstLong );
int LockGWorldPixels(GWorldPtr world, Boolean lockIt);
void SetGWorldPixel(GWorldPtr world, short x, short y);
void EraseGWorld(GWorldPtr world, Rect *bounds);
void FancyMap(const Rect *srcRect, Fixed *xPtr, Fixed *yPtr);
void FancyMapBounds(Rect *bounds);
GWorldPtr MapGWorld(GWorldPtr srcWorld, mapping* dstMapping, GWorldPtr* maskWorld);
GWorldPtr MapGWorldTent(GWorldPtr srcWorld, mapping* dstMapping, GWorldPtr* maskWorld);
GWorldPtr MapGWorldBox(GWorldPtr srcWorld, mapping *dstMapping, GWorldPtr *maskWorld);
GWorldPtr FancyMapGWorld(GWorldPtr srcWorld, mapping* dstMapping, GWorldPtr* maskWorld);
GWorldPtr PictToGWorld(PicHandle pict, Rect *bounds);
void CenterRect(Rect *r, short x, short y);

/* mapping.c */
void MapXY(const mapping *map, Fixed *x, Fixed *y);
mapping *InvertMapping(mapping *map);
mapping *SetIdentityMapping(mapping *map);
mapping *ScaleMapping(mapping *map, Fixed scaleX, Fixed scaleY, Fixed aboutX, Fixed aboutY);
Boolean IdentityMapping(const mapping *map);
mapping *ConcateMapping(mapping *dst, const mapping *map);
mapping *RotateMapping(mapping *map, Fixed angle, Fixed aboutX, Fixed aboutY);
mapping *OffsetMapping(mapping *map, Fixed offsetX, Fixed offsetY);
Point *MapQDPoint(const mapping *map, Point *p);
Rect *MapRectangle(const mapping *map, Rect *r);
RgnHandle MapRectToRgn(const mapping *map, const Rect *r, RgnHandle rgn);

