/* Menu IDs and item numbers */
#define kAppleMenuID		128
	#define	iAbout			1

#define kFileMenuID			129
	#define	iOpen			1
	#define	iClose			2
	#define	iSave			3
	#define	iSaveAs			4
	#define	iPageSetup		6
	#define	iPrint			7
	#define	iQuit			9

#define kEditMenuID			130
	#define	iUndo			1
	#define	iCut			3
	#define	iCopy			4
	#define	iPaste			5
	#define	iClear			6

/* Indexes into global menu array */
#define kAppleMenu			0
#define kFileMenu			1
#define kEditMenu			2

/* The error alert id */
#define kErrorAlertID		129

/*-----------------------------------------------
Protoypes for routines that app must provide
-----------------------------------------------*/

/* The start and the end */
Boolean	AppInit(void);
Boolean	AppQuit(void);
void 	AppCleanUp(void);

/* Events */
void 	AppActivate(WindowPtr wind, Boolean activate);
void 	AppUpdate(EventRecord *event);
void 	AppIdle(EventRecord *event);
void 	AppClick(Point thePt, WindowPtr whichWindptr, Boolean doubleClick);
void 	AppGrowWindow(WindowPtr wind, Point where, Rect *desk);
void 	AppZoomWindow(WindowPtr wind, short zoomDir);

/* Menus in general */
void	AppAdjustMenus(void);
void 	AppMenu(short id, short item);

/* File Menu */
void	AppNew(void);
void	AppOpen(void);
Boolean	AppClose(void);
Boolean	AppSave(void);
Boolean	AppSaveAs(void);
void	AppPageSetup(void);
void	AppPrint(void);

/* Edit Menu */
void 	AppUndo(void);
void 	AppCut(void);
OSErr 	AppCopy(void);
void 	AppPaste(void);
void 	AppClear(void);

/* --------------------------------------------------------
Prototypes for shell routines the App may want to call
-------------------------------------------------------- */
int			abs(int i);
long		labs(long i);
Boolean 	NewPixImage(PixMapHandle ThePix, Rect *TheRect, short dpth);
Boolean 	NewBitMap(BitMap *TheMap, Rect *TheRect);
void 		CenterRect(Rect *theRect, Point *thePt);
Point 		Center(Rect *theRect);
short		NumToolboxTraps(void);
TrapType	GetTrapType(short theTrap);
Boolean		TrapAvailable(short theTrap);
