/* Filters are one shot procedures: they are called only once, so if they need 
configuring they should interact with the user first, then do their thing */

/* messages for the Brush function */
#define kStartBrush 0		/* Initialize */
#define kDoStroke 	1		/* paint a stroke or, if a filter, do your thing */
#define kConfigure	2		/* get necessary user input */
#define kStopBrush 	3		/* Clean up */

/* messages passed back by the brush on kStartBrush */
#define kCantRun 		-1		/* Any Error */
#define kNoConfig		0		/* Regular brush, no config */
#define kConfig			1		/* Tells app to enable the "Configure Brush" option */

#define kConfigMask		1		/* This bit is set if Configurable */

/* The brush params struct */
typedef struct
{
	Point		pt;
	Rect		rect;
	RGBColor	color;
	GWorldPtr	theSource;
	GWorldPtr	theDestination;
	long		storage;
}BrushParams;

/* Here's a typedef that defines the brush interface */
typedef pascal short (*BrushFunc)(short msg, BrushParams *params);

/* Here's a typedef that defines the brush interface */
typedef pascal short (*FilterFunc)(GWorldPtr world);
