#include	"Brushes.h"
#include 	"DialogUtils.h"

typedef struct
{
	short	numDots;
	short	clumpSize;
}ClumpSpecs;

/* Prototypes */
void Stroke(BrushParams *params);
void DoConfigDialog(ClumpSpecs *specs);

pascal short main(short msg, BrushParams *params)
{
	short	rslt = noErr;
	
	switch(msg)
	{
		case kStartBrush:
			params->storage = (long)NewHandle(sizeof(ClumpSpecs));
			if(params->storage == 0)
				rslt = kCantRun;
			else
			{
				ClumpSpecs *specs;
				
				HLock((Handle)params->storage);
				specs = (ClumpSpecs *)(*(Handle)params->storage);
				specs->numDots = 10;
				specs->clumpSize = 8;
				HUnlock((Handle)params->storage);
				rslt = kConfig;
			}
			break;	
		
		case kConfigure:
			HLock((Handle)params->storage);
			DoConfigDialog((ClumpSpecs *)(*(Handle)params->storage));
			HUnlock((Handle)params->storage);
			break;
		
		case kDoStroke:
			Stroke(params);
			break;
			
		case kStopBrush:
			DisposHandle((Handle)params->storage);
			params->storage = 0;
			break;
	}
	return rslt;
}

void Stroke(BrushParams *params)
{
	short		cnt, halfSize;
	
	/* Set the color */
	RGBForeColor(&params->color);
	
	/* Draw Clump */
	cnt = (**(ClumpSpecs **)params->storage).numDots;
	halfSize = (**(ClumpSpecs **)params->storage).clumpSize / 2;
	while(cnt-- > 0)
	{ 
		MoveTo(params->pt.h + Random() % halfSize, params->pt.v + Random() % halfSize);
		Line(0, 0);
	}
}


void DoConfigDialog(ClumpSpecs *specs)
{
	DialogPtr			dptr;
	short				hit, kind;
	long				rslt;
	Handle				itmhndl;
	Rect				rect;
	pascal void			BtnItem();
	
	#define kNumDotsItem	4
	#define kClumpSizeItem	5
	
	dptr = GetNewDialog(203, nil, (Ptr)(-1));
	if(dptr == nil)
	{
		SysBeep(10);
		return;
	}
	
	/* OK button Outline */
	GetDItem(dptr, kOKOutline, &kind, &itmhndl, &rect);
	SetDItem(dptr, kOKOutline, userItem, (Handle)BtnItem, &rect);
	
	/* Set Values... */
	ShortToDlog(specs->numDots, dptr, kNumDotsItem);
	ShortToDlog(specs->clumpSize, dptr, kClumpSizeItem);
		
	/* Do it... */
	SelIText(dptr, kNumDotsItem, 0, 32767);
	ShowWindow(dptr);
	while(true)									/* Loop until break...*/
	{
		Boolean 	out = false;
		
		ModalDialog(NumFilter, &hit);
		switch(hit)
		{
			case kOKButton:						/* OK button hit...*/
				if(InRange(dptr, kNumDotsItem, 1, 100))
				{
					if(InRange(dptr, kClumpSizeItem, 1, 100))
					{
						specs->numDots = DlogToShort(dptr, kNumDotsItem);
						specs->clumpSize = DlogToShort(dptr, kClumpSizeItem);
						out = true;
					}
				}
				break;
	
			case kCancelButton:						/* Cancel button hit...*/
				out = true;
				break;

			default:					/* Anything else hit... */
				continue;
		}
		if(out)
			break;
	}
	InitCursor();
	DisposDialog(dptr);
}
