#include	"Brushes.h"
#include 	"DialogUtils.h"

#define kDialogID 206

void Stroke(BrushParams *params);
void DoConfigDialog(long *length);

pascal short main(short msg, BrushParams *params)
{
	short	rslt = noErr;
	
	switch(msg)
	{
		case kStartBrush:
			params->storage = 8;
			rslt = kConfig;
			break;	
		
		case kConfigure:
			DoConfigDialog(&params->storage);
			break;
		
		case kDoStroke:
			Stroke(params);
			break;
			
		case kStopBrush:
			break;
	}
	return rslt;
}

void Stroke(BrushParams *params)
{
	short	cnt = 8;
	
	/* Set the color */
	RGBForeColor(&params->color);
	
	/* Stroke it... */
	while(cnt-- > 0)
	{
		MoveTo(params->pt.h, params->pt.v);
		Line(Random() % params->storage, Random() % params->storage);
	}
}

void DoConfigDialog(long *length)
{
	DialogPtr			dptr;
	short				hit, kind;
	long				rslt;
	Handle				itmhndl;
	Rect				rect;
	pascal void			BtnItem();
	
	#define kRadiusItem 4
	
	dptr = GetNewDialog(kDialogID, nil, (Ptr)(-1));
	if(dptr == nil)
	{
		SysBeep(10);
		return;
	}
	
	/* OK button Outline */
	GetDItem(dptr, kOKOutline, &kind, &itmhndl, &rect);
	SetDItem(dptr, kOKOutline, userItem, (Handle)BtnItem, &rect);
	
	/* Other user Items... */
	
	/* Set Values... */
	ShortToDlog((short)*length, dptr, kRadiusItem);
		
	/* Do it... */
	SelIText(dptr, kRadiusItem, 0, 32767);
	ShowWindow(dptr);
	while(true)									/* Loop until break...*/
	{
		Boolean 	out = false;
		
		ModalDialog(NumFilter, &hit);
		switch(hit)
		{
			case kOKButton:						/* OK button hit...*/
				if(InRange(dptr, kRadiusItem, 1, 100))
				{
					*length = (long)DlogToShort(dptr, kRadiusItem);
					out = true;
				}
				break;
	
			case kCancelButton:						/* Cancel button hit...*/
				out = true;
				break;
	
			default:					/* Anything else hit... */
				continue;
		}
		if(out)
			break;
	}
	InitCursor();
	DisposDialog(dptr);
}
