#include	"Brushes.h"
#include 	"DialogUtils.h"

#define kMyID	204

/* Prototypes */
void 	Stroke(BrushParams *params);
short 	IconToBitMap(BitMap *dog);
void	DrawDog(Point ctr, BitMap *dog);
void 	CenterRect(Rect *theRect, Point thePt);

pascal short main(short msg, BrushParams *params)
{
	short	rslt = noErr;
	
	switch(msg)
	{
		case kStartBrush:
			params->storage = (long)NewHandle(sizeof(BitMap));
			if(params->storage == 0)
				rslt = kCantRun;
			else
			{
				BitMap 	*dog;
				OSErr		err;
				
				HLock((Handle)params->storage);
				dog = (BitMap *)(*(Handle)params->storage);
				err = IconToBitMap(dog);
				HUnlock((Handle)params->storage);
				if(err != noErr)
					rslt = kCantRun;
				else
					rslt = kNoConfig;
			}
			break;	
		
		case kConfigure:
			break;
		
		case kDoStroke:
			Stroke(params);
			break;
			
		case kStopBrush:
			/* Look out, nasty casting ahead... */
			ReleaseResource((Handle)(((BitMap *)(*((Handle)params->storage)))->baseAddr));
			DisposHandle((Handle)params->storage);
			params->storage = 0;
			break;
	}
	return rslt;
}

void Stroke(BrushParams *params)
{
	short		cnt, halfSize;
	BitMap 	*dog;
	
	/* Get the dog */			
	HLock((Handle)params->storage);
	dog = (BitMap *)(*(Handle)params->storage);
	
	/* Set the color */
	RGBForeColor(&params->color);
	
	/* Draw Dog */
	DrawDog(params->pt, dog);
	HUnlock((Handle)params->storage);
}


OSErr IconToBitMap(BitMap *dog)
{
	Handle	icon;
	Rect	srcRect;
	
	/* Get the Icon, and set up the bit map */
	SetRect(&srcRect, 0, 0, 32, 32);
	dog->rowBytes = 4;
	dog->bounds = srcRect;
	dog->baseAddr = (Ptr)GetIcon(kMyID);
	if(dog->baseAddr != nil)
		return noErr;
	else
		return -1; /* generic error */
}
		
void	DrawDog(Point ctr, BitMap *dog)
{
	Handle	temp;
	Rect	dstRect;
	GrafPtr	port;
	
	if(dog->baseAddr != nil)
	{
		/* Set up the destination rect */
		SetRect(&dstRect, 0, 0, 32, 32);
		CenterRect(&dstRect, ctr);
		
		/* save the handle, lock it, and install good baseAddr */
		temp = (Handle)dog->baseAddr;
		HLock(temp);
		dog->baseAddr = *temp;
		GetPort(&port);
		CopyBits((BitMap *)dog, &port->portBits,
				&dog->bounds, &dstRect, srcOr, nil);
			
		dog->baseAddr = (Ptr)temp;
		HUnlock(temp);
	}
}

void CenterRect(Rect *theRect, Point thePt)
{
	/* First home theRect... */
	
	OffsetRect(theRect, -theRect->left, -theRect->top);
	
	/* ...then center it over thePt */
	
	 
	thePt.h = thePt.h - (theRect->right / 2);
	thePt.v = thePt.v - (theRect->bottom / 2);
	OffsetRect(theRect, thePt.h, thePt.v);
}
