pascal short main(GWorldPtr world)
{
	PixMapHandle		srcPixMap;
	short				srcRowBytes;
	long				*srcBaseAddr;
	long				*srcAddr1;
	char				mmuMode;
	short				row, column;
	short				width, height;
	short				rslt = -1;
	long				val;

	srcPixMap = GetGWorldPixMap(world);
	if(srcPixMap != nil)
	{
		/* If world isn't 32 bit, don't do anything */
		if((*srcPixMap)->pixelSize == 32)
		{	
			val = 0x00FFFFFF;
			HLock(srcPixMap);
			if(LockPixels(srcPixMap)) 
			{
				/* Get the base address. */
				srcBaseAddr = (long *) GetPixBaseAddr(srcPixMap);
				/* Get the row increment. */
				srcRowBytes = (**srcPixMap).rowBytes & 0x7fff;
				width = (**srcPixMap).bounds.right-(**srcPixMap).bounds.left;
				height = (**srcPixMap).bounds.bottom-(**srcPixMap).bounds.top;
				
				mmuMode = true32b;
				SwapMMUMode(&mmuMode);			/* Set the MMU to 32-bit mode. */
				for (row = 0; row < height; row++) 
				{
					srcAddr1 = srcBaseAddr;
					for (column = 0; column < width; column++) 
					{
						/* Invert the red and green. Note that for 32-bit pixels, 
						pixel memory is organized as XRGB, where each component is 8 
						bits. */
						*srcAddr1++ ^= val;		/* Bump to next pixel. */
					}
					/* Go to the next row. */
					srcBaseAddr = (long *) ((char *) srcBaseAddr + srcRowBytes);
				}
				SwapMMUMode(&mmuMode);		/* Restore the previous MMU mode. */
				UnlockPixels(srcPixMap);	/* Unlock the pixMap. */
				rslt = noErr;
			}
			HUnlock(srcPixMap);
		}
		else
			SysBeep(10);
	}
	return rslt;
}

