pascal OSErr TestMain(GWorldPtr world);
/* These routines by Konstantin Othmer and Mike Reed, for develop #10 */
long GWGet32PixelAsm( GWorldPtr src, short x, short y );
void BlastRect( long value, Rect *rect, short x, short y, GWorldPtr dst );
void ImageBlastRect( Rect *rect, GWorldPtr dst );

pascal OSErr main(GWorldPtr world)
{
	short				rslt = -1;
	PixMapHandle		srcPixMap;
	Rect 				boxSize;

	srcPixMap = GetGWorldPixMap(world);
	if(srcPixMap != nil)
	{
		/* If world is 32 bit, go ahead. Else beep */
		if((*srcPixMap)->pixelSize == 32)
		{
			if(LockPixels(srcPixMap))
			{
				SetRect(&boxSize, 0, 0, 10, 10);
				ImageBlastRect( &boxSize, world );
				rslt = noErr;
			}
		}
		else
			SysBeep(10);
	}
	return rslt;
}

/* These routines by Konstantin Othmer and Mike Reed, for develop #10 */
void ImageBlastRect( Rect *rect, GWorldPtr dst )
{
short			x,y;
PixMapHandle	dstPixMap;
long			value;

	dstPixMap = GetGWorldPixMap ( dst );
	for( y = (**dstPixMap).bounds.top; y < (**dstPixMap).bounds.bottom; y += rect->bottom )
	{
		for( x = (**dstPixMap).bounds.left; x < (**dstPixMap).bounds.right; x += rect->right )
		{
			value = GWGet32PixelAsm( dst, x, y );
			BlastRect( value, rect, x, y, dst );
		}
	}
}

void BlastRect( long value, Rect *rect, short x, short y, GWorldPtr dst )
{
PixMapHandle	dstPixMap;
short			dstRowBytes;
long			dstBaseAddr;
long			dstAddr;
short			row, column;
short			width;
short			height;

	dstPixMap = GetGWorldPixMap ( dst );

	dstBaseAddr = (long) GetPixBaseAddr ( dstPixMap );	/* get the address of the pixmap */
	dstRowBytes = (**dstPixMap).rowBytes & 0x7fff;			/* get the row increment */

	if( (x + rect->right) < (**dstPixMap).bounds.right )
		width = rect->right - rect->left;
	else
		width = (**dstPixMap).bounds.right - (x + rect->left);

	if( (y + rect->bottom) < (**dstPixMap).bounds.bottom )
		height = rect->bottom - rect->top;
	else
		height = (**dstPixMap).bounds.bottom - (y + rect->top);

	x -= (**dstPixMap).bounds.left;
	y -= (**dstPixMap).bounds.top;

	dstBaseAddr = dstBaseAddr + (long)y*dstRowBytes + (x<<2);
	for ( row = 0; row < height; row++ ) 
	{
		dstAddr = dstBaseAddr;
		for ( column = 0; column < width; column++ ) 
		{	
			*(long*)dstAddr = value;
			dstAddr += 4;
		}
		dstBaseAddr = (long) ( (char *) dstBaseAddr + dstRowBytes );	/* go to the next row */
	}
}

long GWGet32PixelAsm( GWorldPtr src, short x, short y )
{
PixMapHandle	srcPixMap;
unsigned short	srcRowBytes;
long			srcBaseAddr;
long			srcAddr;
char			mmuMode;
long			result;

	srcPixMap = GetGWorldPixMap( src );
	srcBaseAddr = (long) GetPixBaseAddr ( srcPixMap );	/* get the address of the pixmap */
	mmuMode = true32b;
	SwapMMUMode ( &mmuMode );						/* set the MMU to 32-bit mode */

	asm {
		move.l	srcPixMap,a0
		move.l	srcBaseAddr,a1
		move.l	(a0),a0				;get ptr to pixmap
		move.w	y,d1				;get y
		sub.w	6(a0),d1			;make y bounds 0 relative
		move.w	4(a0),d0			;get rowbytes
		and.w	#0x7FFF,d0			;strip bitmap/pixmap bit
		mulu.w	d0,d1				;calculate offset to beginning of this row
		adda.l	d1,a1				;calculate address of this row
		moveq	#0,d0				;extend x to a word
		move.w	x,d0
		sub.w	8(a0),d0			;make x bounds 0 relative
		lsl.w	#2,d0				;convert x to pixels (4 bytes/pixel)
		adda.l	d0,a1				;calculate pixel address
		move.l	(a1),result
	}
	SwapMMUMode ( &mmuMode );						/* restore the previous MMU mode */
	return( result );
}

