/****************************************************************************************

UTILInstall.h - Includes for UTILInstall
 
Written by Bryan K. Ressler (Beaker), 10/8/91

****************************************************************************************/

#include "std.h"

/****** Resource types *****************************************************************/
#define UTILSPECTYPE	'USPC'		/* Resource type for a UTIL Specification resource */
#define UTILTYPE		'UTIL'		/* Resource type for a UTIL */
#define DLOGTYPE		'DLOG'		/* Resource type for dialog templates */
#define ALRTTYPE		'ALRT'		/* Resource type for alert templates */

/****** Resource IDs *******************************************************************/
#define ERRSTRSID		128			/* 'STR#' - Error strings */
#define INSTALLSTRSID	129			/* 'STR#' - UTILInstall misc strings */
#define ERRALRTID		128			/* 'ALRT' - Error alert */
#define ABOUTALRTID		130			/* 'ALRT' - About box */
#define SUCCESSALRTID	131			/* 'ALRT' - Successful */
#define LOCATEDLOGID	129			/* 'DLOG' - Locate description */
#define UPDATINGDLOGID	132			/* 'DLOG' - Updating LWFU dialog */

/****** Install string numbers *********************************************************/
#define LOCATELWFU		1			/* Locate the LaserWriter Font Utility */
#define LOCATEUTIL		2			/* Locate the UTIL file */

/****** Error alert string numbers *****************************************************/
#define BADENV			1			/* Need System 6.0 or later */
#define NOOPENUTIL		2			/* Couldn't open UTIL file */
#define BADFORMAT		3			/* Bad UTIL file format */
#define NOUTILSPEC		4			/* Unable to find UTIL specification in UTIL file */
#define NOUTIL			5			/* Unable to find the UTIL */
#define NOOPENLWFU		6			/* Couldn't open LWFU for read/write */
#define BADINSTALL		7			/* Error occurred while copying resources */
#define ALREADYTHERE	8			/* There's another UTIL with the same UTIL name */

/****** Miscellaneous constants ********************************************************/
#define MINSYSTEM		0x0600		/* Minimum System we'll run under */
#define BOTTOMOFFSET	11			/* Offset from bottom of "description" dialog */
#define LWFUCREATOR		'LWFU'		/* Creator for LaserWriter Font Utility */
#define BUSYATTRIB		0x80		/* The mask to find out whether a file is busy */
#define UTILRESBASE		16000		/* Base for UTIL's resource space */
#define UTILIDBASE		128			/* Base for UTIL IDs */
#define UTILSPACESIZE	100			/* Number of IDs allocated to each UTIL */
#define RESSPACEOFFSET	2			/* Offset into UTIL resource to ResSpace */

/****** Types **************************************************************************/
typedef struct {
	ResType	type;
	short	id;
} ResSpec;
