//=======================================================================================
//
// SHDemo.h - header for SHDemo.c
//
// Written by Bryan K. Ressler (Beaker), 2/4/92
//
// Version 1.00, 2/4/92		Original version
//         1.10, 4/11/92	Integrate final Sound Helper, clean up
//
//=======================================================================================

#include "Std.h"

//=======================================================================================
// Resource IDs
//=======================================================================================
#define kErrStrs			128		// 'STR#' - Error strings
#define kStrs				129		// 'STR#' - General strings
#define kErrAlert			128		// 'ALRT' - Error alert
#define kErrExtraAlert		129		// 'ALRT' - Error "extra" alert
#define kAboutAlert			130		// 'ALRT' - About box
#define kOutaChannelsAlert	131		// 'ALRT' - A
#define kSHDialog			256		// 'DLOG' - Main dialog
#define kFillSnd			128		// 'snd ' - Drum fill
#define kHitSnd				129		// 'snd ' - Orchestra hit
#define kDanceBeat			130		// 'snd ' - Dance beat

//=======================================================================================
// Error string numbers within kErrStrs
//=======================================================================================
#define kBadEnv				1		// Need System 6.0.7 or later
#define kCantInitSH			2		// Couldn't initialize the Sound Helper
#define kPlayError			3		// General playback error
#define kRecordError		4		// General recording error
#define kCantGetChannel		5		// Couldn't get a channel for the beat box

//=======================================================================================
// Item numbers in the main dialog
//=======================================================================================
#define kQuit				1		// Quit button
#define kAbout				2		// About button
#define kFillBtn			3		// Drum fill button
#define kHitBtn				4		// Orchestra hit button
#define kBeatCheck			5		// Drum machine checkbox
#define kRecordBtn			6		// Record button
#define kPlayBtn			7		// Play button
#define kStopBtn			8		// Stop button
#define kPauseBtn			9		// Pause button
#define kProgressBar		10		// Progress bar
#define kRecPlayStatus		11		// Status statText
#define kLevelBar			12		// Level bar

#define kFirstBoxItem		14		// First BoxItem userItem
#define kNumBoxItems		3		// Number of BoxItems

//=======================================================================================
// Item numbers in the main dialog
//=======================================================================================
#define kIdleNoSound		0		// Idle, no sound has been recorded
#define kIdleSound			1		// Idle, a sound HAS been recorded
#define kRecording			2		// Recording is in progress
#define kRecordPaused		3		// Recording is in progress but is paused
#define kPlaying			4		// Playback is in progress
#define kPlayPaused			5		// Playback is in progress but is paused

//=======================================================================================
// Maximums
//=======================================================================================
#define kMaxUserRecording	110		// Maximum size of user recording (in K)
#define kMaxChannels		8		// Number of channels Helper should allocate
#define kNumRecLevelSteps	256		// Number of recording level steps (0..255)

//=======================================================================================
// Miscellaneous constants
//=======================================================================================
#define kMinSystem			0x0607	// Minimum System we'll run under
#define kFirstStateStr		1		// First string in general string list for rec states
#define kMiddleC			0x3c	// MIDI note number of keyboard middle C
