// OurMain.r
// Resources for OurMain.

#define SystemSevenOrLater	true

		// Standard types

#ifndef __TYPES.R__ 
	#include "Types.r"
#endif

#ifndef __SYSTYPES.R__
	#include "SysTypes.r"				// needed for version resource
#endif

		// Our application resource constants and types

#include "OurMainShared.h"

		// Include the PICTs drawn by our app.

include "Picts.rsrc";

//--------------------------------------------------------------------------------
// this DLOG and DITL are used as an About screen

resource 'DLOG' (rAboutDlog, "About", purgeable) {
	{40, 20, 180, 316},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	rAboutDlog,
	"About",
	centerMainScreen
};

//--------------------------------------------------------------------------------
resource 'DITL' (rAboutDlog, purgeable) {
	{	/* array DITLarray: 6 elements */
		/* [1] */
		{108, 208, 128, 278},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 8, 24, 280},
		StaticText {
			disabled,
			kProgramName
		},
		/* iAboutTitle=[3] */
		{25, 8, 40, 280},
		StaticText {
			disabled,
			""
		},
		/* [4] */
		{48, 8, 96, 280},
		StaticText {
			disabled,
			"Use me, abuse me, drag me everywhere,\n"
			"I'll still draw for you.  Brought to you\n"
			"by John Powers, develop, and Mac DTS."
		},
	}
};

//--------------------------------------------------------------------------------
/* we use an MBAR resource to conveniently load all the menus */

resource 'MBAR' (rMenuBar, preload) {
	{ mApple, mFile };		/* one menu */
};


resource 'MENU' (mApple, preload) {
	mApple,
	textMenuProc,
	0b1111111111111111111111111111101,	/* disable dashed line, enable About and DAs */
	enabled,
	apple,
	{
		"About "kProgramName"", noIcon, nokey, nomark, plain;
		"-", noIcon, nokey, nomark, plain
	}
};

resource 'MENU' (mFile, preload) {
	mFile,
	textMenuProc,
	0b1111111111111111111111111111111,
	enabled,
	"File",
	{
		"Quit", noIcon, "Q", nomark, plain;
	}
};

//--------------------------------------------------------------------------------
resource 'vers' (1, kProgramName, purgeable) {
	kVersionBytes,
	kVersionNumber,
	kVersionNumber"  "kVersionDate " "kCopyright
};

resource 'vers' (2, kProgramName, purgeable)
{
	0x01, 0x00, release, 0x00, verUS,
	"1.0",
	""
};

//--------------------------------------------------------------------------------
type kCreator as 'STR ';

resource kCreator (0) {				// Creator (or Signature)   
	kProgramName " " kVersionNumber " " kVersionDate " " kCopyright;
};

//--------------------------------------------------------------------------------
resource 'WIND' (kWindResID, "DeviceLoopInDrag", purgeable) {
	{0, 0, 180, 440},
	noGrowDocProc,
	visible,
	noGoAway,
	0x0,
	"DeviceLoopInDrag",
	centerMainScreen
};

//--------------------------------------------------------------------------------
resource 'STR#' (kUserStrID, "User Strings", purgeable) {
	{
		"This application requires System 7."
	};
};

