/*
/* Globals.h
/*
/* Author: Michael Chen, Human Interface Group / ATG
/* Copyright  1991-1993 Apple Computer, Inc.  All rights reserved.
/*
/* Part of Virtual Sphere Sample Code Release v1.1
/**/

#ifndef __GLOBALS__
#define __GLOBALS__


/*=================================================================================================
/* LightSpeed C dependencies
/*-------------------------------------------------------------------------------------------------*/
#ifdef THINK_C

/* Set flag for compiling a version using FPU or not */ 
#if __option (mc68020)
	#if __option (mc68881)
		#define	qUseFPUand020	true
	#endif
#endif

#endif THINK_C


/*=================================================================================================
/* MPW C dependencies
/*-------------------------------------------------------------------------------------------------*/
#ifdef applec

/* Set flag for compiling a version using FPU or not */ 
#ifdef	mc68020
	#ifdef mc68881
		#define	qUseFPUand020	true
	#else
		#define	qUseFPUand020	false
	#endif
#endif

#endif applec


/*=================================================================================================
/* Common stuff
/*-------------------------------------------------------------------------------------------------*/
#ifndef	qUseFPUand020
	#define	qUseFPUand020	false
#endif

#define	qDebug				false				/* Flag for compiling a debug version
										 		 * or normal version of this application */



#ifndef __MENUS__
#include <Menus.h>
#endif

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif


/* From Sample.c */
extern	SysEnvRec	gMac;						/* The environment */
extern	Boolean IsDAWindow (WindowPtr window);	/* In Sample.c */

/* Menu globals */
extern	short		gObjectDisplayed;			/* Which object is being draw currently */				
extern	short		gRenderingStyle;			/* iLineDrawing, iFlatShading, iFlatShadingWithOutline */				
extern	Boolean		gDoBackfacedPolygonRemoval;
extern	Boolean		gDoubleBuffer;
extern	Boolean		gDrawInColor;

/* Utility routines */
pascal	void		DebugMessage (Str255 message);
pascal	void		EnableDisableItem (MenuHandle theMenu, short item, Boolean enable);
pascal	void		LocalToGlobalRect (Rect *globalRect);
pascal	void		MessageAlert (Str255 message);
pascal	void		MessageAlertAndQuit (Str255 message);
pascal	short		ScreenDepth (const Rect *globalRect);


#endif __GLOBALS__