// Demo3D.r

//  Auto-Include the requirements for this source
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#ifndef __BalloonTypes__
#include "BalloonTypes.r"
#endif

#if qDebug | qPerform
include "Debug.rsrc" not 'ckid';
#endif
include "MacApp.rsrc" not 'ckid';
include "Dialog.rsrc" not 'ckid';

#ifndef __FloatWindow__
#include "FloatWindow.r"
#endif

include "Demo3D.Views";

include $$Shell("ObjApp")"Demo3D" 'CODE';

#define kSignature			'DE3D'			// Application Signature

// Resource IDs
#define c3DDrawingWind  1001
#define c3DDrawingProcWind  1002

#define kStrings 2000

#define mWindows			4		//	ID of the "Windows" menu

/* Command numbers */


resource 'res!' (256,
#if qNames
	"Demo3D's resident segments",
#endif
	purgeable) {
	{	"ARes";
		"A3DRes";
		"A3DControlRes";
	};
};

resource 'seg!' (256, purgeable) {
	{
		"ARes";
		"GNonRes";
		"GClipboard";
		"GClose";
		"GDoCommand";
		"GOpen";
		"GSelCommand";
		"BBNonRes";
		"BBOpen";
		"GNonRes2";
		"GReadResource";
		"TESelCommand";
		"SANELIB";
	}
};

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,				
	reserved,
	reserved,
	reserved,
	reserved,
#if qModelFarCode
	675 * 1024,
	625 * 1024,
#elif qDebug
	600 * 1024,
	575 * 1024
#else
	450 * 1024,
	400 * 1024
#endif
};

resource 'DITL' (phAboutApp, purgeable) {
	 {
/* [1] */	{160, 182, 180, 262}, Button { enabled, "OK" };
/* [2] */	{8, 70, 152, 316}, StaticText { disabled, 
	"3D Drawing with MacApp Demo." 
	"\n\nBy Jamie Osborne "
	"  1993 Apple Computer, Inc."};
/* [3] */	{10, 20, 42, 52}, Icon { disabled, 1 }
	}
};

resource 'MBAR' (kMBarDisplayed,
#if qNames
"kMBarDisplayed",
#endif
nonpurgeable) {
	{mApple; mFile; mEdit; mWindows} 
};


include "Defaults.rsrc"  'ALRT' (phAboutApp);	// Grab the default about box

include "Defaults.rsrc" 'CMNU' (mApple);		// Grab the default Apple menu

resource 'CMNU' (mFile,
#if qNames
"mFile",
#endif
nonpurgeable) {
	mFile,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"File",
	{
	"Close",			noIcon, "W",	noMark, plain, cClose;
	"Quit",				noIcon, "Q",	noMark, plain, cQuit
	}
};

include "Defaults.rsrc" 'CMNU' (mEdit);		// Grab the default Edit menus

resource 'CMNU' (mWindows,
#if qNames
"mWindows",
#endif
nonpurgeable) {
	mWindows,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Windows",
	 {
/* [1] */	"Show Template 3D Drawing",			noIcon, noKey, noMark, plain, c3DDrawingWind;
/* [2] */	"Show Procedural 3D Drawing",		noIcon, noKey, noMark, plain, c3DDrawingProcWind;
	}
};


include "Defaults.rsrc" 'CMNU' (mBuzzwords);	// Get the default buzzwords menu



resource 'ICN#' (128, "Demo3D Family", purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 007F 00FE 0081 0102 0080 8203"
		$"0100 8403 0100 4803 0200 5003 0200 2003"
		$"0400 0003 0400 0003 0800 0003 0800 0003"
		$"1000 0003 11FF FFE3 2100 0023 217F FFA3"
		$"4140 00A3 4140 7EA3 815B 42A3 FD54 7EAF"
		$"7D40 00AF 7D40 00AF 0140 00A0 014E 1CA0"
		$"0151 22A0 014E 1CA0 0140 00A0 017F FFA0"
		$"0100 0020 01FF FFE0",
		/* [2] */
		$"0000 0000 00FF 01FE 00FF 83FE 01FF 87FF"
		$"01FF CFFF 03FF DFFF 03FF FFFF 07FF FFFF"
		$"07FF FFFF 0FFF FFFF 0FFF FFFF 1FFF FFFF"
		$"1FFF FFFF 3FFF FFFF 3FFF FFFF 7FFF FFFF"
		$"7FFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"7FFF FFFF 7FFF FFFF 01FF FFF0 01FF FFF0"
		$"01FF FFF0 01FF FFF0 01FF FFF0 01FF FFF0"
		$"01FF FFF0 01FF FFF0 00FF FFF0"
	}
};

resource 'ics#' (128, "Demo3D Family", purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0707 0489 0851 0821 1001 1001 2FFD 2805"
		$"4BF5 4A15 EA15 6A15 0BF4 0804 0FFC",
		/* [2] */
		$"078F 0FDF 0FFF 1FFF 1FFF 3FFF 3FFF 7FFF"
		$"7FFF FFFF FFFF 7FFF 0FFE 0FFE 0FFE 07FE"
	}
};

resource 'ics4' (128, "Demo3D Family", purgeable) {
	$"0000 0666 7000 7666 0000 7677 6707 6776"
	$"0000 6777 7676 7776 0007 6777 7767 7776"
	$"0006 7777 7777 7776 0076 7777 7777 7776"
	$"0067 FFFF FFFF FF76 0767 FCCC CCCC CFD6"
	$"0677 FCFF FFFF CFD6 7677 FCF0 000F CFD6"
	$"6666 FCF0 000F CFD6 0DDD FCF0 000F CFDD"
	$"0000 FCFF FFFF CFD0 0000 FCCC CCCC CFD0"
	$"0000 FFFF FFFF FFD0 0000 0DDD DDDD DDD0"
};

resource 'ics8' (128, "Demo3D Family", purgeable) {
	$"0000 0000 00EC ECEC C000 0000 C0EC ECEC"
	$"0000 0000 C0EC C0C0 ECC0 00C0 ECC0 C0EC"
	$"0000 0000 ECC0 C0C0 C0EC C0EC C0C0 C0EC"
	$"0000 00C0 ECC0 C0C0 C0C0 ECC0 C0C0 C0EC"
	$"0000 00EC C0C0 C0C0 C0C0 C0C0 C0C0 C0EC"
	$"0000 C0EC C0C0 C0C0 C0C0 C0C0 C0C0 C0EC"
	$"0000 ECC0 FFFF FFFF FFFF FFFF FFFF C0EC"
	$"00C0 ECC0 FFF7 F7F7 F7F7 F7F7 F7FF FAEC"
	$"00EC C0C0 FFF7 FFFF FFFF FFFF F7FF FAEC"
	$"C0EC C0C0 FFF7 FF00 0000 00FF F7FF FAEC"
	$"ECEC ECEC FFF7 FF00 0000 00FF F7FF FAEC"
	$"00FA FAFA FFF7 FF00 0000 00FF F7FF FAFA"
	$"0000 0000 FFF7 FFFF FFFF FFFF F7FF FA00"
	$"0000 0000 FFF7 F7F7 F7F7 F7F7 F7FF FA00"
	$"0000 0000 FFFF FFFF FFFF FFFF FFFF FA00"
	$"0000 0000 00FA FAFA FAFA FAFA FAFA FA"
};

resource 'icl4' (128, "Demo3D Family", purgeable) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 7666 6666 0000 0007 6666 6660"
	$"0000 0000 6777 7776 7000 0076 7777 7760"
	$"0000 0007 6777 7777 6000 0767 7777 776D"
	$"0000 0006 7777 7777 6700 7677 7777 776D"
	$"0000 0076 7777 7777 7607 6777 7777 776D"
	$"0000 0067 7777 7777 7676 7777 7777 776D"
	$"0000 0767 7777 7777 7767 7777 7777 776D"
	$"0000 0677 7777 7777 7777 7777 7777 776D"
	$"0000 7677 7777 7777 7777 7777 7777 776D"
	$"0000 6777 7777 7777 7777 7777 7777 776D"
	$"0007 6777 7777 7777 7777 7777 7777 776D"
	$"0006 7777 7777 7777 7777 7777 7777 776D"
	$"0076 777F FFFF FFFF FFFF FFFF FFF7 776D"
	$"0067 777F CCCC CCCC CCCC CCCC CCFD 776D"
	$"0767 777F CFFF FFFF FFFF FFFF FCFD 776D"
	$"0677 777F CF00 0000 0000 0000 FCFD 776D"
	$"7677 777F CF06 6660 6660 0600 FCFD 776D"
	$"6777 777F CF00 0000 0000 0000 FCFD 776D"
	$"6666 666F CF00 0000 0666 6660 FCFD 666D"
	$"0DDD DDDF CF0F F0FF 0600 0060 FCFD DDDD"
	$"0DDD DDDF CF0F 0F00 0666 6660 FCFD DDDD"
	$"0000 000F CF00 0000 0000 0000 FCFD 0000"
	$"0000 000F CF00 3330 0003 3300 FCFD 0000"
	$"0000 000F CF03 0003 0030 0030 FCFD 0000"
	$"0000 000F CF00 3330 0003 3300 FCFD 0000"
	$"0000 000F CF00 0000 0000 0000 FCFD 0000"
	$"0000 000F CFFF FFFF FFFF FFFF FCFD 0000"
	$"0000 000F CCCC CCCC CCCC CCCC CCFD 0000"
	$"0000 000F FFFF FFFF FFFF FFFF FFFD 0000"
	$"0000 0000 DDDD DDDD DDDD DDDD DDDD"
};

resource 'icl8' (128, "Demo3D Family", purgeable) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 C0EC ECEC ECEC ECEC"
	$"0000 0000 0000 00C0 ECEC ECEC ECEC EC00"
	$"0000 0000 0000 0000 ECC0 C0C0 C0C0 C0EC"
	$"C000 0000 0000 C0EC C0C0 C0C0 C0C0 EC00"
	$"0000 0000 0000 00C0 ECC0 C0C0 C0C0 C0C0"
	$"EC00 0000 00C0 ECC0 C0C0 C0C0 C0C0 ECFA"
	$"0000 0000 0000 00EC C0C0 C0C0 C0C0 C0C0"
	$"ECC0 0000 C0EC C0C0 C0C0 C0C0 C0C0 ECFA"
	$"0000 0000 0000 C0EC C0C0 C0C0 C0C0 C0C0"
	$"C0EC 00C0 ECC0 C0C0 C0C0 C0C0 C0C0 ECFA"
	$"0000 0000 0000 ECC0 C0C0 C0C0 C0C0 C0C0"
	$"C0EC C0EC C0C0 C0C0 C0C0 C0C0 C0C0 ECFA"
	$"0000 0000 00C0 ECC0 C0C0 C0C0 C0C0 C0C0"
	$"C0C0 ECC0 C0C0 C0C0 C0C0 C0C0 C0C0 ECFA"
	$"0000 0000 00EC C0C0 C0C0 C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 ECFA"
	$"0000 0000 C0EC C0C0 C0C0 C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 ECFA"
	$"0000 0000 ECC0 C0C0 C0C0 C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 ECFA"
	$"0000 00C0 ECC0 C0C0 C0C0 C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 ECFA"
	$"0000 00EC C0C0 C0C0 C0C0 C0C0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 C0C0 ECFA"
	$"0000 C0EC C0C0 C0FF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFC0 C0C0 ECFA"
	$"0000 ECC0 C0C0 C0FF F7F7 F7F7 F7F7 F7F7"
	$"F7F7 F7F7 F7F7 F7F7 F7F7 FFFA C0C0 ECFA"
	$"00C0 ECC0 C0C0 C0FF F7FF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFF7 FFFA C0C0 ECFA"
	$"00EC C0C0 C0C0 C0FF F7FF 0000 0000 0000"
	$"0000 0000 0000 0000 FFF7 FFFA C0C0 ECFA"
	$"C0EC C0C0 C0C0 C0FF F7FF 00D2 D2D2 D200"
	$"D2D2 D200 00D2 0000 FFF7 FFFA C0C0 ECFA"
	$"ECC0 C0C0 C0C0 C0FF F7FF 0000 0000 0000"
	$"0000 0000 0000 0000 FFF7 FFFA C0C0 ECFA"
	$"ECEC ECEC ECEC ECFF F7FF 0000 0000 0000"
	$"00D2 D2D2 D2D2 D200 FFF7 FFFA ECEC ECFA"
	$"00FA FAFA FAFA FAFF F7FF 00FF FF00 FFFF"
	$"00D2 0000 0000 D200 FFF7 FFFA FAFA FAFA"
	$"00FA FAFA FAFA FAFF F7FF 00FF 00FF 0000"
	$"00D2 D2D2 D2D2 D200 FFF7 FFFA FAFA FAFA"
	$"0000 0000 0000 00FF F7FF 0000 0000 0000"
	$"0000 0000 0000 0000 FFF7 FFFA 0000 0000"
	$"0000 0000 0000 00FF F7FF 0000 4747 4700"
	$"0000 0047 4747 0000 FFF7 FFFA 0000 0000"
	$"0000 0000 0000 00FF F7FF 0047 0000 0047"
	$"0000 4700 0000 4700 FFF7 FFFA 0000 0000"
	$"0000 0000 0000 00FF F7FF 0000 4747 4700"
	$"0000 0047 4747 0000 FFF7 FFFA 0000 0000"
	$"0000 0000 0000 00FF F7FF 0000 0000 0000"
	$"0000 0000 0000 0000 FFF7 FFFA 0000 0000"
	$"0000 0000 0000 00FF F7FF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFF7 FFFA 0000 0000"
	$"0000 0000 0000 00FF F7F7 F7F7 F7F7 F7F7"
	$"F7F7 F7F7 F7F7 F7F7 F7F7 FFFA 0000 0000"
	$"0000 0000 0000 00FF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFA 0000 0000"
	$"0000 0000 0000 0000 FAFA FAFA FAFA FAFA"
	$"FAFA FAFA FAFA FAFA FAFA FAFA"
};

type kSignature as 'STR ';
resource kSignature (0,
#if qNames
"Signature",
#endif
	purgeable) {
	"Demo3D  Apple Computer, Inc. 1993"
};

resource 'FREF' (128,
#if qNames
"Demo3D Application",
#endif
	purgeable) {
	'APPL',
	0,
	""
};

resource 'BNDL' (128,
#if qNames
"Demo3D",
#endif
	purgeable) {
	kSignature,
	0,
		{
		'ICN#',
			{
			0, 128,
			},
		'FREF',
			{
			0, 128,
			}
		}
};

//include "Defaults.rsrc"  'STR#' (kDefaultCredits);		// Grab the default credits

// Get the default Version resources
include "Defaults.rsrc"  'vers' (1);		// Application or file specific
include "Defaults.rsrc"  'vers' (2);		// Overall package


resource 'STR#' (kStrings,
#if qNames
"Strings",
#endif
purgeable) {
	{	
		"This window was created procedurally.";
		"Click this to show a window with improper use of a gray background:";
		"Edit Text Field 1:";
	}
};
