/*
	File:		MDemo3D.cp

	Contains:	3D drawing demo program

	Written by:	Jamie Osborne

	Copyright:	 1992-1993 by Apple Computer, Inc.

*/

#ifndef __MACAPP__
#include <MacApp.h>
#endif

#ifndef __UPRINTING__
#include <UPrinting.h>
#endif

#ifndef __UGRIDVIEW__
#include <UGridView.h>
#endif

#ifndef __UTEVIEW__
#include <UTEView.h>
#endif

#ifndef __UDIALOG__
#include <UDialog.h>
#endif

#ifndef __UDEMO3D__
#include <UDemo3D.h>
#endif

#ifndef __UGEOMETRY__
#include <UGeometry.h>
#endif

#ifndef __UFLOATWINDOW__
#include <UFloatWindow.h>
#endif

#include "U3DDrawing.h"

//----------------------------------------------------------------------------------------
// main: 
//----------------------------------------------------------------------------------------
#pragma push
#pragma processor 68000

void main()
{
	TTestApplication *gTestApplication;

	InitToolBox();

	if (ValidateConfiguration(gConfiguration))
	{
		InitUMacApp(12);							// Initialize MacApp; 12 calls to MoreMasters

		InitUTEView();
		InitUDialog();
		InitUGridView();
		InitUFloatWindow();
		InitU3DDrawing();							// Add 3-d drawing unit
		gTestApplication = new TTestApplication;
		gTestApplication->ITestApplication();
		gTestApplication->Run();
	}
	else
		StdAlert(phUnsupportedConfiguration);
} // main

#pragma pop
