/*
	File:		MoePrivate.h

	Contains:	Private header file for Moe component routines.

				Refer to develop Issue 15, "Managing Component Registration",
				for details on this code.

	Written by:	Gary Woodcock

	Copyright:	 1993 by Apple Computer, Inc.

	Change History (most recent first):

*/

//-----------------------------------------------------------------------
// Includes

#ifndef	_MOEPRIVATE_
#define	_MOEPRIVATE_

#include "CompileFlags.h"

#include <Components.h>

//-----------------------------------------------------------------------
// Private constants

// Base resource ID
enum
{
	kMoeBaseResID = 200
};

// Maximum number of instances that can be opened
enum
{
	kMaxMoeInstances = 1
};

// Component and interface revision levels
enum
{
	moeInterfaceRev = 0x00010001	
};

//-----------------------------------------------------------------------
// Private types

typedef	struct MoePrivateGlobals
{
	Component	self;	// Component ID
}
MoePrivateGlobals, *MoePrivateGlobalsPtr, **MoePrivateGlobalsHdl;

//-----------------------------------------------------------------------
// Private prototypes

#ifdef BUILD_LINKED

// Only need this prototype if we're running linked (for debugging)
pascal ComponentResult
MoeDispatcher (ComponentParameters *params, Handle storage);
										 
#endif BUILD_LINKED
											 
pascal ComponentResult
_MoeOpen (Handle storage, ComponentInstance self);
	
pascal ComponentResult
_MoeClose (Handle storage, ComponentInstance self);

pascal ComponentResult
_MoeCanDo (short selector);

pascal ComponentResult
_MoeVersion (void);

pascal ComponentResult
_MoeRegister (void);

#ifdef THINK_C
#ifdef BUILD_LINKED

Component
RegisterMoe (void);

#endif BUILD_LINKED
#endif THINK_C

//-----------------------------------------------------------------------

#endif _MOEPRIVATE_

//-----------------------------------------------------------------------
