/* graphics libraries:
  debug library routines
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.  */


#include <Types.h>
#include "graphics debugging.h"
#include "graphics libraries.h"


/*** The spaces below allow this file to be
compared in its engineering version
side by side with the file
graphics errors.h, to ensure
that the two files are kept in sync. 
These extra spaces may be removed
for the shipping version. */











static char *errorText[] =
{
  "out of memory",
  "internal fatal error",
  "no outline gxFont found",
  "not enough memory for graphics client gxHeap",
  "could not create backing store",
  
  nil,
  "internal error",
  "internal gxFont error",
  "internal layout error",
  "functionality unimplemented",
  "clip to frame gxShape unimplemented",
  
  

  "null gxFont scaler context",
  "null gxFont scaler input",
  "invalid gxFont scaler context",
  "invalid gxFont scaler input",
  "invalid gxFont scaler gxFont data",
  "gxFont scaler newblock failed",
  "gxFont scaler gxBitmap allocation failed",
  "gxFont scaler outline allocation failed",
  "required gxFont scaler table missing",
  "unsupported gxFont scaler outline format",
  "unsupported gxFont scaler stream format",
  "unsupported gxFont scaler gxFont format",
  "gxFont scaler hinting error",
  "gxFont scaler rasterizer error",
  "gxFont scaler internal error",
  "gxFont scaler invalid matrix",
  "gxFont scaler fixed overflow",
  "gxFont scaler api version mismatch",
  
  "unknown gxFont scaler error",
  
  
  "illegal gxFont storage type",
  "illegal gxFont storage reference",
  "illegal gxFont attributes",
  "illegal gxFont parameter",
  "gxFont cannot be changed",
  
  
  "fragmented memory",
  "could not dispose backing store",
  "unflattening interrupted by client",
  
  nil,
  "parameter is nil",
  "gxShape is nil",
  "gxStyle is nil",
  "gxTransform is nil",
  "gxInk is nil",
  "gxTransferMode is nil",
  "gxColor is nil",
  "gxColorProfile is nil",
  "gxColorSet is nil",
  "spoolProcedure is nil",
  "gxTag is nil",
  "type is nil",
  "gxMapping is nil",
  
  "parameter out of range",
  "inconsistent parameters",
  "index is less than zero",
  "index is less than one",
  "count is less than zero",
  "count is less than one",
  "contour is less than zero",
  "length is less than zero",
  
  "invalid client reference",
  "invalid graphics gxHeap start pointer",
  "invalid nongraphic globals pointer",
  
  "gxColorSpace out of range",
  
  "pattern lattice out of range",
  "frequency parameter out of range",
  "tinting parameter out of range",
  "method parameter out of range",
  "space may not be indexed",
  
  "glyph index too small",
  "no glyphs added to gxFont",
  "glyph not added to gxFont",
  "gxPoint does not intersect gxBitmap",
  
  "required gxFont table not present",
  "unknown gxFont table format",
  
  "gxShapeFill not allowed",
  "gxInverseFill face must set gxClipLayer flag",
  "invalid gxTransferMode gxColorSpace",
  "gxColorProfile must be nil",
  "gxBitmap pixel size must be 1",
  "empty gxShape not allowed",
  "gxIgnorePlatformShape not allowed",
  "nil gxStyle in glyph not allowed",
  "complex glyph gxStyle not allowed",
  
  "cannot set item shapes to nil",
  "cannot use original item shapes when growing picture",
  "cannot add unspecified new glyphs",
  "cannot dispose locked gxTag",
  "cannot dispose locked gxShape",
  
  "graphic type does not have a structure",
  "gxStyle run array does not match number of characters",
  "rectangles cannot be inserted into",
  
  "unknown graphics gxHeap",
  "graphics routine selector is obsolete",
  "cannot set graphics client memory without setting size",
  "graphics client memory too small",
  "graphics client memory is already allocated",
  
  "gxViewPort is a window",
  
  
  "illegal type for gxShape",
  "invalid gxViewDevice reference",
  "invalid gxViewGroup reference",
  "invalid gxViewPort reference",
  
  
  "no owners",
  "bad address",
  "object wrong type",
  "gxShape wrong type",
  "gxStyle wrong type",
  "gxInk wrong type",
  "gxTransform wrong type",
  "device wrong type",
  "port wrong type",
  
  
  "gxShape cache wrong type",
  "gxStyle cache wrong type",
  "gxInk cache wrong type",
  "gxTransform cache wrong type",
  "port cache wrong type",
  "gxShape cache parent mismatch",
  "gxStyle cache parent mismatch",
  "gxInk cache parent mismatch",
  "gxTransform cache parent mismatch",
  "port cache parent mismatch",
  "invalid gxShape cache port",
  "invalid gxShape cache device",
  "invalid gxInk cache port",
  "invalid gxInk cache device",
  "invalid gxStyle cache port",
  "invalid gxStyle cache device",
  "invalid gxTransform cache port",
  "invalid gxTransform cache device",
  
  "indirect memory block too small",
  "indirect memory block too large",
  "unexpected nil pointer",
  "invalid pointer",
  "invalid seed",
  "invalid frame seed",
  "invalid text seed",
  "invalid draw seed",
  "bad private flags",
  "text bounds cache wrong size",
  "text metrics cache wrong size",
  "text index cache wrong size",
  "gxBitmap ptr too small",
  "gxBitmap ptr not aligned",
  "gxBitmap rowBytes negative",
  "gxBitmap width negative",
  "gxBitmap height negative",
  "invalid pixelSize",
  "gxBitmap rowBytes too small",
  "gxBitmap rowBytes not aligned",
  "gxBitmap rowBytes must be specified for user image buffer",
  "invalid matrix flag",
  "invalid vector count",
  "invalid contour count",
  "recursive caches",
  "glyph run count negative",
  "glyph run count zero",
  "glyph run counts do not sum to character count",
  "glyph first advance bit set not allowed",
  "glyph tangent vectors both zero",
  "layout run length negative",
  "layout run length zero",
  "layout run level negative",
  "layout run lengths do not sum to text length",
  "invalid fillShape ownerCount",
  "recursive fillShapes",
  "bad gxShape in picture",
  "bad gxStyle in picture",
  "bad gxInk in picture",
  "bad gxTransform in picture",
  "bad gxShape cache in picture",
  "bad seed in picture",
  "invalid picture count",
  "bad textLayer count",
  "bad fillType in gxTextFace",
  "bad gxStyle in gxTextFace",
  "bad gxTransform in gxTextFace",
  "gxTransform clip missing",
  "metrics wrong type",
  "metrics gxPoint size probably bad",
  "scalar block wrong type",
  "scalar block parent mismatch",
  "scalar block too small",
  "scalar block too large",
  "invalid metrics range",
  "invalid metrics flags",
  "metrics maxWidth probably bad",
  "gxFont wrong type",
  "gxFont wrong size",
  "invalid gxFont platform",
  "invalid lookup range",
  "invalid lookup platform",
  "gxFont not in gxFont list",
  "metrics not in metrics list",
  "bad device private flags",
  "bad device attributes",
  "invalid device number",
  "invalid device gxViewGroup",
  "invalid device bounds",
  "invalid gxBitmap in device",
  "gxColorSet wrong type",
  "invalid gxColorSet gxViewDevice owners",
  "invalid gxColorSet gxColorSpace",
  "invalid gxColorSet count",
  "gxColorProfile wrong type",
  "invalid gxColorProfile flags",
  "invalid gxColorProfile response count",
  "backing free parent mismatch",
  "backing store parent mismatch",
  
  nil,
  "number of contours exceeds implementation limit",
  "number of points exceeds implementation limit",
  "size of gxPolygon exceeds implementation limit",
  "size of gxPath exceeds implementation limit",
  "size of text exceeds implementation limit",
  "size of gxBitmap exceeds implementation limit",
  "number of colors exceeds implementation limit",
  
  
  
  
  nil,
  "common colors not initialized",
  "no open picture",
  "picture already open",
  "no open poly",
  "poly already open",
  "no open region",
  "region already open",
  "no active picture"
};
  
  
  
static char *warningText[] =
{
  "warning stack underflow",
  "warning stack overflow",
  "notice stack underflow",
  "notice stack overflow",
  
  nil,
  "gxShape does not contain text",
  "gxShape does not contain a gxBitmap",
  "picture expected",
  "gxBitmap is not resizable",
  "gxShape operator may not be a gxBitmap",
  "gxShape operator may not be a picture",
  "graphic type does not contain points",
  "graphic type does not have multiple contours",
  "graphic type cannot be mapped",
  "graphic type cannot be moved",
  "graphic type cannot be scaled",
  "graphic type cannot be rotated",
  "graphic type cannot be skewed",
  "graphic type cannot be reset",
  "graphic type cannot be dashed",
  "graphic type cannot be reduced",
  "graphic type cannot be inset",
  "gxShape cannot be inverted",
  
  nil,
  "map gxShape out of range",
  "move gxShape out of range",
  "scale gxShape out of range",
  "rotate gxShape out of range",
  "skew gxShape out of range",
  "map gxTransform out of range",
  "move gxTransform out of range",
  "scale gxTransform out of range",
  "rotate gxTransform out of range",
  "skew gxTransform out of range",
  
  nil,
  "contour out of range",
  "index out of range in contour",
  "picture index out of range",
  "gxColor index requested not found",
  "gxColorSet index out of range",
  "index out of range",
  "count out of range",
  "length out of range",
  "gxFont table index out of range",
  "gxFont glyph index out of range",
  "gxFont table not found",
  "gxFont name not found",
  
  
  
  "gxShape access not allowed",
  "gxColorSet access restricted",
  "gxColorProfile access restricted",
  "gxTag access restricted",
  "gxViewDevice access restricted",
  
  
  "new gxShape contains invalid data",
  "new gxTag contains invalid data",
  "extra data passed was ignored",
  
  
  "unable to traverse open contour that starts or ends off th",
  "unable to draw open contour that starts or ends off the cu",
  "picture cannot contain itself",
  "gxViewPort cannot contain itself",
  "cannot dispose default gxShape",
  "cannot dispose default gxStyle",
  "cannot dispose default gxInk",
  "cannot dispose default gxTransform",
  "cannot dispose default gxColorProfile",
  "cannot dispose default gxColorSet",
  "cannot set unique items attribute for a picture that alrea",
  "gxShape not locked",
  "gxTag not locked",
  "gxShape direct attribute not set",
  "first glyph advance must be absolute",
  
  
  "gxShape does not have area",
  "gxShape does not have length",
  "gxPoint does not intersect port",
  "cannot dispose non gxFont",
  
  
  "character substitution took place",
  "gxFont substitution took place",
  "union of area and length returns area only",
  "insufficient coordinate space for new device",
  
  
  "unrecognized stream version",
  "bad data in stream",
  
  
  "gxFont scaler no output",
  "gxFont scaler fake metrics",
  "gxFont scaler fake linespacing",
  "gxFont scaler glyph substitution",
  
  
  "gxShape passed has no bounds",
  "layer gxStyle cannot contain a face",
  "layer glyph gxShape cannot contain nil styles",
  "face override gxStyle gxFont must match gxStyle",
  "tags of type flst removed",



  nil,
  "no picture drawn",
  "gxPolygons have different size contours",
  "graphic type cannot be specifed by four values",
  "graphic type cannot be specifed by six values",
  "gxPoint expected",
  "gxLine or gxRectangle expected",
  "gxCurve expected",
  "graphic type does not contain control bits",
  "request exceeds available data",
  "extra data unread",
  "no variable length user data saved"
};



static char *noticeText[] =
{
  "parameters have no effect",
  "attributes already set",
  "caps already set",
  "gxColor already set",
  "gxCurve error already set",
  "dash already set",
  "default gxColorProfile already set",
  "default gxInk already set",
  "default gxTransform already set",
  "default gxShape already set",
  "default gxStyle already set",
  "device clip already set",
  "dither already set",
  "end cap already set",
  "glyph positions are already set",
  "gxHalftone already set",
  "gxInk already set",
  "join type already set",
  "justification already set",
  "gxMapping already set",
  "pattern already set",
  "pen size already set",
  "port clip already set",
  "gxShape geometry unaffected",
  "gxShape type already set",
  "start cap already set",
  "gxStyle already set",
  "gxTag already set",
  "tags in gxShape ignored",
  "gxTransform already set",
  "gxTransform clip already set",
  "gxTransform gxMapping unaffected",
  "gxViewPort already in gxViewGroup",
  "gxViewDevice already in gxViewGroup",
  
  "gxShape already in primitive form",
  "gxShape already in simple form",
  "gxShape already broken",
  "gxShape already joined",
  "cache already cleared",
  
  "gxShape not disposed",
  "gxStyle not disposed",
  "gxInk not disposed",
  "gxTransform not disposed",
  "gxColorSet not disposed",
  "gxColorProfile not disposed",
  "gxFont not disposed",
  
  "glyph tangents have no effect",
  "glyph positions determined by advance",
  "gxTransform viewPorts already set",
  
  "gxDirectShape attribute set as side effect",
  "lockShape called as side effect",
  
  "disposed dead caches",
  "disposed live caches",
  "low on memory",
  "very low on memory",
  
  "gxTransform references disposed gxViewPort",
  
  
  
  
  "zero length string passed"
};

  #define errorTextSize (sizeof(errorText)/sizeof(*errorText))
  #define warningTextSize (sizeof(warningText)/sizeof(*warningText))
  #define noticeTextSize  (sizeof(noticeText)/sizeof(*noticeText))

typedef struct {
  char    (*errorMessages)[];
  char    (*warningMessages)[];
  char    (*noticeMessages)[];
  char    *fatalErrorMessage;
  char    *errorMessage;
  char    *validationMessage;
  char    *warningMessage;
  char    *noticeMessage;
  char    *undefinedMessage;
} debugLibraryGlobals;

static debugLibraryGlobals messages = { errorText,
                warningText, 
                noticeText,
                "FATAL GRAPHICS ERROR: ",
                "GRAPHICS ERROR: ",
                "VALIDATION ERROR: ",
                "GRAPHICS WARNING: ",
                "GRAPHICS NOTICE: ",
                "ID = $xxxx (undefined)" };
#define undefinedHexOffset 6  /* offset to "xxxx" above */

void SetGraphicsLibraryErrors(void)
{
  GXSetUserGraphicsWarning(DisplayGraphicsWarningMessage, (long)&messages);
  GXSetUserGraphicsError(DisplayGraphicsErrorMessage, (long)&messages);
}

void SetGraphicsLibraryNotices(void)
{
  GXSetUserGraphicsNotice(DisplayGraphicsNoticeMessage, (long)&messages);
}

static char *LookupMessage(char (*table)[], short size, short range, short IDwithinRange)
{
  register char **message = table;

  while (range--) {
    while (*message++)
      if (message-(char **) table > size)
        return nil;
  }
  while (IDwithinRange--)
    if (!*++message)
      return nil;
  return *message;
}

static char *InnerGraphicsErrorMessage(gxGraphicsError errorID, debugLibraryGlobals *messageTables)
{
  if (errorID >= gxFirstAppWarning)
    return nil;
  else if (errorID >= gxFirstLibraryError)
    return LookupMessage(messageTables->errorMessages, errorTextSize, 4, errorID - gxFirstLibraryError);
  else if (errorID >= gxFirstImplementationLimitError)
    return LookupMessage(messageTables->errorMessages, errorTextSize, 3, errorID - gxFirstImplementationLimitError);
  else if (errorID >= gxFirstParameterError)
    return LookupMessage(messageTables->errorMessages, errorTextSize, 2, errorID - gxFirstParameterError);
  else if (errorID >= gxFirstNonfatalError)
    return LookupMessage(messageTables->errorMessages, errorTextSize, 1, errorID - gxFirstNonfatalError);
  else if (errorID >= gxFirstErrorNumber)
    return LookupMessage(messageTables->errorMessages, errorTextSize, 0, errorID - gxFirstErrorNumber);
  else
    return nil;
}

char *GraphicsErrorMessage(gxGraphicsError errorID)
{
  return InnerGraphicsErrorMessage(errorID, &messages);
}

static char *InnerGraphicsWarningMessage(gxGraphicsWarning warningID, debugLibraryGlobals *messageTables)
{
  if (warningID >= gxFirstAppWarning)
    return nil;
  else if (warningID >= gxFirstLibraryWarning)
    return LookupMessage(messageTables->warningMessages, warningTextSize, 4, warningID - gxFirstLibraryWarning);
  else if (warningID >= gxFirstParameterOutOfRangeWarning)
    return LookupMessage(messageTables->warningMessages, warningTextSize, 3, warningID - gxFirstParameterOutOfRangeWarning);
  else if (warningID >= gxFirstResultOutOfRangeWarning)
    return LookupMessage(messageTables->warningMessages, warningTextSize, 2, warningID - gxFirstResultOutOfRangeWarning);
  else if (warningID >= gxFirstWrongTypeWarning)
    return LookupMessage(messageTables->warningMessages, warningTextSize, 1, warningID - gxFirstWrongTypeWarning);
  else if (warningID >= gxFirstWarningNumber)
    return LookupMessage(messageTables->warningMessages, warningTextSize, 0, warningID - gxFirstWarningNumber);
  else
    return nil;
}

char *GraphicsWarningMessage(gxGraphicsWarning warningID)
{
  return InnerGraphicsWarningMessage(warningID, &messages);
}

static char *InnerGraphicsNoticeMessage(gxGraphicsNotice noticeID, debugLibraryGlobals *messageTables)
{
  if (noticeID >= gxFirstAppNotice)
    return nil;
  else if (noticeID >= gxFirstLibraryNotice)
    return LookupMessage(messageTables->noticeMessages, noticeTextSize, 1, noticeID - gxFirstLibraryNotice);
  else if (noticeID >= gxFirstNoticeNumber)
    return LookupMessage(messageTables->noticeMessages, noticeTextSize, 0, noticeID - gxFirstNoticeNumber);
  else
    return nil;
}

char *GraphicsNoticeMessage(gxGraphicsNotice noticeID)
{
  return InnerGraphicsNoticeMessage(noticeID, &messages);
}

static char *HexToAscii(register long value, char *str, register short digits)
{
  register char *end = str + digits;
  register char *p = end;

  while (--digits >= 0) {
    register char nibble = '0' + (value & 0x0F);
    if (nibble > '9') nibble += 'A' - '9' - 1;
    *--p = nibble;
    value >>= 4;
  }
  return end;
}

static void DisplayMessage(char *signalClass, long id, char *signalText, debugLibraryGlobals *messageTables)
{
  char debugString[255];
  register char *dst = debugString + 1;
  register char *src;
  char *hexPosition;

  src = signalClass;
  while (*dst++ = *src++) ;
  --dst;

  src = signalText;
  if (src == nil) {
    src = messageTables->undefinedMessage;
    hexPosition = dst + undefinedHexOffset;
  }
  while (*dst++ = *src++) ;
  *--dst = '.';
  if (signalText == nil)
    HexToAscii((unsigned long) id, hexPosition, 4);

  debugString[0] = dst - debugString;
  DebugStr((void *) debugString);
}

void DisplayGraphicsErrorMessage(gxGraphicsError errorID, long context)
{
  char buffer[255];
  long thing;
  long argNum;
  debugLibraryGlobals *messageTables = (debugLibraryGlobals *)context;
  
  if (errorID == fragmented_memory)
    return;
  if (GXGetValidationError(nil, (void **)&thing, &argNum)) {
    char *walker = buffer;
    char *copy = messageTables->validationMessage;
    
    while (*walker = *copy++)
      ++walker;
    GXGetValidationError(walker, nil, nil);
    while (*walker)
      ++walker;
    *walker++ = '(';
    *walker++ = '0';
    *walker++ = 'x';
    HexToAscii(thing, walker, 8);
    walker += 8;
    *walker++ = ')';
    *walker++ = ' ';
    *walker = 0;
    DisplayMessage(buffer, errorID, InnerGraphicsErrorMessage(errorID, messageTables),
          messageTables);
  } else
    DisplayMessage((errorID >= gxFirstFatalError && errorID <= gxLastFatalError) ? 
      messageTables->fatalErrorMessage : messageTables->errorMessage,
      errorID, InnerGraphicsErrorMessage(errorID, messageTables), messageTables);
}

void DisplayGraphicsWarningMessage(gxGraphicsWarning warningID, long context)
{
  debugLibraryGlobals *messageTables = (debugLibraryGlobals *)context;

  DisplayMessage(messageTables->warningMessage, warningID,
        InnerGraphicsWarningMessage(warningID, messageTables), messageTables);
}

void DisplayGraphicsNoticeMessage(gxGraphicsNotice noticeID, long context)
{
  debugLibraryGlobals *messageTables = (debugLibraryGlobals *)context;

  DisplayMessage(messageTables->noticeMessage, noticeID,
    InnerGraphicsNoticeMessage(noticeID, messageTables), messageTables);
}
