/* ------------------------------------------------------------------------------

FILENAME
  PrintingLibraries.h

DESCRIPTION
    This file defines interfaces to the Printing libraries.
  
COPYRIGHT
    Apple Computer, Inc. 1990-1993
   All rights reserved. 
  
-------------------------------------------------------------------------------- */

#ifndef __PRINTINGMANAGER__
  #include <PrintingManager.h>
#endif


// collection utilities


OSErr GetCollectionItemCategory (Collection,
                        CollectionTag,
                      long tagID,
                      gxCollectionCategory *);

OSErr SetCollectionItemCategory (Collection,
                        CollectionTag,
                      long tagID,
                      gxCollectionCategory);

OSErr RemoveCollectionCategory (Collection,
                      gxCollectionCategory);

void GetCollectionItemLock (Collection,
                   CollectionTag,
                   long tagID,
                   Boolean *isLocked);

OSErr SetCollectionItemLock (Collection,
                    CollectionTag,
                    long tagID,
                    Boolean lockIt);

OSErr AddJobItem (gxJob, CollectionTag, long id, long itemSize, void *itemData);
OSErr AddFormatItem (gxFormat, CollectionTag, long id, long itemSize, void *itemData);
OSErr AddVolatileJobItem (gxJob, CollectionTag, long id, long itemSize, void *itemData);
OSErr AddVolatileFormatItem (gxFormat, CollectionTag, long id, long itemSize, void *itemData);
                  

// papertype utilities


long GetPaperTypeBaseType (gxPaperType thePaperType);

void SetPaperTypeBaseType (gxPaperType thePaperType, long theBasePaperType);

OSType GetPaperTypeCreator(gxPaperType  thePaperType);

void SetPaperTypeCreator (gxPaperType thePaperType, OSType theCreator);

unsigned char GetPaperTypeUnits (gxPaperType thePaperType);

void SetPaperTypeUnits (gxPaperType thePaperType, unsigned char theUnits);

unsigned long GetPaperTypeFlags (gxPaperType thePaperType);

void SetPaperTypeFlags (gxPaperType thePaperType, unsigned long theFlags);

void GetPaperTypeComment (gxPaperType thePaperType, Str255 theComment);

OSErr SetPaperTypeComment (gxPaperType  thePaperType, Str255 theComment);

void LockFormatPaperType (gxFormat, Boolean lockPaperType);


// job format mode utilities


PositionConstraintTableHdl GetJobFormatLineConstraint(gxJob, PositionConstraintTableHdl);

FontTableHdl GetJobFormatFonts(gxJob, FontTableHdl);

StyleNameTableHdl GetJobFormatFontCommonStyles(gxJob, gxFont, StyleNameTableHdl);

PositionConstraintTableHdl GetJobFormatFontConstraint(gxJob, gxFont, PositionConstraintTableHdl);

gxStyle SetStyleJobFormatCommonStyle(gxJob, Str255, gxStyle);


