/* graphics libraries:
  Perspective gxMapping generation routines
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.  */

#pragma once
#ifndef cameraLibraryIncludes
#define cameraLibraryIncludes
typedef struct
{ fixed x;
  fixed y;
  fixed z;
} point3D;

typedef struct
{ fract x;
  fract y;
  fract z;
} unit3D;

typedef struct
{ point3D location;
  point3D axis;
  point3D zenith;
  point3D observer;
  gxMapping orientation;
} camera;

typedef struct
{ point3D u;
  point3D v;
  point3D origin;
} patch;

void InitCamera(camera *);
void UpdateCamera(camera *);
void PatchToCameraMap(patch *, camera *, gxMapping *);
fixed Unitize(point3D *, unit3D *);
fract FracDot(unit3D *, unit3D *);
void FracCross(unit3D *, unit3D *, unit3D *cross);

#endif
