/* graphics:
  gxFont routines
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.
*/

#ifndef gxFontRoutinesIncludes
#define gxFontRoutinesIncludes

  #ifndef gxMathTypesIncludes
    #include "math types.h"
  #endif

  #ifndef gxFontTypesIncludes
    #include "font types.h"
  #endif


  #ifdef appleInternal
    #define GXInlineCode(x)
  #endif
  #ifndef GXInlineCode
    #define GXInlineCode(x) = {0x303C, x, 0xA832}
  #endif
  
  #ifdef __cplusplus
  extern "C" {
  #endif

  gxFont GXNewFont(gxFontStorageTag storage, gxFontStorageReference reference, gxFontAttribute attributes) GXInlineCode(0x11D0);
  gxFontStorageTag GXGetFont(gxFont fontID, gxFontStorageReference *reference, gxFontAttribute *attributes) GXInlineCode(0x11D1);
  gxFont GXFindFont(gxFontStorageTag storage, gxFontStorageReference reference, gxFontAttribute* attributes) GXInlineCode(0x124C);
  void GXSetFont(gxFont fontID, gxFontStorageTag storage, gxFontStorageReference reference, gxFontAttribute attributes) GXInlineCode(0x11D2);
  void GXDisposeFont(gxFont fontID) GXInlineCode(0x11D3);
  void GXChangedFont(gxFont fontID) GXInlineCode(0x11D4);

  gxFontFormatTag GXGetFontFormat(gxFont fontID) GXInlineCode(0x1245);
  gxFont GXGetDefaultFont(void) GXInlineCode(0x11D5);
  gxFont GXSetDefaultFont(gxFont fontID) GXInlineCode(0x11D6);
  long GXFindFonts(gxFont familyID, gxFontName name, gxFontPlatform platform, gxFontScript script, gxFontLanguage language,
    long length, const unsigned char text[], long index, long count, gxFont fonts[]) GXInlineCode(0x11D7);
  long GXCountFontGlyphs(gxFont fontID) GXInlineCode(0x11E3);

  long GXCountFontTables(gxFont fontID) GXInlineCode(0x11D9);
  long GXGetFontTable(gxFont fontID, long index, void* tableData, gxFontTableTag* tableTag) GXInlineCode(0x11DA);
  long GXFindFontTable(gxFont fontID, gxFontTableTag tableTag, void* tableData, long* index) GXInlineCode(0x11DB);
  long GXGetFontTableParts(gxFont fontID, long index, long offset, long length, void* tableData, gxFontTableTag* tableTag) GXInlineCode(0x11DC);
  long GXFindFontTableParts(gxFont fontID, gxFontTableTag tableTag, long offset, long length, void* tableData, long* index) GXInlineCode(0x11DD);
  long GXSetFontTable(gxFont fontID, long index, gxFontTableTag tableTag, long length, const void* tableData) GXInlineCode(0x11E6);
  long GXSetFontTableParts(gxFont fontID, long index, gxFontTableTag tableTag, long offset, long oldLength, long newLength, const void* tableData) GXInlineCode(0x11E7);
  long GXDeleteFontTable(gxFont fontID, long index, gxFontTableTag tableTag) GXInlineCode(0x11E8);

  long GXCountFontNames(gxFont fontID) GXInlineCode(0x11DE);
  long GXGetFontName(gxFont fontID, long index, gxFontName *name, gxFontPlatform *platform,
    gxFontScript *script, gxFontLanguage *language, unsigned char text[]) GXInlineCode(0x120E);
  long GXFindFontName(gxFont fontID, gxFontName name, gxFontPlatform platform,
    gxFontScript script, gxFontLanguage language, unsigned char text[], long *index) GXInlineCode(0x11DF);
  long GXSetFontName(gxFont fontID, gxFontName name, gxFontPlatform platform, gxFontScript script, gxFontLanguage language,
    long length, const unsigned char text[]) GXInlineCode(0x11E9);
  long GXDeleteFontName(gxFont fontID, long index, gxFontName name, gxFontPlatform platform, gxFontScript script,
    gxFontLanguage language) GXInlineCode(0x11EA);
  gxFontName GXNewFontNameID(gxFont fontID) GXInlineCode(0x126D);

  long GXCountFontEncodings(gxFont fontID) GXInlineCode(0x11E0);
  gxFontPlatform GXGetFontEncoding(gxFont fontID, long index, gxFontScript *script, gxFontLanguage* language) GXInlineCode(0x11E1);
  long GXFindFontEncoding(gxFont fontID, gxFontPlatform platform, gxFontScript script, gxFontLanguage language) GXInlineCode(0x120F);
  long GXApplyFontEncoding(gxFont fontID, long index, long* length, const unsigned char text[],
    long count, unsigned short glyphs[], char was16Bit[]) GXInlineCode(0x11E2);

  long GXCountFontVariations(gxFont) GXInlineCode(0x1210);
  long GXFindFontVariation(gxFont, gxFontTableTag variationTag, fixed* minValue, fixed* defaultValue, fixed* maxValue, gxFontName* name) GXInlineCode(0x1211);
  gxFontTableTag GXGetFontVariation(gxFont, long index, fixed* minValue, fixed* defaultValue, fixed* maxValue, gxFontName* name) GXInlineCode(0x1212);

  long GXCountFontInstances(gxFont) GXInlineCode(0x1213);
  gxFontName GXGetFontInstance(gxFont, long index, gxFontVariation variation[]) GXInlineCode(0x1214);
  long GXSetFontInstance(gxFont fontID, long index, gxFontName name, const gxFontVariation variation[]) GXInlineCode(0x1215);
  long GXDeleteFontInstance(gxFont fontID, long index, gxFontName name) GXInlineCode(0x1216);

  long GXCountFontDescriptors(gxFont fontID) GXInlineCode(0x121E);
  gxFontTableTag GXGetFontDescriptor(gxFont fontID, long index, fixed* descriptorValue) GXInlineCode(0x121F);
  long GXFindFontDescriptor(gxFont fontID, gxFontTableTag descriptorTag, fixed* descriptorValue) GXInlineCode(0x1220);
  long GXSetFontDescriptor(gxFont fontID, long index, gxFontTableTag descriptorTag, fixed descriptorValue) GXInlineCode(0x1221);
  long GXDeleteFontDescriptor(gxFont fontID, long index, gxFontTableTag descriptorTag) GXInlineCode(0x1222);

  long GXCountFontFeatures(gxFont fontID) GXInlineCode(0x124F);
  gxFontName GXGetFontFeature(gxFont fontID, long index, gxFontFeatureFlag* flags, long* settingCount, gxFontFeatureSetting settings[], gxFontFeature* feature) GXInlineCode(0x1250);
  gxFontName GXFindFontFeature(gxFont fontID, gxFontFeature feature, gxFontFeatureFlag* flags, long* settingCount, gxFontFeatureSetting settings[], long* index) GXInlineCode(0x1251);
  long GXCountFontFeatureSets(gxFont fontID) GXInlineCode(0x1252);
  gxFontName GXGetFontFeatureSet(gxFont fontID, long index, long* runCount, gxFontRunFeature runs[], gxFontFeatureSetGroup* group, gxFontFeatureSetFlag* flags) GXInlineCode(0x1253);
  long GXSetFontFeatureSet(gxFont fontID, long index, gxFontName name, long runCount, const gxFontRunFeature runs[], gxFontFeatureSetGroup group, gxFontFeatureSetFlag flags) GXInlineCode(0x1254);
  long GXDeleteFontFeatureSet(gxFont fontID, long index, gxFontName name) GXInlineCode(0x1255);

  void GXFlattenFont(gxFont source, struct gxScalerStream* stream, struct gxSpoolBlock* block) GXInlineCode(0x124D);

  #ifdef __cplusplus
  }
  #endif

  #undef GXInlineCode


#endif
