/* graphics:
  gxFont types
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.
*/

#ifndef gxFontTypesIncludes
#define gxFontTypesIncludes

#ifndef gxMathTypesIncludes
  #include "math types.h"
#endif

typedef struct gxPrivateFontRecord *gxFont;

typedef enum {
  gxGlyphPlatform = -1,
  gxNoPlatform,
  gxUnicodePlatform,
  gxMacintoshPlatform,
  gxIsoPlatform
} gxFontPlatforms;

typedef long gxFontPlatform;

typedef enum {
  gxNoScript,
  gxRomanScript,
  gxJapaneseScript,
  gxTraditionalChineseScript,
  gxChineseScript = gxTraditionalChineseScript,
  gxKoreanScript,
  gxArabicScript,
  gxHebrewScript,
  gxGreekScript,
  gxCyrillicScript,
  gxRussian = gxCyrillicScript,
  gxRSymbolScript,
  gxDevanagariScript,
  gxGurmukhiScript,
  gxGujaratiScript,
  gxOriyaScript,
  gxBengaliScript,
  gxTamilScript,
  gxTeluguScript,
  gxKannadaScript,
  gxMalayalamScript,
  gxSinhaleseScript,
  gxBurmeseScript,
  gxKhmerScript,
  gxThaiScript,
  gxLaotianScript,
  gxGeorgianScript,
  gxArmenianScript,
  gxSimpleChineseScript,
  gxTibetanScript,
  gxMongolianScript,
  gxGeezScript,
  gxEthiopicScript = gxGeezScript,
  gxAmharicScript = gxGeezScript,
  gxSlavicScript,
  gxEastEuropeanRomanScript = gxSlavicScript,
  gxVietnameseScript,
  gxExtendedArabicScript,
  gxSindhiScript = gxExtendedArabicScript,
  gxUninterpretedScript
} gxMacintoshScripts;

typedef enum {
  gxIsoASCIIScript = 1,
  gxIso8859_1Script,
  gxIso10646BaseScript
} gxIsoScripts;

typedef long gxFontScript;

typedef enum {
  gxNoLanguage,
  gxEnglishLanguage,
  gxFrenchLanguage,
  gxGermanLanguage,
  gxItalianLanguage,
  gxDutchLanguage,
  gxSwedishLanguage,
  gxSpanishLanguage,
  gxDanishLanguage,
  gxPortugueseLanguage,
  gxNorwegianLanguage,
  gxHebrewLanguage,
  gxJapaneseLanguage,
  gxArabicLanguage,
  gxFinnishLanguage,
  gxGreekLanguage,
  gxIcelandicLanguage,
  gxMalteseLanguage,
  gxTurkishLanguage,
  gxCroatianLanguage,
  gxTradChineseLanguage,
  gxUrduLanguage,
  gxHindiLanguage,
  gxThaiLanguage,
  gxKoreanLanguage,
  gxLithuanianLanguage,
  gxPolishLanguage,
  gxHungarianLanguage,
  gxEstonianLanguage,
  gxLettishLanguage,
  gxLatvianLanguage = gxLettishLanguage,
  gxSaamiskLanguage,
  gxLappishLanguage = gxSaamiskLanguage,
  gxFaeroeseLanguage,
  gxFarsiLanguage,
  gxPersianLanguage = gxFarsiLanguage,
  gxRussianLanguage,
  gxSimpChineseLanguage,
  gxFlemishLanguage,
  gxIrishLanguage,
  gxAlbanianLanguage,
  gxRomanianLanguage,
  gxCzechLanguage,
  gxSlovakLanguage,
  gxSlovenianLanguage,
  gxYiddishLanguage,
  gxSerbianLanguage,
  gxMacedonianLanguage, 
  gxBulgarianLanguage,
  gxUkrainianLanguage,
  gxByelorussianLanguage,
  gxUzbekLanguage,
  gxKazakhLanguage,
  gxAzerbaijaniLanguage,
  gxAzerbaijanArLanguage,
  gxArmenianLanguage,
  gxGeorgianLanguage,
  gxMoldavianLanguage,
  gxKirghizLanguage,
  gxTajikiLanguage,
  gxTurkmenLanguage,
  gxMongolianLanguage,
  gxMongolianCyrLanguage,
  gxPashtoLanguage,
  gxKurdishLanguage,
  gxKashmiriLanguage,
  gxSindhiLanguage,
  gxTibetanLanguage,
  gxNepaliLanguage,
  gxSanskritLanguage,
  gxMarathiLanguage,
  gxBengaliLanguage,
  gxAssameseLanguage,
  gxGujaratiLanguage,
  gxPunjabiLanguage,
  gxOriyaLanguage,
  gxMalayalamLanguage,
  gxKannadaLanguage,
  gxTamilLanguage,
  gxTeluguLanguage, 
  gxSinhaleseLanguage,
  gxBurmeseLanguage,
  gxKhmerLanguage,
  gxLaoLanguage,
  gxVietnameseLanguage, 
  gxIndonesianLanguage,
  gxTagalogLanguage,
  gxMalayRomanLanguage,
  gxMalayArabicLanguage,
  gxAmharicLanguage,
  gxTigrinyaLanguage,
  gxGallaLanguage,
  gxOromoLanguage = gxGallaLanguage,
  gxSomaliLanguage,
  gxSwahiliLanguage,
  gxRuandaLanguage,
  gxRundiLanguage,
  gxChewaLanguage,
  gxMalagasyLanguage,
  gxEsperantoLanguage,
  gxWelshLanguage = 129,
  gxBasqueLanguage,
  gxCatalanLanguage,
  gxLatinLanguage,
  gxQuechuaLanguage,
  gxGuaraniLanguage,
  gxAymaraLanguage,
  gxTatarLanguage,
  gxUighurLanguage,
  gxDzongkhaLanguage,
  gxJavaneseRomLanguage,
  gxSundaneseRomLanguage
} gxMacintoshLanguages;

typedef long gxFontLanguage;

typedef enum {
  gxNoFontName,
  gxCopyrightFontName,
  gxFamilyFontName,
  gxStyleFontName,
  gxUniqueFontName,
  gxFullFontName,
  gxVersionFontName,
  gxPostscriptFontName,
  gxTrademarkFontName,
  gxManufacturerFontName
} gxFontNames;

typedef long gxFontName;

#ifndef gxSharedFontTypeDefines
  #define gxSharedFontTypeDefines
  
  typedef long gxFontTableTag;
  typedef long gxFontVariationTag;
  typedef long gxFontFormatTag;
  typedef long gxFontStorageTag;

  typedef struct {
    gxFontVariationTag  name;
    fixed       value;
  } gxFontVariation;
  typedef gxFontVariation gxFontDescriptor;

  typedef struct {
    unsigned short  featureType;
    unsigned short  setting;
  } gxFontRunFeature;

  typedef struct {
    unsigned short  setting;
    unsigned short  nameID;
  } gxFontFeatureSetting;
#endif

typedef enum {
  gxSystemFontAttribute = 0x00000001
} gxFontAttributes;

typedef long gxFontAttribute;

typedef enum {
  gxMutuallyExclusiveFeature = 0x00008000
} gxFontFeatureFlags;

typedef long gxFontFeatureFlag;

typedef enum {
  gxMutuallyExclusiveFeatureSet = 0x00004000,
  gxSelectedByDefaultFeatureSet = 0x00008000
} gxFontFeatureSetFlags;

typedef long gxFontFeatureSetFlag;

typedef long gxFontFeature;
typedef long gxFontFeatureSetGroup;

/*
 *  These are gxFontStorageTag values
*/
#define gxResourceFontStorage 0x72737263  /* 'rsrc' */
#define gxHandleFontStorage   0x686e646c  /* 'hndl' */
#define gxFileFontStorage   0x62617373  /* 'bass' */
#define gxNfntFontStorage   0x6e666e74  /* 'nfnt' */

typedef void *gxFontStorageReference;

#endif
