/* graphics libraries:
  graphics state routines 
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.  */

#pragma once
#ifndef graphicsStateLibraryIncludes
#define graphicsStateLibraryIncludes
  #ifndef gxGraphicsTypesIncludes
    #include "graphics types.h"
  #endif
  
  typedef struct graphicsStateRecord {
    gxShape defaultShapes[gxPictureType - 1];
  } graphicsStateRecord, *graphicsState;
  
  extern graphicsState lastGraphicsState;
  
  graphicsState NewGraphicsState(void);
  void DisposeGraphicsState(graphicsState);
  void GetGraphicsState(graphicsState);
  void SetGraphicsState(graphicsState);
  graphicsState SwapGraphicsState(graphicsState);
#endif
