/* graphics:
  toolbox interfaces
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.  */


#ifndef gxGraphicsToolboxIncludes
  #define gxGraphicsToolboxIncludes

  #ifndef __WINDOWS__
    #include <Windows.h>
  #endif

  #ifndef gxFontTypesIncludes
    #include "font types.h"
  #endif

  #ifndef gxGraphicsTypesIncludes
    #include "graphics types.h"
  #endif

  #ifdef appleInternal
    #define GXInlineCode(x)
  #endif
  #ifndef GXInlineCode
    #define GXInlineCode(x) = {0x303C, x, 0xA832}
  #endif

  typedef void (*gxUserViewPortFilter)(gxShape, gxViewPort, long);

  gxViewPort GXNewWindowViewPort(WindowPtr) GXInlineCode(0x11FA);
  gxViewPort GXGetWindowViewPort(WindowPtr) GXInlineCode(0x11FB);
  WindowPtr GXGetViewPortWindow(gxViewPort) GXInlineCode(0x11FC);

  GDHandle GXGetViewDeviceGDevice(gxViewDevice) GXInlineCode(0x11FD);
  gxViewDevice GXGetGDeviceViewDevice(GDHandle) GXInlineCode(0x11FE);

  /* gxPoint utilities */
  void GXQDGlobalToFixedLocal(const Point *, gxPoint *) GXInlineCode(0x11FF);     /* convert from QD global space to fixed-gxPoint local space */
  void GXQDLocalToFixedGlobal(const Point *, gxViewPort, gxPoint *) GXInlineCode(0x1200); /* convert from QD local space to fixed-gxPoint global space */

  /* mouse utilities */
  void GXGetGlobalMouse(gxPoint *) GXInlineCode(0x1201);          /* return mouse location in fixed-gxPoint global space */
  void GXGetViewPortMouse(gxViewPort, gxPoint *) GXInlineCode(0x1202);    /* return fixed-gxPoint local mouse (gxViewPort == 0 --> default) */

  /* QuickDraw PICT utilities (NOTE: InitGraf must must be called before using these routines) */
  PicHandle GXShapeToPICT(gxShape) GXInlineCode(0x1203);      /* given a gxShape, return a handle to a QuickDraw PICT */
  gxShape GXPICTToShape(PicHandle) GXInlineCode(0x1204);      /* vice-versa */

  gxUserViewPortFilter GXGetViewPortFilter(gxViewPort, long *) GXInlineCode(0x1206);
  void GXSetViewPortFilter(gxViewPort, gxUserViewPortFilter, long) GXInlineCode(0x1207);
 
  /* QD to QD GX Translator typedefs and functions */
  
  #define gxDefaultOptionsTranslation   0x0000
  #define gxOptimizedTranslation      0x0001
  #define gxReplaceLineWidthTranslation   0x0002
  #define gxSimpleScalingTranslation    0x0004
  #define gxSimpleGeometryTranslation   0x0008  /* implies simple scaling */
  #define gxSimpleLinesTranslation      0x000C  /* implies simple geometry & scaling */
  #define gxLayoutTextTranslation     0x0010  /* turn on gxLine layout (normally off) */
  
  typedef long gxTranslationOptions;
  
  #define gxContainsFormsBegin     0x0001
  #define gxContainsFormsEnd     0x0002
  #define gxContainsPostScript     0x0004
  #define gxContainsEmptyPostScript  0x0008
  
  typedef OSErr (*gxShapeSpoolFunction)(gxShape theShape, long reference);
  
  typedef long gxTranslatorStatistics;

  void GXInstallQDTranslator(GrafPtr port, gxTranslationOptions options, const Rect *srcRect, const Rect *dstRect, Point patStrech, gxShapeSpoolFunction userFunction, long reference) GXInlineCode(0x1269);

  gxTranslatorStatistics *GXRemoveQDTranslator(GrafPtr port, gxTranslatorStatistics *statistics) GXInlineCode(0x126A);

  gxShape GXConvertPICTToShape(const PicHandle pict, gxTranslationOptions options, const Rect *srcRect, const Rect *dstRect, Point patStretch, gxShape destination, gxTranslatorStatistics stats) GXInlineCode(0x126B);

  #undef GXInlineCode

#endif
