/* layout feature constants.h -- Names for layout feature types and selectors. */

/* Copyright 1992, 1993 Apple Computer, Inc.  All rights reserved. */

#ifndef gxLayoutFeatureConstantsIncludes
#define gxLayoutFeatureConstantsIncludes

/* The following values can be used to set gxRunFeature values. Note that unless the
    feature is defaulted differently in different fonts, the zero value for the
    selectors represents the default value. */

enum {

  gxTypographicFeaturesType = 0,
  
    gxEnableEffectsOnSelector                 = 0,
    gxEnableEffectsOffSelector                = 1,
  
  gxLigatureType = 1,
  
    gxLigatureRequiredOnSelector              = 0,
    gxLigatureRequiredOffSelector             = 1,
    gxLigatureCommonOnSelector                = 2,
    gxLigatureCommonOffSelector               = 3,
    gxLigatureRareOnSelector                  = 4,
    gxLigatureRareOffSelector                 = 5,
    gxLigatureLogotypeOnSelector              = 6,
    gxLigatureLogotypeOffSelector             = 7,
    gxLigatureRebusOnSelector                 = 8,
    gxLigatureRebusOffSelector                = 9,
  
  gxCursiveConnectionType = 2,
  
    gxCursiveConnectionNoneSelector           = 0,
    gxCursiveConnectionPartialSelector        = 1,
    gxCursiveConnectionFullSelector           = 2,
  
  gxLetterNumberCaseType = 3,
  
    gxLetterNumberCaseUpperLowerSelector      = 0,
    gxLetterNumberCaseAllUpperSelector        = 1,
    gxLetterNumberCaseAllLowerSelector        = 2,
    gxLetterNumberCaseSmallCapsSelector       = 3,
    gxLetterNumberCaseUpperThenLowerSelector  = 4,
    gxLetterNumberCaseUpperThenSmCapsSelector = 5,
  
  gxVerticalSubstitutionType = 4,
  
    gxVerticalSubstitutionOnSelector          = 0,
    gxVerticalSubstitutionOffSelector         = 1,
  
  gxRearrangementType = 5,
  
    gxRearrangementOnSelector                 = 0,
    gxRearrangementOffSelector                = 1,
  
  gxNumberStyleType = 6,
  
    gxNumberStyleForColumnsSelector           = 0,
    gxNumberStyleProportionalSelector         = 1,
  
  gxAlternateDesignsType = 7,
  
    gxAlternateDesignsEngravedOnSelector      = 0,
    gxAlternateDesignsEngravedOffSelector     = 1,
    gxAlternateDesignsCursiveOnSelector       = 2,
    gxAlternateDesignsCursiveOffSelector      = 3,
    gxAlternateDesignsSlopedOnSelector        = 4,
    gxAlternateDesignsSlopedOffSelector       = 5,
    gxAlternateDesignsChanceryOnSelector      = 6,
    gxAlternateDesignsChanceryOffSelector     = 7,
    gxAlternateDesignsBookTextOnSelector      = 8,
    gxAlternateDesignsBookTextOffSelector     = 9,
    gxAlternateDesignsDisplayTextOnSelector   = 10,
    gxAlternateDesignsDisplayTextOffSelector  = 11,
    gxAlternateDesignsIlluminatedOnSelector   = 12,
    gxAlternateDesignsIlluminatedOffSelector  = 13,
    gxAlternateDesignsTitlingOnSelector       = 14,
    gxAlternateDesignsTitlingOffSelector      = 15,
  
  gxSmartSwashType = 8,
  
    gxSmartSwashWordInitialsOnSelector        = 0,
    gxSmartSwashWordInitialsOffSelector       = 1,
    gxSmartSwashWordFinalsOnSelector          = 2,
    gxSmartSwashWordFinalsOffSelector         = 3,
    gxSmartSwashLineInitialsOnSelector        = 4,
    gxSmartSwashLineInitialsOffSelector       = 5,
    gxSmartSwashLineFinalsOnSelector          = 6,
    gxSmartSwashLineFinalsOffSelector         = 7,
    gxSmartSwashArchaicNonFinalsOnSelector    = 8,
    gxSmartSwashArchaicNonFinalsOffSelector   = 9,
  
  gxDiacriticsType = 9,
  
    gxDiacriticsShowSelector                  = 0,
    gxDiacriticsHideSelector                  = 1,
    gxDiacriticsSerializeSelector             = 2,
  
  gxVerticalPositionType = 10,
  
    gxVerticalPositionNormalSelector          = 0,
    gxVerticalPositionSuperiorsSelector       = 1,
    gxVerticalPositionInferiorsSelector       = 2,
    gxVerticalPositionOrdinalsSelector        = 3,
  
  gxFractionsType = 11,
  
    gxFractionsDontFormSelector               = 0,
    gxFractionsFormVerticalSelector           = 1,
    gxFractionsFormDiagonalSelector           = 2,
  
  gxDiphthongLigaturesType = 12,
  
    gxDiphthongLigaturesOnSelector            = 0,
    gxDiphthongLigaturesOffSelector           = 1,
  
  gxOverlappingGlyphsType = 13,
  
    gxOverlappingGlyphsPreventOnSelector      = 0,
    gxOverlappingGlyphsPreventOffSelector     = 1,
  
  gxTypographicExtrasType = 14,
  
    gxExtrasHyphensToEmDashOnSelector         = 0,
    gxExtrasHyphensToEmDashOffSelector        = 1,
    gxExtrasHyphenToEnDashOnSelector          = 2,
    gxExtrasHyphenToEnDashOffSelector         = 3,
    gxExtrasForceUnslashedZeroOnSelector      = 4,
    gxExtrasForceUnslashedZeroOffSelector     = 5,
    gxExtrasMakeInterrobangOnSelector         = 6,
    gxExtrasMakeInterrobangOffSelector        = 7,
  
  gxMathExtrasType = 15,
  
    gxMathHyphenToMinusOnSelector             = 0,
    gxMathHyphenToMinusOffSelector            = 1,
    gxMathStarToMultiplyOnSelector            = 2,
    gxMathStarToMultiplyOffSelector           = 3,
    gxMathSlashToDivideOnSelector             = 4,
    gxMathSlashToDivideOffSelector            = 5,
    gxMathInequalityLigaturesOnSelector       = 6,
    gxMathInequalityLigaturesOffSelector      = 7,
    gxMathExponentiationOnSelector            = 8,
    gxMathExponentiationOffSelector           = 9,
  
  gxOrnamentSetsType = 16,
  
    gxOrnamentSetsNoneSelector                = 0,
    gxOrnamentSetsDingbatsSelector            = 1,
    gxOrnamentSetsPiCharactersSelector        = 2,
    gxOrnamentSetsFleuronsSelector            = 3,
    gxOrnamentSetsDecorativeBordersSelector   = 4,
    gxOrnamentSetsIntlSymbolsSelector         = 5,
    gxOrnamentSetsMathSymbolsSelector         = 6,
  
  gxGlyphAlternativesType = 17,
  
    /* The selectors for this type are simply numbers starting with zero for
       the different sets of swash glyphs in a gxFont. For example, a gxFont with
       twenty ampersands could place them in twenty selectors under this feature
       type. Use of the gxAlternateDesignsType, however, is preferred (when feasible). */

  gxLastFeatureType = -1
  
  };

#endif gxLayoutFeatureConstantsIncludes
