/* graphics:  
  math type definitions
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.
*/

#ifndef gxMathTypesIncludes
  #define gxMathTypesIncludes

  #ifndef gxDefine_true_false_boolean
    #define gxDefine_true_false_boolean
    #ifndef _MacTypes_
      #ifndef __TYPES__
        enum {false, true};
      #endif
    #endif
    typedef unsigned char gxBoolean;
  #endif

    /* we have to use either an if-n-def or an if-def with the last symbol so that our preprocess tool can strip it out properly */
    typedef long fixed;
    typedef struct {fixed x, y;} gxPoint;

  typedef long fract;
  typedef unsigned short gxColorValue;
  typedef struct { fixed radius, angle; } gxPolar;
  typedef struct {long hi; unsigned long lo;} gxWide;
  typedef struct { fixed map[3][3]; } gxMapping;

  #define fixed1      ((fixed) 0x00010000)  /* fixed 1.0 */
  #define fract1      ((fract) 0x40000000)  /* fract 1.0 */
  #define gxColorValue1   ((gxColorValue) 0xFFFF) /* gxColorValue 1.0 */
  #define gxPositiveInfinity  ((fixed) 0x7FFFFFFF)    /* for fixed and fract */
  #define gxNegativeInfinity  ((fixed) 0x80000000)  /* for fixed and fract */

  #define fix1      fixed1
  #define frac1     fract1
#endif
