/* graphics libraries:  
  offscreen support library interfaces
  by Cary Clark, Michael Fairman, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink
  Copyright 1987 - 1990 Apple Computer, Inc.  All rights reserved.
*/

#ifndef offscreenLibraryIncludes
  #define offscreenLibraryIncludes
  
  #ifndef gxGraphicsTypesIncludes
    #include "graphics types.h"
  #endif

  typedef struct {
    gxShape   draw; /* a gxBitmap gxShape which, when drawn, will transfer the offscreen to the display */
    gxTransform   xform;  /* a gxTransform that will cause shapes owning it to draw offscreen. */
    gxViewDevice  device; /* the offscreen gxViewDevice whose gxColorSpace, etc. you may change */
    gxViewPort    port;   /* the offscreen gxViewPort which may be placed in any gxTransform's gxViewPort list */
    gxViewGroup group;  /* the global space in which the gxViewPort and gxViewDevice exist */
  } offscreen;
  
  typedef struct viewPortBufferRecord **viewPortBuffer;

  /* (see the .c file for routine explanations) */
  void CreateOffscreen(offscreen *target, gxShape bitmapShape);
  void DisposeOffscreen(offscreen *target);
  void CopyToBitmaps(gxShape target, gxShape source);

  viewPortBuffer NewViewPortBuffer(gxViewPort originalPort);
  void DisposeViewPortBuffer(viewPortBuffer target);
  gxBoolean ValidViewPortBuffer(viewPortBuffer target);
  gxBoolean UpdateViewPortBuffer(viewPortBuffer target);
  gxViewPort GetViewPortBufferViewPort(viewPortBuffer source);
  gxShape GetViewPortBufferShape(viewPortBuffer source);
#endif
