/* graphics routines:
  quickdraw library interfaces
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.  */

#ifndef qdLibraryIncludes
  #define qdLibraryIncludes

  /* geometry conversions */
  gxPoint *ShortPointToFixed(const Point *, gxPoint *);
  Point *FixedPointToShort(const gxPoint *, Point *);
  gxRectangle *ShortRectToFixed(const Rect *, gxRectangle *);
  Rect *FixedRectToShort(const gxRectangle *, Rect *);
    
  /* gxColor conversions */
  gxColorSet CTableToColorSet(const CTabHandle);
  CTabHandle ColorSetToCTable(const gxColorSet);
  
  /* pixmap/gxBitmap conversions */
  gxBitmap *ConvertFromQDBitmap(const BitMap *, gxBitmap *);
  BitMap *ConvertToQDBitmap(const gxBitmap *, BitMap *);
  gxShape BitMapToShape(const BitMap *);
  gxShape PixMapToShape(const PixMapHandle);
  gxShape GetPixMapShape(short resourceID);
  gxShape CICNToMask(CIconHandle iconH);
  gxShape CICNToShape(CIconHandle iconH);
  gxShape GetCICNMask(long resourceID);
  gxShape GetCICNShape(long resourceID);
#endif
