/*
**  scaler library.h  - Interface to the routines used to call gxFont scalers directly
**
**  Copyright 1992 Apple Computer, Inc.  All rights reserved.
*/

#ifndef scalerLibraryIncludes
#define scalerLibraryIncludes

#ifndef gxScalerTypeIncludes
  #include "scaler types.h"
#endif

gxScalerError FontScalerOpen( gxScalerContext* context, gxScalerInfo* theInfo);
gxScalerError FontScalerNewFont( gxScalerContext* context, gxScalerFontInfo* info);
gxScalerError FontScalerNewVariation( gxScalerContext* context, long count, gxFontVariation variation[]);
gxScalerError FontScalerNewTransform( gxScalerContext* context, gxScalerTransform* trans, gxScalerTransformInfo* info);
gxScalerError FontScalerNewGlyph( gxScalerContext* context, gxScalerGlyph* glyph, gxScalerMetrics* fractional, gxScalerMetrics* device, gxScalerBitmap* bitImage, void* outlineData);
gxScalerError FontScalerStreamFont( gxScalerContext* context, gxScalerStream* stream);
gxScalerError FontScalerKernGlyphs( gxScalerContext* context, gxScalerKerning* kerning, gxPoint deltas[], unsigned short flags[], gxPoint locations[]);
void  CloseAllOpenFontScalers(void);

#endif
