/* graphics libraries:  
  primitive flattening library routine interfaces
  by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
  Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.  */

#ifndef storageLibraryIncludes
  #ifndef __TYPES__
    #include <Types.h>
  #endif

  #ifndef gxGraphicsStreamTypesIncludes
    #include "graphics stream types.h"
  #endif
    
  typedef struct {
    gxSpoolBlock    spool;
    long      reference;
    long      position;
    long      size;
    void      *data;
    void      *userField;
  } userSpool;

  long HandleSpoolProc(gxSpoolCommand, userSpool *);
  long FileSpoolProc(gxSpoolCommand, userSpool *);
  
  Handle ShapeToHandle(gxShape);
  gxShape HandleToShape(Handle, long count, const gxViewPort portList[]);
  void ShapeToFile(gxShape, Str255 fileName, short vRefNum, OSType creator, OSType fileType);
  gxShape FileToShape(Str255 fileName, short vRefNum, long count, const gxViewPort portList[]);
  Handle FontToHandle(gxFont fontID, long glyphBits[]);
  gxFont HandleToFont(Handle source);
#endif
