/*
	File:		FontHIFontUtils.h

	Contains:	internal font-related utility routines and data structs
				supporting FontHI library

	Written by:	Parry Kejriwal, Dennis Buchheim

	Copyright:	 1992, 1993 by Apple Computer, Inc., All rights reserved.

	Change History (most recent first):


*/

#pragma once

#include <Types.h>
#include <FixMath.h>

#include "font types.h"

#include "FontHIPaletteData.h"


/*----------*/

typedef struct {
	fontName		theNameID;		/* the name table index */
	Str255			name;			/* the actual string */
} FHI_NameRec;

typedef struct {
	short			numberOfInstances;
	FHI_NameRec		names[];
} FHI_InstanceRec, *FHI_InstancePtr, **FHI_InstanceHan;


typedef struct {
	Str255			name;
	fontName		nameID;
	Fixed			trackValue;
} FHI_TrackInfoRec;

typedef struct {
	long				numTracks;
	FHI_TrackInfoRec	tracks[];
} FHI_TrackingRec, *FHI_TrackingPtr, **FHI_TrackingHan;

/*----------*/

short				FHIVariationToIndex (font theFontID,
										 short numCmpVariations,
										 fontVariation *cmpVariations);
FHI_InstanceHan		FHIGetInstances (font theFontID);

void				FHIApplyFeaturesToDefault( FHI_FeatMenuInfoHan featH, 
							short srcNumFeatures, fontRunFeature * srcFeatures, 
							short * dstNumFeatures, fontRunFeature *** dstFeatures);
FHI_FeatMenuInfoHan	FHIGetFeatures (font theFontID);

FHI_TrackingHan		FHIGetTrackTableInfo (font theFontID);
