/*
	File:		FontHIMenus.h

 	Contains:	public interface to routines and data structs for FontHI Font and Style menus

	Written by:	Dennis Buchheim

	Copyright:	 1993 by Apple Computer, Inc., All rights reserved.

	Change History (most recent first):


*/

#pragma once

#include <Types.h>
#include <QuickDraw.h>
#include <Menus.h>

#include "font types.h"

/*----------*/

typedef struct {
	font	oldFontID;
	Style	oldTextface;
	font	newFontID;
	Style	newTextface;
	short	oldFamilyMenuItem;	/* for internal use */
	short	oldStyleMenuItem;	/* for internal use */
} FHI_FontMapRec, *FHI_FontMapPtr;

typedef struct {
	font	fontID;
	Style	textface;
} FHI_FontIDRec, *FHI_FontIDPtr;

/*----------*/

void *	FontHIInitMenuData			(void);
void	FontHIDisposeMenuData		(void 			*fontMenuDataH);

short	FontHIFamilyMenu			(void 			*fontMenuDataH,
									 MenuHandle		familyMenu);
short	FontHIFamilyMenuSetItem		(void			*fontMenuDataH,
									 MenuHandle		familyMenu,
									 MenuHandle		styleMenu,
									 short			newFamilyItem,
									 short			*numFontMappings,
									 FHI_FontMapPtr	*fontMappings);
									 
short	FontHIStyleMenu				(void			*fontMenuDataH,
									 MenuHandle		styleMenu);
short	FontHIStyleMenuSetItem		(void			*fontMenuDataH,
									 MenuHandle		styleMenu,
									 short			newStyleItem,
									 short			*numFontMappings,
									 FHI_FontMapPtr	*fontMappings);

short	FontHIGetMarkedFamilyItem	(void			*fontMenuDataH);
short	FontHIGetMarkedStyleItem	(void			*fontMenuDataH);

short	FontHICountSelectedFonts	(void			*fontMenuDataH);
short	FontHIGetSelectedFontIDs	(void			*fontMenuDataH,
									 short			*numSelectedFonts,
									 FHI_FontIDPtr	*fontIDs);
									 
void	FontHIGetFamilyName			(void			*fontMenuDataH,
									 font			fontID,
									 Style			textface,
									 Str255			familyName);
void	FontHIGetStyleName			(void			*fontMenuDataH,
									 font			fontID,
									 Style			textface,
									 Str255			styleName);

void	FontHIMarkFonts				(void			*fontMenuDataH,
									 MenuHandle		familyMenu,
									 MenuHandle		styleMenu,
									 short			numFontsToSelect,
									 FHI_FontIDPtr	fontIDs);
