/*
	File:		FontHIPalette.h

 	Contains:	public interface to routines and data structs for FontHI font palette

	Written by:	Dennis Buchheim

	Copyright:	 1993 by Apple Computer, Inc., All rights reserved.

	Change History (most recent first):


*/

#pragma once

#include <Types.h>
#include <Controls.h>
#include <QuickDraw.h>
#include <Windows.h>

#include <FixMath.h>

#include "font types.h"

#include "FontHIMenus.h"

/*----------*/

typedef enum {
	FHI_NoChange = 0,
	FHI_FontChange,
	FHI_InstanceChange,
	FHI_FeatureChange,
	FHI_TrackingChange
} FHI_Changes;

/*----------*/

void *		FontHIOpenPalette			(void 			*fontMenuDataH);

void		FontHIShowHidePalette		(void 			*fontPalDataH,
										 Boolean		show);
										 
void		FontHIDisposePalette		(void 			*fontPalDataH);

FHI_Changes	FontHIDoPaletteControl		(void 			*fontPalDataH,
										 ControlHandle	whichControl,
				 						 short	 		whichPart,
							 			 Point			where);
							 			 
FHI_Changes	FontHIDoPaletteClick		(void 			*fontPalDataH,
										 Point			where,
										 short			modifiers,
										 fontRunFeature	*newFeature,
										 Boolean		*newFeatExcl);
										 
void		FontHIUpdatePalette			(void 			*fontPalDataH);

void		FontHIActivatePalette		(void 			*fontPalDataH,
										 Boolean		activate);

short 		FontHIPaletteFontChange		(void 			*fontPalDataH,
										 void 			*fontMenuDataH,
										 short			numMappings,
										 FHI_FontMapPtr	fontMappings);

WindowPtr	FontHIGetPalettePort		(void 			*fontPalDataH);
Boolean		FontHIWindowIsPalette		(void 			*fontPalDataH,
										 WindowPtr		theWindow);
Boolean		FontHIPaletteVisible		(void 			*fontPalDataH);

font		FontHIGetPaletteFontID		(void 			*fontPalDataH);
short		FontHIGetSelectedInstance	(void 			*fontPalDataH);
short		FontHIGetSelectedFeatures	(void 			*fontPalDataH,
										 short 			*numFeatures,
										 fontRunFeature	**features);
Fixed		FontHIGetTrackingValue		(void 			*fontPalDataH);

short		FontHIVariationToIndex		(font 			theFontID,
										 short 			numCmpVariations,
										 fontVariation	*cmpVariations);
void		FontHISetSelectedInstances	(void 			*fontPalDataH,
										 font 			fontID,
										 Style			textface,
										 short			numIndices,
										 short			*indices,
										 Boolean		clearAll);
										 
void		FontHISetAllSelectedFeatures(void 			*fontPalDataH,
										 font			fontID,
										 Style			textface,
										 short			numFeatureGroups,
										 short			**featureGroupSizes,
										 fontRunFeature	***featureGroups);
										 
void		FontHISetTrackingValue		(void 			*fontPalDataH,
										 font			fontID,
										 Style			textface,
										 float			newValue);
