/*
	File:		FontHIPaletteWind.h

 	Contains:	internal routines for FontHI font palette window handling

	Written by:	Dennis Buchheim

	Copyright:	 1992, 1993 by Apple Computer, Inc., All rights reserved.

	Change History (most recent first):


*/

#pragma once

#include <Types.h>
#include <Controls.h>
#include <QuickDraw.h>

#include "font types.h"

#include "FontHIMenuData.h"
#include "FontHIMenus.h"
#include "FontHIPaletteData.h"
#include "FontHIPalette.h"

/*----------*/

/*	routines called in FontHIPalette.c
 */
FHI_PalDataHan	FHIOpenPalette			(FHI_MenuDataHan fontMenuDataH);
void 			FHIShowHidePalette		(FHI_PalDataHan fontPalDataH,
										 Boolean show);
void			FHIDisposePalette		(FHI_PalDataHan	fontPalDataH);
FHI_Changes		FHIDoPaletteControl		(FHI_PalDataHan	fontPalDataH,
										 ControlHandle	whichControl,
				 						 short	 		whichPart,
							 			 Point			where);
FHI_Changes		FHIDoPaletteClick		(FHI_PalDataHan	fontPalDataH,
										 Point			where,
										 short			modifiers,
										 fontRunFeature	*newFeature,
										 Boolean		*newFeatExcl);
void			FHIUpdatePalette		(FHI_PalDataHan	fontPalDataH);
void			FHIActivatePalette		(FHI_PalDataHan	fontPalDataH,
										 Boolean		activate);

short 			FHIPaletteFontChange	(FHI_PalDataHan fontPalDataH,
										 FHI_MenuDataHan fontMenuDataH,
										 short numMappings,
										 FHI_FontMapPtr fontMappings);


/*	routines called only in FontHIPaletteData.c
 */
void 			FHIBuildInstancePopup	(FHI_PalDataHan fontPalDataH,
										 font fontID, Style textface);

void			FHIMarkFeatPopup		(FHI_PalDataHan fontPalDataH,
										 font fontID, Style textface);
void			FHIMarkMultFeatPopup	(FHI_PalDataHan fontPalDataH,
										 font fontID, Style textface);
										 
void			UpdateTrackControl		(FHI_PalDataHan fontPalDataH);
