/*
	File:		FontHIUtils.c

	Contains:	internal general utility routines supporting FontHI library

	Written by:	code taken from QuickDraw GX "font menu library"

	Copyright:	 1992, 1993 by Apple Computer, Inc., All rights reserved.

	Change History (most recent first):


*/

#include "FontHIUtils.h"


/*--------------------------------------------------------- FHIPstrcat */
void FHIPstrcat( d, s)
char *d, *s;
{
	short	lenSrc, lenDest;

	lenSrc = s[0];
	lenDest = d[0];

	if ( lenSrc + lenDest < 255) {
		BlockMove (s+1, d+lenDest+1, lenSrc);
		d[0] = lenSrc + lenDest;
	}
}

/*--------------------------------------------------------- Minimum */
static long Minimum ( long l1, long l2 )
{
	if ( l1 > l2 ) return ( l2);
	return ( l1 );
}

/*--------------------------------------------------------- FHIPstrcmp */
short FHIPstrcmp (char *s1, char *s2)
{
	short				len1, len2;
	register short		i;
	short				min;

	len1 = s1[0];
	len2 = s2[0];

	min = Minimum (len1, len2);

	i = 1;
	while ( i <= min ) {
		if ( s1[i] < s2[i] )
			return ( -1 );
		if ( s1[i] > s2[i] )
			return ( 1 );
		if ( s1[i] == s2[i])
			i++;
	}
	if ( len1 == len2 )
		return ( 0 );
	if ( len1 < len2 )
		return ( -1 );
	return ( 1 );
}

/*--------------------------------------------------------- FHIStr255Cmp */
short FHIStr255Cmp (Str255 a, Str255 b)
{
	short i, minSize = a[0] < b[0] ? a[0] : b[0];

	for (i = 1; i < minSize; i++) {
		if (a[i] == b[i])
			continue;
		return a[i] - b[i];
	}
	return a[0] - b[0];
}
