/*
	File:		FontHIUtils.h

	Contains:	internal general utility routines and data structs supporting FontHI library

	Written by:	Dennis Buchheim
				some code taken from QuickDraw GX "font menu library"

	Copyright:	 1992, 1993 by Apple Computer, Inc., All rights reserved.

	Change History (most recent first):


*/

#pragma once

#include <Memory.h>
#include <Types.h>


#define FHI_Pstrcpy(d, s)	(BlockMove((Ptr)s, (Ptr)d, (long)(*s+1)))
#define FHI_Pstrlen(s)		(short)((char *) s[0])

#define FHI_Abs(n)			((n >= 0) ? n : -n)
#define FHI_Round(n)		((long)(n+0.5))
#define FHI_Round1(n)		((float) Round(n*10)/10)

void	FHIPstrcat 		(char *d, char *s);
short	FHIPstrcmp		(char *s1, char *s2);
short	FHIStr255Cmp	(Str255 a, Str255 b);
