/*
	File:		FontHIValidation.h

	Contains:	validation routines and data structs for FontHI library

	Written by:	Dennis Buchheim

	Copyright:	 1993 by Apple Computer, Inc., All rights reserved.

	Change History (most recent first):


*/

#pragma once


#define FontHIMenuValidationOn		1
#define FontHIPaletteValidationOn	1

/*----------*/

typedef enum {
	FontHI_NoErr = 0,
	FontHI_BadMagic,
	FontHI_NullStruct,
	FontHI_BadFields,
	FontHI_OtherArgsBad
} FHI_Errors;

/*----------*/

FHI_Errors	FHIValidateMenuData (void *fontMenuDataH);

FHI_Errors	FHIValidatePaletteData (void *fontPalDataH);

void		FHIPostError (FHI_Errors err);
