/*
	File:			GXEditParagraph.h
	
	Contains:
	
	Written by:		Barton R. House
	
	Copyright:		 1993 by Apple Computer, Inc., All rights reserved.
	
*/


void	InsertParagraphText(DocPtr dp, ParaPtr pp, short paragraphOffset,
												  void * text, short numText, short textSize,
												  short styleIndex);
									
void	DrawParagraph(DocPtr dp, ParaPtr pp, long start, long end);

void	ReflowParagraph(DocPtr dp, ParaPtr pp);

void	gxEditNewParagraph(DocPtr dp, ParaPtr pp, short styleIndex, short textSize);

void	HitTestParagraph(DocPtr dp, ParaPtr pp, Point where, short * paraOffset,
																	Boolean * endOfLine);

void	ParagraphPosition(DocPtr dp, ParaPtr pp, short paraOffset, Rect * rect);

void	ParagraphClear(DocPtr dp, ParaPtr pp, short paraOffset, short numGlyphs);

void	JoinParagraphs(DocPtr dp, ParaPtr top, ParaPtr bottom);

void	gxEditDisposeParagraph(ParaPtr pp);

void	SplitParagraph(DocPtr dp, ParaPtr pp, short paragraphOffset, ParaPtr newPara);

Boolean	SetParagraphTextFonts(DocPtr dp, ParaPtr pp,
												short numFonts, font * srcFonts, font * dstFonts,
												short startOffset, short endOffset);

Boolean	SetParagraphTextSize(DocPtr dp, ParaPtr pp, short size,
													short startOffset, short endOffset);

Boolean	SetParagraphStyles(DocPtr dp, ParaPtr pp,
										short numStyles, short *oldStyles, short *newStyles,
										short startOffset, short endOffset);

void	GetParagraphAttributes(DocPtr dp, ParaPtr pp, AttrPtr ap,
											short startOffset, short endOffset);
