/*
	File:			GXEditStyle.h
	
	Contains:
	
	Written by:		Barton R. House
	
	Copyright:		 1993 by Apple Computer, Inc., All rights reserved.
	
*/

#ifndef _H_Style
#define _H_Style

short		FindDocStyle(DocPtr dp, StylePtr sp);
short		AddDocStyle(DocPtr dp, StylePtr sp);
StylePtr	GetDocStyle(DocPtr dp, short styleIndex);

short		SetDocStyleTextFont(DocPtr dp, short styleIndex, font fontId);
font		GetDocStyleTextFont(DocPtr dp, short styleIndex);

short		SetDocStyleTextSize(DocPtr dp, short styleIndex, short size);
short		GetDocStyleTextSize(DocPtr dp, short styleIndex);

short		SetDocStyleFeatures(DocPtr dp, short styleIndex,
										short numFeatures, fontRunFeature * features);
void		GetDocStyleFeatures(DocPtr dp, short styleIndex,
										short * numFeatures, fontRunFeature * features);

void		ModifyStyleFeatures(DocPtr dp, font fontId, short numFeatureGroups,
									short * srcFeatureGroupSizes,
									fontRunFeature ** srcFeatureGroups,
									short * dstFeatureGroupSizes,
									fontRunFeature ** dstFeatureGroups,
									short numStyles, short * oldStyles, short * newStyles);

void		ModifyStyleVariations(DocPtr dp, font fontId, short numVariations, fontVariation * variations,
									short numStyles, short * oldStyles, short * newStyles);

void		ModifyStyleRunControls(DocPtr dp, RunControls * newRunControls,
									RunControls * runControlsMask,
									short numStyles, short * oldStyles, short * newStyles);


void		UnionStyleFeatures(DocPtr dp, short numStyles, short *styles,
									font fontId, short * numFeatureGroupsPtr,
									short *** featureGroupSizesPtr,
									fontRunFeature **** featureGroupsPtr);

void		UnionStyleVariations(DocPtr dp, short numStyles, short *styles,
						font fontId, short * numInstancesPtr,
						short *** instanceSizesPtr, fontVariation **** instancesPtr);

void		UnionStyleRunControls(DocPtr dp, short numStyles, short *styles,
									RunControls * runControls, RunControls * runControlsMask);
#endif
