/* color matching library
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.
	
	The below code and data is an example, intended to illustrate Graphics functionality.
	It is not part of the Graphics system provided as part of Macintosh System Software.
	Apple Computer, Inc. provides no liability, explicit or implied, for applications using this example.
	The Apple Developer Technical Support group is not able to support this example.
	
	The numbers included in this library are not endorsements of the products described.
	The numbers have not been extensively tested to ensure their accuracy.  	*/

#include "graphics libraries.h"
	
/* data for the QMS Colorscript 100 / Four-color ribbon */

static profileRecord QMS_Chroma = { 
	{0x2165,	0x102b,	0x028f},	/* red		0.5507, 0.3225, 18.57	 */
	{0x06cf,	0x13de,	0x08bb},	/* green		0.2342, 0.4732, 20.09	 */
	{0x0464,	0x02ee,	0x0fc5},	/* blue		0.1864, 0.1718,  5.68	 */
	{0x1618,	0x1da2,	0x54d7},	/* cyan		0.1728, 0.2523, 30.92	 */
	{0x25bc,	0x12c7,	0x1471},	/* magenta	0.4145, 0.2521, 22.58	 */
	{0x60bb,	0x6e87,	0x0d12},	/* yellow		0.4381, 0.4664, 84.14	 */
	{0x0000,	0x0000,	0x0000},	/* black		0.3138, 0.3310,  0.01	 */
	{0x799d,	0x8000,	0x8b12}	/* white		0.3138, 0.3310, 100.00	 */
};

static colorValue QMS_Samples[] = { 	11, 11, 11, 11, 11, 11, 11, 0, 0, 
	0x0000, 0x19c7, 0x3c50, 0x5b22, 0x7c9e, 0xa3c2, 0xcb07, 0xe957, 0xf9e7, 0xfff8, 0xffff,
	0x0000, 0x224d, 0x4587, 0x630b, 0x81a2, 0xa52b, 0xca22, 0xe885, 0xfa15, 0xff75, 0xffff,
	0x0000, 0x21de, 0x4580, 0x65a7, 0x8709, 0xab42, 0xce34, 0xe964, 0xf943, 0xffa3, 0xffff,
	0x0000, 0x2765, 0x4d63, 0x6bd9, 0x8ab2, 0xad21, 0xceb0, 0xe871, 0xf7e1, 0xffeb, 0xffff,
	0x0000, 0x1e21, 0x3e3b, 0x5c1b, 0x7d63, 0xa2d0, 0xc6ba, 0xe287, 0xf466, 0xff89, 0xffff,
	0x0000, 0x1f9d, 0x4247, 0x5e4f, 0x7d9e, 0xa44c, 0xcbbf, 0xe9a5, 0xf971, 0xfff1, 0xffff,
	0x0000, 0x1ea4, 0x3b71, 0x56e9, 0x7703, 0x9d4f, 0xc4a7, 0xe46c, 0xf616, 0xfb0e, 0xffff };

colorProfile CreateQMSColorProfile(void)
{
	return NewColorProfile(&QMS_Chroma, (profileResponse *)QMS_Samples);
}

/* data for the Canon BJ820 ... forthcoming... */

colorProfile CreateCanonColorProfile(void)
{
	return nil;		/* for now */
}
