/* graphics libraries:
	Better shape framing routines
	by Cary Clark, Georgiann Delaney, Michael Fairman, Pablo Fernicola, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.	*/

#include "graphics libraries.h"

void OutsetShape(shape source, fixed outset)
{
	shape temp = CopyToShape(nil, source);
	boolean framed = GetShapeFill(source) < evenOddFill;
	SetShapeFill(source, windingFill);
	SetShapeFill(temp, closedFrameFill);
	SetShapeStyleAttributes(temp, centerFrameStyle);
	SetShapePen(temp, (outset < 0 ? -outset : outset) << 1);
	PrimitiveShape(temp);
	if (outset > 0)							/* if we are outsetting */
		UnionShape(source, temp);
	else if (outset < 0)						/* if we are insetting */
		DifferenceShape(source, temp);
	if (framed)
		SetShapeFill(source, closedFrameFill);
	DisposeShape(temp);
}

void FrameShape(shape source, fixed outset)
{
	shape temp = CopyToShape(nil, source);
	shapeFill originalFill = GetShapeFill(source);
	SetShapeFill(temp, windingFill);
	SetShapeFill(source, closedFrameFill);
	SetShapeStyleAttributes(source, centerFrameStyle);
	SetShapePen(source, (outset < 0 ? -outset : outset) << 1);
	PrimitiveShape(source);
	if (outset > 0)							/* if we are outside framing */
		DifferenceShape(source, temp);
	else if (outset < 0)						/* if we are inside framing */
		IntersectShape(source, temp);
	else									/* the outset is 0 */
		SetShapeFill(source, closedFrameFill);
	DisposeShape(temp);
}
