/* graphics libraries:
	debug library routines
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/


#include <Types.h>
#include "graphics debugging.h"
#include "graphics libraries.h"


/*** The spaces below allow this file to be
compared in its engineering version
side by side with the file
graphics errors.h, to ensure
that the two files are kept in sync. 
These extra spaces may be removed
for the shipping version. */











static char *errorText[] =
{
	"out of memory",
	"internal fatal error",
	"no outline font found",
	"not enough memory for graphics client heap",
	"could not create backing store",
	
	nil,
	"internal error",
	"internal font error",
	"internal layout error",
	"functionality unimplemented",
	"clip to frame shape unimplemented",
	
	

	"null font scaler context",
	"null font scaler input",
	"invalid font scaler context",
	"invalid font scaler input",
	"invalid font scaler font data",
	"font scaler newblock failed",
	"font scaler bitmap allocation failed",
	"font scaler outline allocation failed",
	"required font scaler table missing",
	"unsupported font scaler outline format",
	"unsupported font scaler stream format",
	"unsupported font scaler font format",
	"font scaler hinting error",
	"font scaler rasterizer error",
	"font scaler internal error",
	"font scaler invalid matrix",
	"font scaler fixed overflow",
	"font scaler api version mismatch",
	
	"unknown font scaler error",
	
	
	"illegal font storage type",
	"illegal font storage reference",
	"illegal font attributes",
	"illegal font parameter",
	"font cannot be changed",
	
	
	"fragmented memory",
	"could not dispose backing store",
	"unflattening interrupted by client",
	
	nil,
	"parameter is nil",
	"shape is nil",
	"style is nil",
	"transform is nil",
	"ink is nil",
	"transferMode is nil",
	"color is nil",
	"colorProfile is nil",
	"colorSet is nil",
	"spoolProcedure is nil",
	"tag is nil",
	"type is nil",
	"mapping is nil",
	
	"parameter out of range",
	"inconsistent parameters",
	"index is less than zero",
	"index is less than one",
	"count is less than zero",
	"count is less than one",
	"contour is less than zero",
	"length is less than zero",
	
	"invalid client reference",
	"invalid graphics heap start pointer",
	"invalid nongraphic globals pointer",
	
	"colorSpace out of range",
	
	"pattern lattice out of range",
	"frequency parameter out of range",
	"tinting parameter out of range",
	"method parameter out of range",
	"space may not be indexed",
	
	"glyph index too small",
	"no glyphs added to font",
	"glyph not added to font",
	"point does not intersect bitmap",
	
	"required font table not present",
	"unknown font table format",
	
	"shapeFill not allowed",
	"inverseFill face must set clipLayer flag",
	"invalid transferMode colorSpace",
	"colorProfile must be nil",
	"bitmap pixel size must be 1",
	"empty shape not allowed",
	"ignorePlatformShape not allowed",
	"nil style in glyph not allowed",
	"complex glyph style not allowed",
	
	"cannot set item shapes to nil",
	"cannot use original item shapes when growing picture",
	"cannot add unspecified new glyphs",
	"cannot dispose locked tag",
	"cannot dispose locked shape",
	
	"graphic type does not have a structure",
	"style run array does not match number of characters",
	"rectangles cannot be inserted into",
	
	"unknown graphics heap",
	"graphics routine selector is obsolete",
	"cannot set graphics client memory without setting size",
	"graphics client memory too small",
	"graphics client memory is already allocated",
	
	"viewPort is a window",
	
	
	"illegal type for shape",
	"invalid viewDevice reference",
	"invalid viewGroup reference",
	"invalid viewPort reference",
	
	
	"no owners",
	"bad address",
	"object wrong type",
	"shape wrong type",
	"style wrong type",
	"ink wrong type",
	"transform wrong type",
	"device wrong type",
	"port wrong type",
	
	
	"shape cache wrong type",
	"style cache wrong type",
	"ink cache wrong type",
	"transform cache wrong type",
	"port cache wrong type",
	"shape cache parent mismatch",
	"style cache parent mismatch",
	"ink cache parent mismatch",
	"transform cache parent mismatch",
	"port cache parent mismatch",
	"invalid shape cache port",
	"invalid shape cache device",
	"invalid ink cache port",
	"invalid ink cache device",
	"invalid style cache port",
	"invalid style cache device",
	"invalid transform cache port",
	"invalid transform cache device",
	
	"indirect memory block too small",
	"indirect memory block too large",
	"unexpected nil pointer",
	"invalid pointer",
	"invalid seed",
	"invalid frame seed",
	"invalid text seed",
	"invalid draw seed",
	"bad private flags",
	"text bounds cache wrong size",
	"text metrics cache wrong size",
	"text index cache wrong size",
	"bitmap ptr too small",
	"bitmap ptr not aligned",
	"bitmap rowBytes negative",
	"bitmap width negative",
	"bitmap height negative",
	"invalid pixelSize",
	"bitmap rowBytes too small",
	"bitmap rowBytes not aligned",
	"bitmap rowBytes must be specified for user image buffer",
	"invalid matrix flag",
	"invalid vector count",
	"invalid contour count",
	"recursive caches",
	"glyph run count negative",
	"glyph run count zero",
	"glyph run counts do not sum to character count",
	"glyph first advance bit set not allowed",
	"glyph tangent vectors both zero",
	"layout run length negative",
	"layout run length zero",
	"layout run level negative",
	"layout run lengths do not sum to text length",
	"invalid fillShape ownerCount",
	"recursive fillShapes",
	"bad shape in picture",
	"bad style in picture",
	"bad ink in picture",
	"bad transform in picture",
	"bad shape cache in picture",
	"bad seed in picture",
	"invalid picture count",
	"bad textLayer count",
	"bad fillType in textFace",
	"bad style in textFace",
	"bad transform in textFace",
	"transform clip missing",
	"metrics wrong type",
	"metrics point size probably bad",
	"scalar block wrong type",
	"scalar block parent mismatch",
	"scalar block too small",
	"scalar block too large",
	"invalid metrics range",
	"invalid metrics flags",
	"metrics maxWidth probably bad",
	"font wrong type",
	"font wrong size",
	"invalid font platform",
	"invalid lookup range",
	"invalid lookup platform",
	"font not in font list",
	"metrics not in metrics list",
	"bad device private flags",
	"bad device attributes",
	"invalid device number",
	"invalid device viewGroup",
	"invalid device bounds",
	"invalid bitmap in device",
	"colorSet wrong type",
	"invalid colorSet viewDevice owners",
	"invalid colorSet colorSpace",
	"invalid colorSet count",
	"colorProfile wrong type",
	"invalid colorProfile flags",
	"invalid colorProfile response count",
	"backing free parent mismatch",
	"backing store parent mismatch",
	
	nil,
	"number of contours exceeds implementation limit",
	"number of points exceeds implementation limit",
	"size of polygon exceeds implementation limit",
	"size of path exceeds implementation limit",
	"size of text exceeds implementation limit",
	"size of bitmap exceeds implementation limit",
	"number of colors exceeds implementation limit",
	
	
	
	
	nil,
	"common colors not initialized",
	"no open picture",
	"picture already open",
	"no open poly",
	"poly already open",
	"no open region",
	"region already open",
	"no active picture"
};
	
	
	
static char *warningText[] =
{
	"warning stack underflow",
	"warning stack overflow",
	"notice stack underflow",
	"notice stack overflow",
	
	nil,
	"shape does not contain text",
	"shape does not contain a bitmap",
	"picture expected",
	"bitmap is not resizable",
	"shape operator may not be a bitmap",
	"shape operator may not be a picture",
	"graphic type does not contain points",
	"graphic type does not have multiple contours",
	"graphic type cannot be mapped",
	"graphic type cannot be moved",
	"graphic type cannot be scaled",
	"graphic type cannot be rotated",
	"graphic type cannot be skewed",
	"graphic type cannot be reset",
	"graphic type cannot be dashed",
	"graphic type cannot be reduced",
	"graphic type cannot be inset",
	"shape cannot be inverted",
	
	nil,
	"map shape out of range",
	"move shape out of range",
	"scale shape out of range",
	"rotate shape out of range",
	"skew shape out of range",
	"map transform out of range",
	"move transform out of range",
	"scale transform out of range",
	"rotate transform out of range",
	"skew transform out of range",
	
	nil,
	"contour out of range",
	"index out of range in contour",
	"picture index out of range",
	"color index requested not found",
	"colorSet index out of range",
	"index out of range",
	"count out of range",
	"length out of range",
	"font table index out of range",
	"font glyph index out of range",
	"font table not found",
	"font name not found",
	
	
	
	"shape access not allowed",
	"colorSet access restricted",
	"colorProfile access restricted",
	"tag access restricted",
	"viewDevice access restricted",
	
	
	"new shape contains invalid data",
	"new tag contains invalid data",
	"extra data passed was ignored",
	
	
	"unable to traverse open contour that starts or ends off th",
	"unable to draw open contour that starts or ends off the cu",
	"picture cannot contain itself",
	"viewPort cannot contain itself",
	"cannot dispose default shape",
	"cannot dispose default style",
	"cannot dispose default ink",
	"cannot dispose default transform",
	"cannot dispose default colorProfile",
	"cannot dispose default colorSet",
	"cannot set unique items attribute for a picture that alrea",
	"shape not locked",
	"tag not locked",
	"shape direct attribute not set",
	"first glyph advance must be absolute",
	
	
	"shape does not have area",
	"shape does not have length",
	"point does not intersect port",
	"cannot dispose non font",
	
	
	"character substitution took place",
	"font substitution took place",
	"union of area and length returns area only",
	"insufficient coordinate space for new device",
	
	
	"unrecognized stream version",
	"bad data in stream",
	
	
	"font scaler no output",
	"font scaler fake metrics",
	"font scaler fake linespacing",
	"font scaler glyph substitution",
	
	
	"shape passed has no bounds",
	"layer style cannot contain a face",
	"layer glyph shape cannot contain nil styles",
	"face override style font must match style",
	"tags of type flst removed",



	nil,
	"no picture drawn",
	"polygons have different size contours",
	"graphic type cannot be specifed by four values",
	"graphic type cannot be specifed by six values",
	"point expected",
	"line or rectangle expected",
	"curve expected",
	"graphic type does not contain control bits",
	"request exceeds available data",
	"extra data unread",
	"no variable length user data saved"
};



static char *noticeText[] =
{
	"parameters have no effect",
	"attributes already set",
	"caps already set",
	"color already set",
	"curve error already set",
	"dash already set",
	"default colorProfile already set",
	"default ink already set",
	"default transform already set",
	"default shape already set",
	"default style already set",
	"device clip already set",
	"dither already set",
	"end cap already set",
	"glyph positions are already set",
	"halftone already set",
	"ink already set",
	"join type already set",
	"justification already set",
	"mapping already set",
	"pattern already set",
	"pen size already set",
	"port clip already set",
	"shape geometry unaffected",
	"shape type already set",
	"start cap already set",
	"style already set",
	"tag already set",
	"tags in shape ignored",
	"transform already set",
	"transform clip already set",
	"transform mapping unaffected",
	"viewPort already in viewGroup",
	"viewDevice already in viewGroup",
	
	"shape already in primitive form",
	"shape already in simple form",
	"shape already broken",
	"shape already joined",
	"cache already cleared",
	
	"shape not disposed",
	"style not disposed",
	"ink not disposed",
	"transform not disposed",
	"colorSet not disposed",
	"colorProfile not disposed",
	"font not disposed",
	
	"glyph tangents have no effect",
	"glyph positions determined by advance",
	"transform viewPorts already set",
	
	"directShape attribute set as side effect",
	"lockShape called as side effect",
	
	"disposed dead caches",
	"disposed live caches",
	"low on memory",
	"very low on memory",
	
	"transform references disposed viewPort",
	
	
	
	
	"zero length string passed"
};

	#define errorTextSize	(sizeof(errorText)/sizeof(*errorText))
	#define warningTextSize	(sizeof(warningText)/sizeof(*warningText))
	#define noticeTextSize	(sizeof(noticeText)/sizeof(*noticeText))

typedef struct {
	char		(*errorMessages)[];
	char		(*warningMessages)[];
	char		(*noticeMessages)[];
	char		*fatalErrorMessage;
	char		*errorMessage;
	char		*validationMessage;
	char		*warningMessage;
	char		*noticeMessage;
	char		*undefinedMessage;
} debugLibraryGlobals;

static debugLibraryGlobals messages = {	errorText,
								warningText, 
								noticeText,
								"FATAL GRAPHICS ERROR: ",
								"GRAPHICS ERROR: ",
								"VALIDATION ERROR: ",
								"GRAPHICS WARNING: ",
								"GRAPHICS NOTICE: ",
								"ID = $xxxx (undefined)" };
#define undefinedHexOffset 6	/* offset to "xxxx" above */

void SetGraphicsLibraryErrors(void)
{
	SetUserGraphicsWarning(DisplayGraphicsWarningMessage, (long)&messages);
	SetUserGraphicsError(DisplayGraphicsErrorMessage, (long)&messages);
}

void SetGraphicsLibraryNotices(void)
{
	SetUserGraphicsNotice(DisplayGraphicsNoticeMessage, (long)&messages);
}

static char *LookupMessage(char (*table)[], short size, short range, short IDwithinRange)
{
	register char **message = table;

	while (range--) {
		while (*message++)
			if (message-(char **) table > size)
				return nil;
	}
	while (IDwithinRange--)
		if (!*++message)
			return nil;
	return *message;
}

static char *InnerGraphicsErrorMessage(graphicsError errorID, debugLibraryGlobals *messageTables)
{
	if (errorID >= firstAppWarning)
		return nil;
	else if (errorID >= firstLibraryError)
		return LookupMessage(messageTables->errorMessages, errorTextSize, 4, errorID - firstLibraryError);
	else if (errorID >= firstImplementationLimitError)
		return LookupMessage(messageTables->errorMessages, errorTextSize, 3, errorID - firstImplementationLimitError);
	else if (errorID >= firstParameterError)
		return LookupMessage(messageTables->errorMessages, errorTextSize, 2, errorID - firstParameterError);
	else if (errorID >= firstNonfatalError)
		return LookupMessage(messageTables->errorMessages, errorTextSize, 1, errorID - firstNonfatalError);
	else if (errorID >= firstErrorNumber)
		return LookupMessage(messageTables->errorMessages, errorTextSize, 0, errorID - firstErrorNumber);
	else
		return nil;
}

char *GraphicsErrorMessage(graphicsError errorID)
{
	return InnerGraphicsErrorMessage(errorID, &messages);
}

static char *InnerGraphicsWarningMessage(graphicsWarning warningID, debugLibraryGlobals *messageTables)
{
	if (warningID >= firstAppWarning)
		return nil;
	else if (warningID >= firstLibraryWarning)
		return LookupMessage(messageTables->warningMessages, warningTextSize, 4, warningID - firstLibraryWarning);
	else if (warningID >= firstParameterOutOfRangeWarning)
		return LookupMessage(messageTables->warningMessages, warningTextSize, 3, warningID - firstParameterOutOfRangeWarning);
	else if (warningID >= firstResultOutOfRangeWarning)
		return LookupMessage(messageTables->warningMessages, warningTextSize, 2, warningID - firstResultOutOfRangeWarning);
	else if (warningID >= firstWrongTypeWarning)
		return LookupMessage(messageTables->warningMessages, warningTextSize, 1, warningID - firstWrongTypeWarning);
	else if (warningID >= firstWarningNumber)
		return LookupMessage(messageTables->warningMessages, warningTextSize, 0, warningID - firstWarningNumber);
	else
		return nil;
}

char *GraphicsWarningMessage(graphicsWarning warningID)
{
	return InnerGraphicsWarningMessage(warningID, &messages);
}

static char *InnerGraphicsNoticeMessage(graphicsNotice noticeID, debugLibraryGlobals *messageTables)
{
	if (noticeID >= firstAppNotice)
		return nil;
	else if (noticeID >= firstLibraryNotice)
		return LookupMessage(messageTables->noticeMessages, noticeTextSize, 1, noticeID - firstLibraryNotice);
	else if (noticeID >= firstNoticeNumber)
		return LookupMessage(messageTables->noticeMessages, noticeTextSize, 0, noticeID - firstNoticeNumber);
	else
		return nil;
}

char *GraphicsNoticeMessage(graphicsNotice noticeID)
{
	return InnerGraphicsNoticeMessage(noticeID, &messages);
}

static char *HexToAscii(register long value, char *str, register short digits)
{
	register char *end = str + digits;
	register char *p = end;

	while (--digits >= 0) {
		register char nibble = '0' + (value & 0x0F);
		if (nibble > '9') nibble += 'A' - '9' - 1;
		*--p = nibble;
		value >>= 4;
	}
	return end;
}

static void DisplayMessage(char *signalClass, long id, char *signalText, debugLibraryGlobals *messageTables)
{
	char debugString[255];
	register char *dst = debugString + 1;
	register char *src;
	char *hexPosition;

	src = signalClass;
	while (*dst++ = *src++) ;
	--dst;

	src = signalText;
	if (src == nil) {
		src = messageTables->undefinedMessage;
		hexPosition = dst + undefinedHexOffset;
	}
	while (*dst++ = *src++) ;
	*--dst = '.';
	if (signalText == nil)
		HexToAscii((unsigned long) id, hexPosition, 4);

	debugString[0] = dst - debugString;
	DebugStr((void *) debugString);
}

void DisplayGraphicsErrorMessage(graphicsError errorID, long context)
{
	char buffer[255];
	long thing;
	long argNum;
	debugLibraryGlobals *messageTables = (debugLibraryGlobals *)context;
	
	if (errorID == fragmented_memory)
		return;
	if (GetValidationError(nil, (void **)&thing, &argNum)) {
		char *walker = buffer;
		char *copy = messageTables->validationMessage;
		
		while (*walker = *copy++)
			++walker;
		GetValidationError(walker, nil, nil);
		while (*walker)
			++walker;
		*walker++ = '(';
		*walker++ = '0';
		*walker++ = 'x';
		HexToAscii(thing, walker, 8);
		walker += 8;
		*walker++ = ')';
		*walker++ = ' ';
		*walker = 0;
		DisplayMessage(buffer, errorID, InnerGraphicsErrorMessage(errorID, messageTables),
					messageTables);
	} else
		DisplayMessage((errorID >= firstFatalError && errorID <= lastFatalError) ? 
			messageTables->fatalErrorMessage : messageTables->errorMessage,
			errorID, InnerGraphicsErrorMessage(errorID, messageTables), messageTables);
}

void DisplayGraphicsWarningMessage(graphicsWarning warningID, long context)
{
	debugLibraryGlobals *messageTables = (debugLibraryGlobals *)context;

	DisplayMessage(messageTables->warningMessage, warningID,
				InnerGraphicsWarningMessage(warningID, messageTables), messageTables);
}

void DisplayGraphicsNoticeMessage(graphicsNotice noticeID, long context)
{
	debugLibraryGlobals *messageTables = (debugLibraryGlobals *)context;

	DisplayMessage(messageTables->noticeMessage, noticeID,
		InnerGraphicsNoticeMessage(noticeID, messageTables), messageTables);
}
