/* graphics libraries:
	picture library
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#include "graphics libraries.h"
#include "math routines.h"


void AddToPicture(shape picture, shape newShape, style newStyle, ink newInk, transform newTransform)
{
	SetPictureParts(picture, 0, 0, 1, &newShape, &newStyle, &newInk, &newTransform);
}

void InsertPictureItem(shape picture, long index, shape newShape, style newStyle, ink newInk, transform newTransform)
{
	SetPictureParts(picture, index, 0, 1, &newShape, &newStyle, &newInk, &newTransform);
}

shape GetPictureItem(shape picture, long index, shape *destShape, style *destStyle, ink *destInk, transform *destTransform)
{
	shape tempShape;

	if( destShape == nil )
		destShape = &tempShape;

	if( GetPictureParts(picture, index, 1, destShape, destStyle, destInk, destTransform) )
		return *destShape;

	return nil;
}

void SetPictureItem(shape picture, long index, shape newShape, style newStyle, ink newInk, transform newTransform)
{
	SetPictureParts(picture, index, 1, 1, &newShape, &newStyle, &newInk, &newTransform);
}
