/* graphics libraries:
	user library
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#include "graphics libraries.h"


void DisposeTagAt(tag *oldTag)
{
	NilParamReturn(oldTag);
	if (*oldTag) {
		DisposeTag(*oldTag);
		*oldTag = nil;
	}
}

void AddShapeUser(shape source, const void *data, long length, long type)
{
	tag tempItem;

	tempItem = NewTag(type, length, data);
	SetShapeTags(source, 0, 0, 0, 1, &tempItem);
	DisposeTag(tempItem);
}

long GetShapeUser(shape source, void *data, long *length, long requestedType, long *foundType, long index)
{
	if( length )
		*length = 0;

	if( index )
	{
		tag tempItem;

		if( GetShapeTags(source, requestedType, index, 1, &tempItem) )
		{
			register long tempLength;

			tempLength = GetTag(tempItem, foundType, data);
			if( length )
				*length = tempLength;
			return index;
		}

		return 0;
	}
	else
		return GetShapeTags(source, requestedType, 1, selectToEnd, nil);
}

void RemoveShapeUser(shape source, long type, long index)
{
	register long count = 1;

	if( index == 0 )		/* remove all user items of the specified type */
	{
		count = selectToEnd;
		index = 1;
	}

	SetShapeTags(source, type, index, count, 0, nil);
}
