/* ------------------------------------------------------------------------------

FILENAME
	PrintingLibraries.h

DESCRIPTION
		This file defines interfaces to the Printing libraries.
	
COPYRIGHT
	  Apple Computer, Inc. 1990-1993
	 All rights reserved. 
	
-------------------------------------------------------------------------------- */

#ifndef __PRINTINGMANAGER__
	#include <PrintingManager.h>
#endif


// collection utilities


OSErr GetCollectionItemCategory (Collection,
				  							CollectionTag,
											long tagID,
											CollectionCategory *);

OSErr SetCollectionItemCategory (Collection,
				  							CollectionTag,
											long tagID,
											CollectionCategory);

OSErr RemoveCollectionCategory (Collection,
										  CollectionCategory);

void GetCollectionItemLock (Collection,
									 CollectionTag,
									 long	tagID,
									 Boolean *isLocked);

OSErr SetCollectionItemLock (Collection,
									  CollectionTag,
									  long tagID,
									  Boolean lockIt);

OSErr AddJobItem (Job, CollectionTag, long id, long itemSize, void *itemData);
OSErr AddFormatItem (Format, CollectionTag, long id, long itemSize, void *itemData);
OSErr AddVolatileJobItem (Job, CollectionTag, long id, long itemSize, void *itemData);
OSErr AddVolatileFormatItem (Format, CollectionTag, long id, long itemSize, void *itemData);
								  

// papertype utilities


long GetPaperTypeBaseType (PaperType thePaperType);

void SetPaperTypeBaseType (PaperType thePaperType, long theBasePaperType);

OSType GetPaperTypeCreator(PaperType	thePaperType);

void SetPaperTypeCreator (PaperType thePaperType, OSType theCreator);

unsigned char GetPaperTypeUnits (PaperType thePaperType);

void SetPaperTypeUnits (PaperType thePaperType, unsigned char theUnits);

unsigned long GetPaperTypeFlags (PaperType thePaperType);

void SetPaperTypeFlags (PaperType thePaperType, unsigned long theFlags);

void GetPaperTypeComment (PaperType thePaperType, Str255 theComment);

OSErr SetPaperTypeComment (PaperType	thePaperType, Str255 theComment);

void LockFormatPaperType (Format, Boolean lockPaperType);


// job format mode utilities


PositionConstraintTableHdl GetJobFormatLineConstraint(Job, PositionConstraintTableHdl);

FontTableHdl GetJobFormatFonts(Job, FontTableHdl);

StyleNameTableHdl GetJobFormatFontCommonStyles(Job, font, StyleNameTableHdl);

PositionConstraintTableHdl GetJobFormatFontConstraint(Job, font, PositionConstraintTableHdl);

style SetStyleJobFormatCommonStyle(Job, Str255, style);


