/* graphics:	
	font library interfaces
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.
*/

#ifndef fontLibraryIncludes
#define fontLibraryIncludes

#ifndef fontTypesIncludes
	#include "font types.h"
#endif

#ifndef graphicsTypesIncludes
	#include "graphics types.h"
#endif

#ifndef fontRoutinesIncludes
	#include "font routines.h"
#endif


/*	example font descriptor tags
*/
#define weightVariationTag	0x77676874	/* 'wght' */
#define widthVariationTag		0x77647468	/* 'wdth' */
#define slantVariationTag		0x736c6e74	/* 'slnt' */
#define opticalSizeTag		0x6f70737a	/* 'opsz' */

/* weights for style matching */
/* these will have to be tweaked*/
/* this info could be in the font???*/
#define	prefwghtweighting	0x00010000
#define	prefwdthweighting	0x00020000
#define	prefslntweighting	0x00010000/*this is naturally weighted to last place*/
#define	prefcontweighting	0x00040000

typedef enum commonFontEnums {
	firstCommonFont,
	chicagoFont = firstCommonFont,
	courierFont,
	genevaFont,
	helveticaFont,
	monacoFont,
	newyorkFont,
	symbolFont,
	timesFont,
	lastCommonFont = timesFont
} commonFontEnums;


enum{noMatching = 0,
	useStyleMatching,
	useVariationsMatching,
	useTextFaceMatching= 4
	};

typedef long commonFontEnum;

font GetCommonFont(commonFontEnum);
void SetShapeCommonFont(shape, commonFontEnum);
void SetStyleCommonFont(style, commonFontEnum);

font FindCNameFont(fontName meaning, const char name[]);
font FindPNameFont(fontName meaning, const unsigned char name[]);

long FindFontCName(font fontID, fontName meaning, char name[]);
long FindFontPName(font fontID, fontName meaning, unsigned char name[]);

long FindStyleFontCName(style s, fontName meaning, char name[]);
long FindStyleFontPName(style s, fontName meaning, unsigned char name[]);
void SetStylePNamedFont(style s, const unsigned char name[]);
void SetStyleCNamedFont(style s, const char* name);

long CountFontFamilies(void);
font FindFontFamily(long index, fontPlatform platform, fontScript script, fontLanguage language,
	long nameLength, const unsigned char *name);
long CountFontStyles(font family);
font FindFontStyle(font family, long index, fontPlatform platform, fontScript script, fontLanguage language,
	long nameLength, const unsigned char *name);

void SetMatchingStyle(font targetFamily, style theStyle, long matchInfo);
style ReturnMatchingStyle(font targetFamily, style theStyle, long matchInfo);

#endif