/* graphics:
	font routines
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.
*/

#ifndef fontRoutinesIncludes
#define fontRoutinesIncludes

	#ifndef mathTypesIncludes
		#include "math types.h"
	#endif

	#ifndef fontTypesIncludes
		#include "font types.h"
	#endif

	#define GetFontName gGetFontName

	#ifdef appleInternal
		#define InlineCode(x)
	#endif
	#ifndef InlineCode
		#define InlineCode(x)	= {0x303C, x, 0xA832}
	#endif
	
	#ifdef __cplusplus
	extern "C" {
	#endif

	font NewFont(fontStorageTag storage, fontStorageReference reference, fontAttribute attributes) InlineCode(0x11D0);
	fontStorageTag GetFont(font fontID, fontStorageReference *reference, fontAttribute *attributes) InlineCode(0x11D1);
	font FindFont(fontStorageTag storage, fontStorageReference reference, fontAttribute* attributes) InlineCode(0x124C);
	void SetFont(font fontID, fontStorageTag storage, fontStorageReference reference, fontAttribute attributes) InlineCode(0x11D2);
	void DisposeFont(font fontID) InlineCode(0x11D3);
	void ChangedFont(font fontID) InlineCode(0x11D4);

	fontFormatTag GetFontFormat(font fontID) InlineCode(0x1245);
	font GetDefaultFont(void) InlineCode(0x11D5);
	font SetDefaultFont(font fontID) InlineCode(0x11D6);
	long FindFonts(font familyID, fontName name, fontPlatform platform, fontScript script, fontLanguage language,
		long length, const unsigned char text[], long index, long count, font fonts[]) InlineCode(0x11D7);
	long CountFontGlyphs(font fontID) InlineCode(0x11E3);

	long CountFontTables(font fontID) InlineCode(0x11D9);
	long GetFontTable(font fontID, long index, void* tableData, fontTableTag* tableTag) InlineCode(0x11DA);
	long FindFontTable(font fontID, fontTableTag tableTag, void* tableData, long* index) InlineCode(0x11DB);
	long GetFontTableParts(font fontID, long index, long offset, long length, void* tableData, fontTableTag* tableTag) InlineCode(0x11DC);
	long FindFontTableParts(font fontID, fontTableTag tableTag, long offset, long length, void* tableData, long* index) InlineCode(0x11DD);
	long SetFontTable(font fontID, long index, fontTableTag tableTag, long length, const void* tableData) InlineCode(0x11E6);
	long SetFontTableParts(font fontID, long index, fontTableTag tableTag, long offset, long oldLength, long newLength, const void* tableData) InlineCode(0x11E7);
	long DeleteFontTable(font fontID, long index, fontTableTag tableTag) InlineCode(0x11E8);

	long CountFontNames(font fontID) InlineCode(0x11DE);
	long GetFontName(font fontID, long index, fontName *name, fontPlatform *platform,
		fontScript *script, fontLanguage *language, unsigned char text[]) InlineCode(0x120E);
	long FindFontName(font fontID, fontName name, fontPlatform platform,
		fontScript script, fontLanguage language, unsigned char text[], long *index) InlineCode(0x11DF);
	long SetFontName(font fontID, fontName name, fontPlatform platform, fontScript script, fontLanguage language,
		long length, const unsigned char text[]) InlineCode(0x11E9);
	long DeleteFontName(font fontID, long index, fontName name, fontPlatform platform, fontScript script,
		fontLanguage language) InlineCode(0x11EA);
	fontName NewFontNameID(font fontID) InlineCode(0x126D);

	long CountFontEncodings(font fontID) InlineCode(0x11E0);
	fontPlatform GetFontEncoding(font fontID, long index, fontScript *script, fontLanguage* language) InlineCode(0x11E1);
	long FindFontEncoding(font fontID, fontPlatform platform, fontScript script, fontLanguage language) InlineCode(0x120F);
	long ApplyFontEncoding(font fontID, long index, long* length, const unsigned char text[],
		long count, unsigned short glyphs[], char was16Bit[]) InlineCode(0x11E2);

	long CountFontVariations(font) InlineCode(0x1210);
	long FindFontVariation(font, fontTableTag variationTag, fixed* minValue, fixed* defaultValue, fixed* maxValue, fontName* name) InlineCode(0x1211);
	fontTableTag GetFontVariation(font, long index, fixed* minValue, fixed* defaultValue, fixed* maxValue, fontName* name) InlineCode(0x1212);

	long CountFontInstances(font) InlineCode(0x1213);
	fontName GetFontInstance(font, long index, fontVariation variation[]) InlineCode(0x1214);
	long SetFontInstance(font fontID, long index, fontName name, const fontVariation variation[]) InlineCode(0x1215);
	long DeleteFontInstance(font fontID, long index, fontName name) InlineCode(0x1216);

	long CountFontDescriptors(font fontID) InlineCode(0x121E);
	fontTableTag GetFontDescriptor(font fontID, long index, fixed* descriptorValue) InlineCode(0x121F);
	long FindFontDescriptor(font fontID, fontTableTag descriptorTag, fixed* descriptorValue) InlineCode(0x1220);
	long SetFontDescriptor(font fontID, long index, fontTableTag descriptorTag, fixed descriptorValue) InlineCode(0x1221);
	long DeleteFontDescriptor(font fontID, long index, fontTableTag descriptorTag) InlineCode(0x1222);

	long CountFontFeatures(font fontID) InlineCode(0x124F);
	fontName GetFontFeature(font fontID, long index, fontFeatureFlag* flags, long* settingCount, fontFeatureSetting settings[], fontFeature* feature) InlineCode(0x1250);
	fontName FindFontFeature(font fontID, fontFeature feature, fontFeatureFlag* flags, long* settingCount, fontFeatureSetting settings[], long* index) InlineCode(0x1251);
	long CountFontFeatureSets(font fontID) InlineCode(0x1252);
	fontName GetFontFeatureSet(font fontID, long index, long* runCount, fontRunFeature runs[], fontFeatureSetGroup* group, fontFeatureSetFlag* flags) InlineCode(0x1253);
	long SetFontFeatureSet(font fontID, long index, fontName name, long runCount, const fontRunFeature runs[], fontFeatureSetGroup group, fontFeatureSetFlag flags) InlineCode(0x1254);
	long DeleteFontFeatureSet(font fontID, long index, fontName name) InlineCode(0x1255);

	void FlattenFont(font source, struct scalerStream* stream, struct spoolBlock* block) InlineCode(0x124D);

	#ifdef __cplusplus
	}
	#endif

	#undef InlineCode

	#ifdef MacintoshIncludes
		#undef GetFontName
	#endif

#endif
