/* graphics:
	toolbox interfaces
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/


#ifndef graphicsToolboxIncludes
	#define graphicsToolboxIncludes

	#ifndef __WINDOWS__
		#include <Windows.h>
	#endif

	#ifndef fontTypesIncludes
		#include "font types.h"
	#endif

	#ifndef graphicsTypesIncludes
		#include "graphics types.h"
	#endif

 	#ifdef appleInternal
		#define InlineCode(x)
	#endif
	#ifndef InlineCode
		#define InlineCode(x)	= {0x303C, x, 0xA832}
	#endif

	typedef void (*userViewPortFilter)(shape, viewPort, long);

	viewPort NewWindowViewPort(WindowPtr) InlineCode(0x11FA);
	viewPort GetWindowViewPort(WindowPtr) InlineCode(0x11FB);
	WindowPtr GetViewPortWindow(viewPort) InlineCode(0x11FC);

	GDHandle GetViewDeviceGDevice(viewDevice) InlineCode(0x11FD);
 	viewDevice GetGDeviceViewDevice(GDHandle) InlineCode(0x11FE);

	/* point utilities */
	void QDGlobalToFixedLocal(const Point *, point *) InlineCode(0x11FF);			/* convert from QD global space to fixed-point local space */
	void QDLocalToFixedGlobal(const Point *, viewPort, point *) InlineCode(0x1200);	/* convert from QD local space to fixed-point global space */

 	/* mouse utilities */
 	void GetGlobalMouse(point *) InlineCode(0x1201);					/* return mouse location in fixed-point global space */
	void GetViewPortMouse(viewPort, point *) InlineCode(0x1202);		/* return fixed-point local mouse (viewPort == 0 --> default) */

	/* QuickDraw PICT utilities (NOTE: InitGraf must must be called before using these routines) */
 	PicHandle ShapeToPICT(shape) InlineCode(0x1203);			/* given a shape, return a handle to a QuickDraw PICT */
 	shape PICTToShape(PicHandle) InlineCode(0x1204);			/* vice-versa */

	userViewPortFilter GetViewPortFilter(viewPort, long *) InlineCode(0x1206);
	void SetViewPortFilter(viewPort, userViewPortFilter, long) InlineCode(0x1207);
 
 	/* QD to QD GX Translator typedefs and functions */
	
	#define defaultOptionsTranslation		0x0000
	#define optimizedTranslation		 	0x0001
	#define replaceLineWidthTranslation	 	0x0002
	#define simpleScalingTranslation	 	0x0004
	#define simpleGeometryTranslation	 	0x0008	/* implies simple scaling */
	#define simpleLinesTranslation			0x000C	/* implies simple geometry & scaling */
	#define layoutTextTranslation		 	0x0010	/* turn on line layout (normally off) */
	
	typedef long translationOptions;
	
	#define	containsFormsBegin		 0x0001
	#define	containsFormsEnd		 0x0002
	#define	containsPostScript		 0x0004
	#define	containsEmptyPostScript	 0x0008
	
	typedef OSErr (*shapeSpoolFunction)(shape theShape, long reference);
	
	typedef long translatorStatistics;

	void InstallQDTranslator(GrafPtr port, translationOptions options, const Rect *srcRect, const Rect *dstRect, Point patStrech, shapeSpoolFunction userFunction, long reference) InlineCode(0x1269);

	translatorStatistics *RemoveQDTranslator(GrafPtr port, translatorStatistics *statistics) InlineCode(0x126A);

	shape ConvertPICTToShape(const PicHandle pict, translationOptions options, const Rect *srcRect, const Rect *dstRect, Point patStretch, shape destination, translatorStatistics stats) InlineCode(0x126B);

	#undef InlineCode

#endif
