/* memory manager:
	public interface definition
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#ifndef memoryDebuggingIncludes
#define memoryDebuggingIncludes

	#ifndef memoryTypesIncludes
		#include "memory types.h"
	#endif

	#ifdef appleInternal
		#ifdef insideLoader
			#define InlineCode(x)	= {0x303C, 0x0800 + x, 0xA832}
		#else
			#define InlineCode(x)
		#endif
	#endif
	#ifndef InlineCode
		#define InlineCode(x)	= {0x7000 + (x), 0xA832}
	#endif

	typedef enum {
		scrambleBlocks		= 0x01,		/* pretend that every movable block in the heap moves every time that they could */
		checkBlocks		= 0x02,		/* check blocks when they are passed to the memory manager */
		checkHeap			= 0x04,		/* check the entire heap in every memory routine */
		checkSubHeaps		= 0x08		/* check all the sub-heaps of this heap in every memory routine */
	} memoryValidationFlags;

	#ifdef __cplusplus
	extern "C" {
	#endif

	long GetHeapValidation(const heap *source) InlineCode(49);
	void SetHeapValidation(heap *target, long flags) InlineCode(50);

	void ValidateHeap(const heap *target, long flags) InlineCode(51);
	void ValidateDirectBlock(const void *block) InlineCode(52);
	void ValidateIndirectBlock(const void *block) InlineCode(53);
	void ValidateMasterPointer(const void *masterPointer) InlineCode(54);
	void ValidateBlockRange(const void *rangeStart, long length) InlineCode(55);
	void *UnscrambleMaster(const void *masterPtr) InlineCode(56);

	#ifdef appleInternal
		#ifdef debugging
			#define MasterFlip(x)	UnscrambleMaster(x)
		#else
			#define MasterFlip(x)	(x)
		#endif
	#endif


	#ifdef __cplusplus
	}
	#endif

	#undef InlineCode

#endif
