/* memory manager:
	public interface definition
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#ifndef memoryTypesIncludes
#define memoryTypesIncludes

	#ifndef privateMemMgrIncludes
		typedef struct privateHeapRecord *heap;
	
		typedef enum {
			directBlockFlag 	= 0x01,
			indirectBlockFlag 	= 0x02,
			afterFreeBlockFlag	= 0x04,
			inProgressFlag		= 0x08,		/*  indicates that the block is in progress and should be disposed if an error occurs */
			tempBusyFlag		= 0x10,
			blockTypeFlag 		= 0x80		/* set for dir and dyn; clear for free */
		} blockFlags;
	#endif

	typedef enum {
		pointerBlockType
	} blockIDs;

	typedef enum {
		directBlockType	= 0x01,
		indirectBlockType	= 0x02,
		freeBlockType		= 0x04,
		privateBlockType	= 0x08
	} blockTypes;

	#define noParent	(void *)(-1)

#endif
