/* graphics libraries:	
	offscreen support library interfaces
	by Cary Clark, Michael Fairman, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink
	Copyright 1987 - 1990 Apple Computer, Inc.	 All rights reserved.
*/

#ifndef offscreenLibraryIncludes
	#define offscreenLibraryIncludes
	
	#ifndef graphicsTypesIncludes
		#include "graphics types.h"
	#endif

	typedef struct {
		shape		draw;	/* a bitmap shape which, when drawn, will transfer the offscreen to the display */
		transform		xform;	/* a transform that will cause shapes owning it to draw offscreen. */
		viewDevice	device;	/* the offscreen viewDevice whose colorSpace, etc. you may change */
		viewPort		port;		/* the offscreen viewPort which may be placed in any transform's viewPort list */
		viewGroup	group;	/* the global space in which the viewPort and viewDevice exist */
	} offscreen;
	
	typedef struct viewPortBufferRecord **viewPortBuffer;

	/* (see the .c file for routine explanations) */
	void CreateOffscreen(offscreen *target, shape bitmapShape);
	void DisposeOffscreen(offscreen *target);
	void CopyToBitmaps(shape target, shape source);

	viewPortBuffer NewViewPortBuffer(viewPort originalPort);
	void DisposeViewPortBuffer(viewPortBuffer target);
	boolean ValidViewPortBuffer(viewPortBuffer target);
	boolean UpdateViewPortBuffer(viewPortBuffer target);
	viewPort GetViewPortBufferViewPort(viewPortBuffer source);
	shape GetViewPortBufferShape(viewPortBuffer source);
#endif
