/* graphics routines:
	quickdraw library interfaces
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#ifndef qdLibraryIncludes
	#define qdLibraryIncludes

	/* geometry conversions */
	point *ShortPointToFixed(const Point *, point *);
	Point *FixedPointToShort(const point *, Point *);
	rectangle *ShortRectToFixed(const Rect *, rectangle *);
	Rect *FixedRectToShort(const rectangle *, Rect *);
		
	/* color conversions */
	colorSet CTableToColorSet(const CTabHandle);
	CTabHandle ColorSetToCTable(const colorSet);
	
	/* pixmap/bitmap conversions */
	bitmap *ConvertFromQDBitmap(const BitMap *, bitmap *);
	BitMap *ConvertToQDBitmap(const bitmap *, BitMap *);
	shape BitMapToShape(const BitMap *);
	shape PixMapToShape(const PixMapHandle);
	shape GetPixMapShape(short resourceID);
	shape CICNToMask(CIconHandle iconH);
	shape CICNToShape(CIconHandle iconH);
	shape GetCICNMask(long resourceID);
	shape GetCICNShape(long resourceID);
#endif
