/*
**	scaler library.h	-	Interface to the routines used to call font scalers directly
**
**	Copyright 1992 Apple Computer, Inc.  All rights reserved.
*/

#ifndef	scalerLibraryIncludes
#define	scalerLibraryIncludes

#ifndef	scalerTypeIncludes
	#include "scaler types.h"
#endif

scalerError FontScalerOpen( scalerContext* context, scalerInfo* theInfo);
scalerError FontScalerNewFont( scalerContext* context, scalerFontInfo* info);
scalerError FontScalerNewVariation( scalerContext* context, long count, fontVariation variation[]);
scalerError FontScalerNewTransform( scalerContext* context, scalerTransform* trans, scalerTransformInfo* info);
scalerError FontScalerNewGlyph( scalerContext* context, scalerGlyph* glyph, scalerMetrics* fractional, scalerMetrics* device, scalerBitmap* bitImage, void* outlineData);
scalerError FontScalerStreamFont( scalerContext* context, scalerStream* stream);
scalerError FontScalerKernGlyphs( scalerContext* context, scalerKerning* kerning, point deltas[], unsigned short flags[], point locations[]);
void	CloseAllOpenFontScalers(void);

#endif