/* graphics libraries:	
	primitive flattening library routine interfaces
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#ifndef storageLibraryIncludes
	#ifndef __TYPES__
		#include <Types.h>
	#endif

	#ifndef graphicsStreamTypesIncludes
		#include "graphics stream types.h"
	#endif
		
	typedef struct {
		spoolBlock		spool;
		long			reference;
		long			position;
		long			size;
		void			*data;
		void			*userField;
	} userSpool;

	long HandleSpoolProc(spoolCommand, userSpool *);
	long FileSpoolProc(spoolCommand, userSpool *);
	
	Handle ShapeToHandle(shape);
	shape HandleToShape(Handle, long count, const viewPort portList[]);
	void ShapeToFile(shape, Str255 fileName, short vRefNum, OSType creator, OSType fileType);
	shape FileToShape(Str255 fileName, short vRefNum, long count, const viewPort portList[]);
	Handle FontToHandle(font fontID, long glyphBits[]);
	font HandleToFont(Handle source);
#endif
