#ifndef truetypeLibraryIncludes
#define truetypeLibraryIncludes

#ifndef mathTypesIncludes
	#include "math types.h"
#endif

#ifndef fontTypesIncludes
	#include "font types.h"
#endif

#ifndef graphicsTypesIncludes
	#include "graphics types.h"
#endif

#define fontHeaderTag		'head'
#define horizontalHeaderTag	'hhea'
#define indexToLocationTag	0x6c6f6361	/* 'loca' */
#define maximumProfileTag	0x6d617870	/* 'maxp' */
#define controlValueTag		0x63767420	/* 'cvt ' */
#define preProgramTag		0x70726570	/* 'prep' */
#define glyphDataTag		0x676c7966	/* 'glyf' */
#define horizontalMetricsTag	0x686d7478	/* 'hmtx' */
#define verticalMetricsTag	0x766d7478	/* 'vmtx' */
#define fontProgramTag		0x6670676d	/* 'fpgm' */
#define bitmapLocationTag	0x626c6f63	/* 'bloc' */
#define bitmapDataTag		0x62646174	/* 'bdat' */
#define glyphVariationTag		0x67766172	/* 'gvar' */
#define cvtVariationTag		'cvar'
#define accentAttachmentTag	0x61636e74	/* 'acnt' */
#define postcriptGlyphNameTag		0x706f7374	/* 'post' */
#define verticalHeaderTag	'vhea'

	typedef struct {
		short	xMin;
		short	yMin;
		short	xMax;
		short	yMax;
	} glyphBoundingBox;

void ComputeGlyphBBox(register glyphBoundingBox* bbox, const short xArray[], const short yArray[], int counter);
long GetFontGlyphData(font, long index, void* userCopy);
void SetFontGlyphData(font, long index, long length, void* data);
void SetFontGlyphShape(font fontID, long glyphIndex, shape pathOrPolygon);

/* These are experimental */
long GetFontGlyphOutline(font fontID, long glyphIndex, short* contourCount, short endPoint[], unsigned char onCurve[],
	short xCoord[], short yCoord[], short* instructionCount, unsigned char instructions[], glyphBoundingBox* bbox);
void SetFontGlyphOutline(font fontID, long glyphIndex, long contourCount, const short endPoint[], const unsigned char onCurve[],
	const short xCoord[], const short yCoord[], long instructionCount, const unsigned char instructions[], const glyphBoundingBox* bbox);

#endif

