/* graphics libraries:
	QuickDraw arc routines
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#include "qd globals.h"
#include "qd emulation.h"
#include "qd utilities.h"
#include "qd library.h"
#include "graphics libraries.h"

pascal void StdArc(GrafVerb verb, const Rect *rect, short startAngle, short arcAngle)
{
	shape qdArc;
	rectangle fixedRectangle;

	NilParamReturn(rect);
	qdArc = NewArc(ShortRectToFixed(rect, &fixedRectangle), ff(startAngle), ff(arcAngle), verb != frame);
	DrawQDShape(qdArc, verb, false, false);
	DisposeShape(qdArc);
}


pascal void FrameArc(const Rect *rect, short startAngle, short arcAngle)
{
	(*stdArcProc)(frame, rect, startAngle, arcAngle);
}


pascal void EraseArc(const Rect *rect, short startAngle, short arcAngle)
{
	(*stdArcProc)(erase, rect, startAngle, arcAngle);
}


pascal void FillArc(const Rect *rect, short startAngle, short arcAngle, const Pattern pat)
{
	SaveQDFillStyleInk
	SetStyleQDPat(qdFillStyle, qdFillInk, pat);
	(*stdArcProc)(fill, rect, startAngle, arcAngle);
	RestoreQDFillStyleInk
}


pascal void InvertArc(const Rect *rect, short startAngle, short arcAngle)
{
	(*stdArcProc)(invert, rect, startAngle, arcAngle);
}


pascal void PaintArc(const Rect *rect, short startAngle, short arcAngle)
{
	(*stdArcProc)(paint, rect, startAngle, arcAngle);
}
