/* graphics libraries:
	QuickDraw clipping
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#include "qd emulation.h"
#include "graphics libraries.h"

#define  firstShapeType  emptyType
#define  lastShapeType   pictureType

pascal void ClipRect(const Rect *visible)
{
	RgnHandle rgn;

	NilParamReturn(visible);
	rgn = NewRgn();
	SetRectRgn(rgn, visible->left, visible->top, visible->right, visible->bottom);
	SetShapeFill(rgn,evenOddFill);
	SetClip(rgn);
	DisposeRgn(rgn);
}


pascal void SetClip(RgnHandle rgn)
{
	register shapeType type;

	NilShapeReturn(rgn);
	SetTransformClip(GetShapeTransform(GetDefaultShape(pointType)), rgn);
	SetTransformClip(GetShapeTransform(GetDefaultShape(pictureType)), rgn);

	for (type = firstShapeType;  type<=lastShapeType;  type++)
		SetTransformClip(GetShapeTransform(GetDefaultShape(type)), rgn);
}


pascal void GetClip(RgnHandle rgn)
{
	NilShapeReturn(rgn);
	CopyToShape(rgn, GetTransformClip(GetShapeTransform(GetDefaultShape(pointType))));
}
