/* graphics libraries:
	QuickDraw emulation routines
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#ifndef qdEmulationIncludes
	#define qdEmulationIncludes

	#ifndef __QUICKDRAW__
		#include <QuickDraw.h>
	#endif

	#ifndef qdTextIncludes
		#include "qd text.h"
	#endif

	#define PicHandle shape
	#define PolyHandle shape
	#define RgnHandle shape

	#undef GetPixel
	#define GetPixel QDEGetPixel
	#undef DrawPicture
	#define DrawPicture QDEDrawPicture
	
	#define InitGraf QDEInitGraf
	#define SetStdProcs QDESetStdProcs

	#define FrameArc QDEFrameArc
	#define PaintArc QDEPaintArc
	#define EraseArc QDEEraseArc
	#define InvertArc QDEInvertArc
	#define FillArc QDEFillArc
	#define StdArc QDEStdArc

	#define CopyBits QDECopyBits
	#define StdBits QDEStdBits
	#define ScrollRect QDEScrollRect
	#define PlotIcon QDEPlotIcon
	#define PlotSicn QDEPlotSicn

	#define ClipRect QDEClipRect
	#define SetClip QDESetTransformClip
	#define GetClip QDEGetClip

	#define Move QDEMove
	#define MoveTo QDEMoveTo
	#define Line QDELine
	#define LineTo QDELineTo
	#define StdLine QDEStdLine

	#define FrameOval QDEFrameOval
	#define PaintOval QDEPaintOval
	#define EraseOval QDEEraseOval
	#define InvertOval QDEInvertOval
	#define FillOval QDEFillOval
	#define StdOval QDEStdOval

	#define HidePen QDEHidePen
	#define ShowPen QDEShowPen
	#define GetPenState QDEGetPenState
	#define SetPenState QDESetPenState
	#define GetPen QDEGetPen
	#define PenSize QDEPenSize
	#define PenMode QDEPenMode
	#define PenPat QDEPenPat
	#define BackPat QDEBackPat
	#define PenNormal QDEPenNormal

	#define PicComment QDEPicComment
	#define StdComment QDEStdComment
	#define StdGetPic QDEStdGetPic
	#define StdPutPic QDEStdPutPic
	#define OpenPicture QDEOpenPicture
	#define ClosePicture QDEClosePicture
	#define KillPicture QDEKillPicture

	#define FramePoly QDEFramePoly
	#define PaintPoly QDEPaintPoly
	#define ErasePoly QDEErasePoly
	#define InvertPoly QDEInvertPoly
	#define FillPoly QDEFillPoly
	#define StdPoly QDEStdPoly
	#define OpenPoly QDEOpenPoly
	#define ClosePoly QDEClosePoly
	#define KillPoly QDEKillPoly
	#define OffsetPoly QDEOffsetPoly

	#define FrameRect QDEFrameRect
	#define PaintRect QDEPaintRect
	#define EraseRect QDEEraseRect
	#define InvertRect QDEInvertRect
	#define FillRect QDEFillRect
	#define StdRect QDEStdRect

	#define NewRgn QDENewRgn
	#define OpenRgn QDEOpenRgn
	#define CloseRgn QDECloseRgn
	#define DisposeRgn QDEDisposeRgn
	#define CopyRgn QDECopyRgn
	#define SetEmptyRgn QDESetEmptyRgn
	#define SetRectRgn QDESetRectRgn
	#define RectRgn QDERectRgn
	#define OffsetRgn QDEOffsetRgn
	#define InsetRgn QDEInsetRgn
	#define SectRgn QDESectRgn
	#define UnionRgn QDEUnionRgn
	#define DiffRgn QDEDiffRgn
	#define XorRgn QDEXorRgn
	#define PtInRgn QDEPtInRgn
	#define RectInRgn QDERectInRgn
	#define EqualRgn QDEEqualRgn
	#define EmptyRgn QDEEmptyRgn

	#define FrameRgn QDEFrameRgn
	#define PaintRgn QDEPaintRgn
	#define EraseRgn QDEEraseRgn
	#define InvertRgn QDEInvertRgn
	#define FillRgn QDEFillRgn

	#define StdRgn QDEStdRgn

	#define FrameRoundRect QDEFrameRoundRect
	#define PaintRoundRect QDEPaintRoundRect
	#define EraseRoundRect QDEEraseRoundRect
	#define InvertRoundRect QDEInvertRoundRect
	#define FillRoundRect QDEFillRoundRect
	#define StdRRect QDEStdRRect

	#define InitGraf QDEInitGraf
	#define SetStdProcs QDESetStdProcs

	#define SaveQDFillStyleInk \
	{	style oldStyle = qdFillStyle; \
		ink oldInk = qdFillInk; \
		qdFillStyle = CopyToStyle(nil, oldStyle); \
		qdFillInk = CopyToInk(nil, oldInk);
	#define RestoreQDFillStyleInk \
		DisposeStyle(qdFillStyle); \
		DisposeInk(qdFillInk); \
		qdFillStyle = oldStyle; \
		qdFillInk = oldInk; \
	}

	void InitGraf(void);
	void ExitGraf(void);

	void QDSetPort(const void *);
	void SetStdProcs(QDProcs procs);

	pascal void FrameArc(const Rect *, short startAngle, short arcAngle);
	pascal void PaintArc(const Rect *, short startAngle, short arcAngle);
	pascal void EraseArc(const Rect *, short startAngle, short arcAngle);
	pascal void InvertArc(const Rect *, short startAngle, short arcAngle);
	pascal void FillArc(const Rect *, short startAngle, short arcAngle, const Pattern);
	pascal void StdArc(GrafVerb, const Rect *, short startAngle, short arcAngle);

	pascal void CopyBits(const BitMap *srcBits, const BitMap *dstBits, const Rect *srcRect, const Rect *dstRect, short mode, RgnHandle maskRgn);
	pascal void StdBits(const BitMap *srcBits, const Rect *srcRect, const Rect *dstRect, short mode, RgnHandle maskRgn);
	pascal void ScrollRect(const Rect *, short dh, short dv, RgnHandle updateRgn);
	pascal Boolean GetPixel(short x, short y);
	pascal void PlotIcon(const Rect *theRect, Handle theIcon);
	pascal void PlotSicn(const Rect *theRect, Handle theSicn, short index);

	pascal void ClipRect(const Rect *);
	pascal void GetClip(RgnHandle);
	pascal void SetClip(RgnHandle);

	pascal void MoveTo(short h, short v);
	pascal void Move(short h, short v);
	pascal void LineTo(short h, short v);
	pascal void Line(short h, short v);
	pascal void StdLine(Point newPt);

	pascal void FrameOval(const Rect *);
	pascal void PaintOval(const Rect *);
	pascal void EraseOval(const Rect *);
	pascal void InvertOval(const Rect *);
	pascal void FillOval(const Rect *, const Pattern);
	pascal void StdOval(GrafVerb, const Rect *);

	pascal void HidePen(void);
	pascal void ShowPen(void);
	pascal void GetPenState(PenState *pnState);
	pascal void SetPenState(const PenState *pnState);
	pascal void GetPen(Point *);
	pascal void PenSize(short width, short height);
	pascal void PenMode(short mode);
	pascal void PenPat(const Pattern pat);
	pascal void BackPat(const Pattern pat);
	pascal void PenNormal(void);

	pascal void PicComment(short kind, short dataSize, Handle dataHandle);
	pascal void StdComment(short kind, short dataSize, Handle dataHandle);
	pascal void StdGetPic(void *dataPtr, short byteCount);
	pascal void StdPutPic(const void *dataPtr, short byteCount);
	pascal PicHandle OpenPicture(const Rect *picFrame);
	pascal void ClosePicture(void);
	pascal void KillPicture(PicHandle);
	pascal void DrawPicture(PicHandle, const Rect *dstRect);

	pascal void FramePoly(PolyHandle);
	pascal void PaintPoly(PolyHandle);
	pascal void ErasePoly(PolyHandle);
	pascal void InvertPoly(PolyHandle);
	pascal void FillPoly(PolyHandle, const Pattern);
	pascal void StdPoly(GrafVerb, PolyHandle);
	pascal PolyHandle OpenPoly(void);
	pascal void ClosePoly(void);
	pascal void KillPoly(PolyHandle);
	pascal void OffsetPoly(PolyHandle, short dh, short dv);

	pascal void FrameRect(const Rect *);
	pascal void PaintRect(const Rect *);
	pascal void EraseRect(const Rect *);
	pascal void InvertRect(const Rect *);
	pascal void FillRect(const Rect *, const Pattern);
	pascal void StdRect(GrafVerb, const Rect *);

	pascal RgnHandle NewRgn(void);
	pascal void OpenRgn(void);
	pascal void CloseRgn(RgnHandle dstRgn);
	pascal void DisposeRgn(RgnHandle);
	pascal void CopyRgn(RgnHandle srcRgn, RgnHandle dstRgn);
	pascal void SetEmptyRgn(RgnHandle);
	pascal void SetRectRgn(RgnHandle, short left, short top, short right, short bottom);
	pascal void RectRgn(RgnHandle, const Rect *);
	pascal void OffsetRgn(RgnHandle, short dh, short dv);
	pascal void InsetRgn(RgnHandle, short dh, short dv);
	pascal void SectRgn(RgnHandle srcRgnA, RgnHandle srcRgnB, RgnHandle dstRgn);
	pascal void UnionRgn(RgnHandle srcRgnA, RgnHandle srcRgnB, RgnHandle dstRgn);
	pascal void DiffRgn(RgnHandle srcRgnA, RgnHandle srcRgnB, RgnHandle dstRgn);
	pascal void XorRgn(RgnHandle srcRgnA, RgnHandle srcRgnB, RgnHandle dstRgn);
	pascal boolean PtInRgn(Point, RgnHandle);
	pascal boolean RectInRgn(const Rect *, RgnHandle);
	pascal boolean EqualRgn(RgnHandle a, RgnHandle b);
	pascal boolean EmptyRgn(RgnHandle);

	pascal void FrameRgn(RgnHandle);
	pascal void PaintRgn(RgnHandle);
	pascal void EraseRgn(RgnHandle);
	pascal void InvertRgn(RgnHandle);
	pascal void FillRgn(RgnHandle, const Pattern);
	pascal void StdRgn(GrafVerb, RgnHandle);

	pascal void FrameRoundRect(const Rect *, short width, short height);
	pascal void PaintRoundRect(const Rect *, short width, short height);
	pascal void EraseRoundRect(const Rect *, short width, short height);
	pascal void InvertRoundRect(const Rect *, short width, short height);
	pascal void FillRoundRect(const Rect *, short width, short height, const Pattern);
	pascal void StdRRect(GrafVerb, const Rect *, short width, short height);

	/* new routines */
	pascal void FixMoveTo(fixed, fixed);
	pascal void FixMove(fixed, fixed);
	pascal void FixLineTo(fixed, fixed);
	pascal void FixLine(fixed, fixed);

	pascal void FastFrameRgn(RgnHandle);
	pascal void FastEraseRgn(RgnHandle);
	pascal void FastInvertRgn(RgnHandle);
	pascal void FastPaintRgn(RgnHandle);

	pascal void FastFrameRect(const Rect *);
	pascal void FastPaintRect(const Rect *);
	pascal void FastEraseRect(const Rect *);
	pascal void FastInvertRect(const Rect *);

	pascal void FastFramePoly(PolyHandle);
	pascal void FastErasePoly(PolyHandle);
	pascal void FastInvertPoly(PolyHandle);
	pascal void FastPaintPoly(PolyHandle);

	pascal void GetPenPat(Pattern);
	pascal void GetBackPat(Pattern);

	pascal short GetTextSize(void);
	pascal short GetTextFont(void);
	pascal short GetTextFace(void);
	pascal short GetTextMode(void);
	pascal void TextNamedFont(const Str255);
	pascal void GetTextNamedFont(Str255);
	pascal void TextPat(const Pattern);
	pascal void GetTextPat(Pattern);

	pascal void FastDrawText(const StringPtr data, short first, short len);
	pascal void FastDrawString(const StringPtr);
	pascal void FastDrawCString(const StringPtr);
	pascal void FastDrawChar(char);

	pascal void GetPictureBounds(PicHandle, Rect *);
	pascal void GetPolyBounds(PolyHandle, Rect *);
	pascal void GetRgnBounds(RgnHandle, Rect *);
	pascal void SetFullRgn(RgnHandle);

	extern const Pattern whitePat, ltGrayPat, grayPat, dkGrayPat, blackPat;
#endif
