/* graphics libraries:
	QuickDraw private global includes
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#ifndef qdGlobalsIncludes
	#define qdGlobalsIncludes

	#ifndef __QUICKDRAW__
		#include <QuickDraw.h>
	#endif
	
	#ifndef graphicsTypesIncludes
		#include "graphics types.h"
	#endif

	typedef struct {
		short visible;
		point penPosition;
		fixed spaceExtra;
		fixed charExtra;
		short textFont;
		Pattern fgPat;
		Pattern bgPat;
		Pattern txPat;
	} emulationGrafPort;

	typedef emulationGrafPort *emulationPortPtr;
	#define GrafPtr emulationPortPtr
	#define thePort gEmulationPortPtr

	extern emulationPortPtr gEmulationPortPtr;
	extern const Point oneOne;

	extern shape openPicture, openRgn, openPoly;
	extern boolean lastRgnOpClosed;
	extern shape picturePlayBack;
	extern style qdEraseStyle, qdPatternStyle, qdFillStyle, qdTextStyle;
	extern ink qdPenInk, qdFillInk, qdEraseInk, qdInvertInk, qdTextInk;
	extern shape qdLineShape, qdTextShape, qdRectShape, qdRRectShape, qdOvalShape, qdArcShape;
	extern shape qdFrameRectShape, qdPaintRectShape, qdEraseRectShape, qdInvertRectShape, qdFillRectShape;
	extern pascal void (*stdTextProc)(short count, const StringPtr textAddr, Point numer, Point denom);
	extern pascal void (*stdLineProc)(Point);
	extern pascal void (*stdRectProc)(GrafVerb, const Rect *);
	extern pascal void (*stdRRectProc)(GrafVerb, const Rect *, short ovalWidth, short ovalHeight);
	extern pascal void (*stdOvalProc)(GrafVerb, const Rect *);
	extern pascal void (*stdArcProc)(GrafVerb, const Rect *, short startAngle, short arcAngle);
	extern pascal void (*stdPolyProc)(GrafVerb, shape);
	extern pascal void (*stdRgnProc)(GrafVerb, shape);
	extern pascal void (*stdBitsProc)(const BitMap *, const Rect *srcRect, const Rect *dstRect, short mode, shape maskRgn);
	extern pascal void (*stdCommentProc)(short kind, short dataSize, Handle dataHandle);
	extern pascal short (*stdTxMeasProc)(short count, const  StringPtr textAddr, Point *numer, Point *denom, FontInfo *info);
#endif
