/* graphics libraries:
	QuickDraw lines
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#include "qd globals.h"
#include "qd emulation.h"
#include "graphics libraries.h"

pascal void FixLineTo(fixed x, fixed y)
{
	/*
	SetShape4(qdLineShape, thePort->penPosition.x, thePort->penPosition.y, x, y);
	*/

	DisposeShape(qdLineShape);
	qdLineShape = NewShape4(lineType, thePort->penPosition.x, thePort->penPosition.y, x, y);

	if( openPicture )
		SetPictureParts(openPicture, 0, 0, 1, &qdLineShape, nil, nil, nil);

	if (openPoly) {
		shape lineCopy;

		lineCopy = CopyToShape(nil, qdLineShape);
		ExtendShape(openPoly, lineCopy);
		DisposeShape(lineCopy);
	}
	if (openRgn) {
		shape lineCopy;

		lineCopy = CopyToShape(nil, qdLineShape);
		if (lastRgnOpClosed) {
			AddToShape(openRgn, lineCopy);
			lastRgnOpClosed = false;
		} else {
			ExtendShape(openRgn,lineCopy);
		}
		DisposeShape(lineCopy);
	}
	if (thePort->visible>=0)
		DrawShape(qdLineShape);
	thePort->penPosition.x = x;
	thePort->penPosition.y = y;
}


pascal void StdLine(Point newPt)
{
	FixLineTo(IntToFixed(newPt.h), IntToFixed(newPt.v));
}


pascal void FixMoveTo(fixed x, fixed y)
{
	thePort->penPosition.x = x;
	thePort->penPosition.y = y;
}


pascal void FixMove(fixed x, fixed y)
{
	thePort->penPosition.x += x;
	thePort->penPosition.y += y;
}


pascal void FixLine(fixed x, fixed y)
{
	FixLineTo(thePort->penPosition.x + x, thePort->penPosition.y + y);
}


pascal void MoveTo(short h, short v)
{
	FixMoveTo(IntToFixed(h), IntToFixed(v));
}


pascal void Move(short h, short v)
{
	FixMove(IntToFixed(h), IntToFixed(v));
}


pascal void LineTo(short h, short v)
{
	Point dstPt;
	dstPt.h = h;
	dstPt.v = v;
	(*stdLineProc)(dstPt);
}


pascal void Line(short h, short v)
{
	if (stdLineProc == StdLine)
		FixLine(IntToFixed(h), IntToFixed(v));
	else
		LineTo(FixedToInt(thePort->penPosition.x) + h, FixedToInt(thePort->penPosition.x) + v);
}
