/* graphics libraries:
	QuickDraw oval routines
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#include "qd globals.h"
#include "qd emulation.h"
#include "qd utilities.h"
#include "qd library.h"
#include "graphics libraries.h"


pascal void StdOval(GrafVerb verb, const Rect *rect)
{
	rectangle fixedRectangle;
	shape qdOval;

	NilParamReturn(rect);
	qdOval = NewOval(ShortRectToFixed(rect, &fixedRectangle));
	DrawQDShape(qdOval, verb, false, true);
	DisposeShape(qdOval);
}


pascal void FrameOval(const Rect *rect)
{
	(*stdOvalProc)(frame, rect);
}


pascal void EraseOval(const Rect *rect)
{
	(*stdOvalProc)(erase, rect);
}


pascal void FillOval(const Rect *rect, const Pattern pat)
{
	SaveQDFillStyleInk
	SetStyleQDPat(qdFillStyle, qdFillInk, pat);
	(*stdOvalProc)(fill, rect);
	RestoreQDFillStyleInk
}


pascal void InvertOval(const Rect *rect)
{
	(*stdOvalProc)(invert, rect);
}


pascal void PaintOval(const Rect *rect)
{
	(*stdOvalProc)(paint, rect);
}
