/* graphics libraries:
	QuickDraw rectangle routines
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#include "qd globals.h"
#include "qd emulation.h"
#include "qd utilities.h"
#include "qd library.h"
#include "graphics libraries.h"


pascal void StdRect(GrafVerb verb, const Rect *rect)
{
	rectangle fixedRectangle;

	NilParamReturn(rect);
	SetRectangle(qdRectShape, ShortRectToFixed(rect, &fixedRectangle));
	DrawQDShape(qdRectShape, verb, true, true);
}

pascal void FrameRect(const Rect *rect)
{
	(*stdRectProc)(frame, rect);
}

pascal void PaintRect(const Rect *rect)
{
	(*stdRectProc)(paint, rect);
}

pascal void EraseRect(const Rect *rect)
{
	(*stdRectProc)(erase, rect);
}

pascal void InvertRect(const  Rect *rect)
{
	(*stdRectProc)(invert, rect);
}

pascal void FillRect(const Rect *rect, const Pattern pat)
{
	SaveQDFillStyleInk
	SetStyleQDPat(qdFillStyle, qdFillInk, pat);
	(*stdRectProc)(fill, rect);
	RestoreQDFillStyleInk
}


pascal void FastFrameRect(const Rect *rect)
{
	NilParamReturn(rect);

	if (GetStylePen(GetShapeStyle(GetDefaultShape(rectangleType))) == 0) {
		SetShape4(qdFrameRectShape, IntToFixed(rect->left), IntToFixed(rect->top), IntToFixed(rect->right), IntToFixed(rect->bottom));
		DrawShape(qdFrameRectShape);
	} else
		(*stdRectProc)(frame, rect);
}

pascal void FastPaintRect(const Rect *rect)
{
	NilParamReturn(rect);

	SetShape4(qdPaintRectShape, IntToFixed(rect->left), IntToFixed(rect->top), IntToFixed(rect->right), IntToFixed(rect->bottom));
	DrawShape(qdPaintRectShape);
}

pascal void FastEraseRect(const Rect *rect)
{
	NilParamReturn(rect);

	SetShape4(qdEraseRectShape, IntToFixed(rect->left), IntToFixed(rect->top), IntToFixed(rect->right), IntToFixed(rect->bottom));
	DrawShape(qdEraseRectShape);
}

pascal void FastInvertRect(const Rect *rect)
{
	NilParamReturn(rect);

	SetShape4(qdInvertRectShape, IntToFixed(rect->left), IntToFixed(rect->top), IntToFixed(rect->right), IntToFixed(rect->bottom));
	DrawShape(qdInvertRectShape);
}
