/* graphics libraries:
	QuickDraw rectangle routines
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#include "qd globals.h"
#include "qd emulation.h"
#include "qd utilities.h"
#include "qd library.h"
#include "graphics libraries.h"


pascal void StdRRect(GrafVerb verb, const Rect *rect, short width, short height)
{
	rectangle myRect;
	point myPoint;
	shape qdRoundRect;

	NilParamReturn(rect);
	myPoint.x = ff(width);
	myPoint.y = ff(height);
	qdRoundRect = NewRoundRect(ShortRectToFixed(rect, &myRect), &myPoint);
	DrawQDShape(qdRoundRect, verb, false, true);
	DisposeShape(qdRoundRect);
}


pascal void FrameRoundRect(const Rect *rect, short width, short height)
{
	(*stdRRectProc)(frame, rect, width, height);
}


pascal void EraseRoundRect(const Rect *rect, short width, short height)
{
	(*stdRRectProc)(erase, rect, width, height);
}


pascal void FillRoundRect(const Rect *rect, short width, short height, const Pattern pat)
{
	SaveQDFillStyleInk
	SetStyleQDPat(qdFillStyle, qdFillInk, pat);
	(*stdRRectProc)(fill, rect, width, height);
	RestoreQDFillStyleInk
}


pascal void InvertRoundRect(const Rect *rect, short width, short height)
{
	(*stdRRectProc)(invert, rect, width, height);
}


pascal void PaintRoundRect(const Rect *rect, short width, short height)
{
	(*stdRRectProc)(paint, rect, width, height);
}