/* graphics libraries:
	QuickDraw text routines interface
	by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1991 Apple Computer, Inc.  All rights reserved.	*/

#ifndef qdTextIncludes
	#define qdTextIncludes

	#ifndef __QUICKDRAW__
		#include <QuickDraw.h>
	#endif

	#ifndef graphicsRoutinesIncludes
		#include "graphics routines.h"	/* needs to precede the #define DrawText below */
	#endif

	#undef DrawText
	#define DrawText QDEDrawText
	
	#define DrawString QDEDrawString
	#define DrawChar QDEDrawChar
	#define TextWidth QDETextWidth
	#define StringWidth QDEStringWidth
	#define CharWidth QDECharWidth
	#define MeasureText QDEMeasureText
	#define TextSize QDETextSize
	#define TextMode QDETextMode
	#define TextFace QDETextFace
	#define TextFont QDETextFont
	#define StdText QDEStdText
	#define StdTxMeas QDEStdTxMeas
	#define GetFontInfo QDEGetFontInfo
	#define SpaceExtra QDESpaceExtra
	#define CharExtra QDECharExtra

	typedef struct {
		short txFont;
		short txFace;
		short txMode;
		short txSize;
		Pattern txPat;
		short charExtra;
		short spaceExtra;
	} textState;


	pascal void DrawText(const StringPtr textBuf, short first, short len);
	pascal void DrawString(const StringPtr s);
	pascal void DrawChar(unsigned char);

	pascal short TextWidth(const StringPtr textBuf, short first, short length);
	pascal short StringWidth(const StringPtr);
	pascal short CharWidth(unsigned char);
	pascal void MeasureText(short count, const StringPtr text, short *charLocs);

	pascal void TextSize(short);
	pascal void TextFont(short);
	pascal void TextFace(short);
	pascal void TextMode(short);
	pascal void GetFontInfo(FontInfo *);

	pascal void SpaceExtra(fixed extra);
	pascal void CharExtra(fixed extra);
	pascal void GetTextState(textState *);
	pascal void SetTextState(const textState *);

	pascal void StdText(short count, const StringPtr textAddr, Point numer, Point denom);
	pascal short StdTxMeas(short count, const StringPtr textAddr, Point *numer, Point *denom, FontInfo *info);
#endif