/*	File: no kaboom.c
	
	C code for a simple printing extension.
	
	Dave Hersey
	Apple Developer Technical Support

	4/26/93	- dmh - updated to use recommended approach,
					and work around b1 shutdown bug.
	2/01/93	- dmh - created.
*/

#include <Types.h>
#include <Errors.h>
#include <Resources.h>
#include <ToolUtils.h>
#include "Messages.h"
#include "PrintingMessages.h"

// external defines for creating our a5 world.

extern long A5Size (void);
extern void A5Init (void *);


#define r_str		200
#define r_s1_idx	1
#define r_s2_idx	2
#define r_s3_idx	3
#define r_s4_idx	4

// globals

Str255	s1;
Str255	s2;
Str255	s3;
Str255	s4;

// InitGlobalData is used to initialize any global data we need to
// in our message override.  It's critical that you do things this
// way, rather than access the data in the same scope that you call
// NewMessageGlobals.  Otherwise, some compilers will generate code
// with invalid data references.

OSErr InitGlobalData()
{
	short	oldResFile;

// Initialize any global data here.

	oldResFile = CurResFile();
	UseResFile(GetMyResFile());

	GetIndString(s1, r_str, r_s1_idx);
	GetIndString(s2, r_str, r_s2_idx);
	GetIndString(s3, r_str, r_s3_idx);
	GetIndString(s4, r_str, r_s4_idx);

	UseResFile(oldResFile);
	return ResError();
}

OSErr MyStartJob(StringPtr docName, long pageCount)
{
	OSErr	err1, err2;
	
	err1 = NewMessageGlobals(A5Size(), A5Init);
	if (!err1) err1 = InitGlobalData();

	err2 = Forward_StartJob(docName, pageCount);

	if (!err2)
		err2 = err1;

	if (err2)
		DisposeMessageGlobals();

	return err2;
}

OSErr MyFinishJob()
{
	DebugStr(s1);
	DebugStr(s2);
	DebugStr(s3);
	DebugStr(s4);
	
	DisposeMessageGlobals();
	return Forward_FinishJob();
}
