unit UFailure;

{$IFC undefined Think_Pascal}
{$SETC Think_Pascal := false}
{$ENDC}

interface

	uses
		Errors, Memory, Types, Resources, 
{$IFC not Think_Pascal}
		IntEnv, 
{$ENDC}
		SegLoad;


	procedure FailOSErr (error: OSErr);

	procedure FailNIL (thePtr: univ Ptr);

	procedure FailNILResource (theResource: univ Ptr);

	procedure FailResError;

	procedure Assert (condition: Boolean);

	procedure ExitProgram;

implementation

	procedure ExitProgram;
	begin
  {$IFC Think_Pascal}
		Writeln('Press mouse button to exit.');
		repeat
		until Button;
		ExitToShell;
  {$ELSEC}
		if IEStandalone then
			ExitToShell
		else
			IEExit(1);
  {$ENDC}
	end;

	procedure ReportError (error: OSErr);
	begin
		Writeln('### OS error: ', error : 1);
		ExitProgram;
	end;

	procedure FailOSErr (error: OSErr);
	begin
		if error <> noErr then
			ReportError(error);
	end;

	procedure FailNIL (thePtr: univ Ptr);
	begin
		if thePtr = nil then
			FailOSErr(memFullErr);
	end;

	procedure FailNILResource (theResource: univ Ptr);
	begin
		if theResource = nil then
			FailOSErr(ResError);
	end;

	procedure FailResError;
	begin
		FailOSErr(ResError);
	end;

	procedure Assert (condition: Boolean);
	begin
		if not condition then
			begin
				Writeln('### Assertion Failed.');
				ExitProgram;
			end;
	end;

end.