/* file: BigEasy2.h
 *
 * Started 4 July 1989, more or less.
 *
 * A set of routines to allow the quick development
 * of simple Macintosh applications.
 *
 */

/************************************
* Simple things
************************************/

typedef char s8;
typedef unsigned char u8;
typedef short s16;
typedef unsigned short u16;
typedef long s32;
typedef unsigned long u32;

typedef s16 boolean;
typedef s16 (*FP)();		/* Integer Function Pointer */

#define nil (0L)

/************************************
* Major BigEasy2 Structures
************************************/

typedef struct tSubwindow
	{
	boolean vUsed;
	FP vUpdateProc;
	FP vClickProc;
	s16 vOwner;
	Rect vRect;
	boolean vRelTop;					/* top relative to window size?		*/
	boolean vRelLeft;					/* left relative to window size?		*/
	boolean vRelBottom;					/* bottom relative to window size?		*/
	boolean vRelRight;					/* right relative to window size?		*/
	boolean vScrollerV;					/* has V scroll bar?					*/
	boolean vScrollerH;					/* has H scroll bar?					*/
	s16 vScrollBottom;					/* Maximum down scroll				*/
	s16 vScrollRight;					/* Maximum right scroll				*/
	s32 vRefcon;						/* User number					*/
	} tSubwindow;

typedef struct tWindowObject
	{
	boolean wUsed;						/* is this object used (in BigEasy's list)?	*/
	boolean wGrowable;
	FP wUpdateProc;
	FP wClickProc;
	FP wKeyProc;
	FP wGoAwayProc;
	FP wActivateProc;
	FP wDeactivateProc;
	FP wLoopyProc;
	tSubwindow **wSubwindowsH;
	s16 wSubwindowCount;
	WindowPeek wWindow;
	} tWindowObject;

/************************************
* BigEasy2 Global Variables
************************************/
#ifdef BigEasy2
	#define VAR
#else
	#define VAR extern
#endif

VAR boolean gQuitApp;
VAR boolean gMenuNeedsCmdKey;
VAR Rect gBigRect;

/************************************
* Major BigEasy2 Routines
************************************/

void InstallWindow(s16 iNum,s8 *iTitle,Rect *iRect,s16 iType,s16 iGrow,
		FP iUpdate,FP iClick,FP iKey,FP iGoAway,
		FP iActivate,FP iDeactivate,FP iLoopy);

void InstallSubwindow(s16 wNum,s16 iNum,Rect *iRect,s32 iRefcon,
		FP iUpdateProc,FP iClickProc);

void BringToFront(s16);
void InvalSubport(s16 wNum,s16 iNum);
void InvalSubports(s16 wNum,s32 ref);

void InstallMenu(char s[],FP action,s16 ref);
void InstallItem(char s[],FP action,s16 ref);
void SetMenuItem(s16 ref,boolean enable,boolean isMarked,char mark,char s[]);
void SetSubport(s16 wNum,s16 aSub,Rect *r);
void GetWindowRect(s16 n,Rect *r);

void FailNil(long);

/************************************
* Minor BigEasy2 Hacks
************************************/
#ifndef BigEasy2
	#define FailNil(x)	FailNil((long)(x))			/* Simulate a typeless call			*/
#endif