/* file: BigEasyTextish.c
 *
 * Started 13 July 1989, more or less.
 *
 * A set of routines for converting and
 * displaying textish things on the Mac.
 *
 */



/************************************
* Inclusions
************************************/

#include "colortoolbox.h"
#include "EventMgr.h"
#include "MenuMgr.h"
#include "BigEasy2.h"
#include "BigEasyTextish.h"


/************************************
* Limits
************************************/

/************************************
* Types and globals
************************************/
static char dHexChars[] = "0123456789ABCDEF";
s16 gLeftMargin = 5;
s16 gLineHeight = 10;

/************************************
* Prototypes
************************************/

/************************************
* Routines
************************************/
void AnyBaseToPString(n,b,f,c)
/*
  * Convert 32 bit number n to
  *  string c, in number base b.
  * f is the format: 0 - any length signed
  * positive: unsigned with leading zeros
  * to width f.
  */
	s32 n;
	s16 b,f;
	char *c;
	{
	register s16 charCount;
	register char *w;
	register u32 x;				/* unsigned number for divs	*/

	if(b<2 || b>16)				/* a ridiculous number base?	*/
		{
		c[0] = 0;				/* mark as empty string		*/
		return;				/* bye.					*/
		}

	if(f == 0)
		{
		charCount = 1;			/* initially, 1 char long		*/

		if(n < 0)				/* number negative?		*/
			{
			charCount++;		/* one more char			*/
			n = -n;			/* make it positive			*/
			c[1] = '-';			/* drop in a minus sign		*/
			}

		x = n;				/* find out how many digits	*/
		while(x /= b)
			charCount++;

		c[0] = charCount;		/* number of digits, plus sign	*/
		w = c+c[0];			/* we'll walk backwards		*/
		x = n;
		do
			{
			*w-- = dHexChars[x%b];
			x /= b;
			} while(x);
		}
	}

void DrawNum(n)
/*
  * Draw number n as a signed long, in decimal
  */
	s32 n;
	{
	char c[30];

	NumToString(n,c);
	DrawString(c);
	}

void DrawCString(c)
/*
  * Draw a c-string, (convert to p string).
  */
	char *c;
	{
	char p[256];
	register s16 i;
	register char *w1,*w2;

	w1 = c;
	w2 = p+1;
	i = 0;
	while(*w2++ = *w1++)
		i++;
	p[0] = i;
	DrawString(p);
	}

void DrawCR()
/*
  * Bump penposition down a line, to
  * gLeftMargin, and +gLineHeight.
  */
	{
	Point p;

	GetPen(&p);
	p.h = gLeftMargin;
	p.v += gLineHeight;
	MoveTo(p.h,p.v);
	}



