/************************************************************

Created: Thursday, March 23, 1989 at 7:25 PM by Jean-Charles Mourey
    QuickDraw32Bit.h
    C Interface to the Macintosh Libraries


    Copyright Apple Computer, Inc.  1985-1989
    All rights reserved

************************************************************/


#ifndef __QuickDraw32Bit__
#define __QuickDraw32Bit__

#ifndef __QUICKDRAW__

#endif

/* New Constants for 32-Bit QuickDraw */

#define ditherCopy 64			/* Dither mode for Copybits */
#define RGBDirect 16			/* 16 & 32 bits/pixel pixelType value */


/* New error codes */

#define rgnOverflowErr -147		/* Region accumulation failed. Resulting region may be currupt */
#define pixmapTooDeepErr -148	/* Pixmap is not 1-bit/pixel for BitmapToRegion */
#define insufficientStackErr -149 /* QuickDraw could not complete the operation */
#define cDepthErr -157			/* invalid pixel depth passed to NewGWorld or UpdateGWorld */


/* Flag bits passed to or returned by Offscreen routines */

enum  {
	pixPurgeBit = 0,
	noNewDeviceBit = 1,
	pixelsPurgeableBit = 6,
	pixelsLockedBit = 7,

	mapPixBit = 16,			/* set if color table mapping occurred */
	newDepthBit = 17,			/* set if pixels were scaled to a different depth */
	alignPixBit = 18,			/* set if pixels were realigned to screen alignment */
 	newRowBytesBit = 19,		/* set if pixmap was reconfigured in a new rowBytes */
	reallocPixBit = 20,		/* set if offscreen buffer had to be reallocated */
	clipPixBit = 28,			/* set if pixels were or are to be clipped */
	stretchPixBit = 29,		/* set if pixels were or are to be stretched/shrinked */
	ditherPixBit = 30,
	gwFlagErrBit = 31
};

typedef enum {
	pixPurge = 1 << pixPurgeBit,
	noNewDevice = 1 << noNewDeviceBit,
	pixelsPurgeable = 1 << pixelsPurgeableBit,
	pixelsLocked = 1 << pixelsLockedBit,
	mapPix = 1 << mapPixBit,
	newDepth = 1 << newDepthBit,
	alignPix = 1 << alignPixBit,
	newRowBytes = 1 << newRowBytesBit,
	reallocPix = 1 << reallocPixBit,
	clipPix = 1 << clipPixBit,
	stretchPix = 1 << stretchPixBit,
	ditherPix = 1 << ditherPixBit,
	gwFlagErr = 1 << gwFlagErrBit
}GWorldFlag;

typedef long GWorldFlags;

/* Type definition of a GWorldPtr */

typedef CGrafPtr GWorldPtr;


#ifdef __safe_link
extern "C" {
#endif

pascal OSErr BitmapToRegion(RgnHandle region, BitMap *bMap)
	= {0xA8D7};


pascal QDErr NewGWorld (GWorldPtr *offscreenGWorld, short pixelDepth,
		Rect *boundsRect, CTabHandle cTable, GDHandle aGDevice, GWorldFlags flags)
	= {0x7000,0xAB1D};
pascal Boolean LockPixels (PixMapHandle pm)
	= {0x7001,0xAB1D};
pascal void UnlockPixels (PixMapHandle pm)
	= {0x7002,0xAB1D};
pascal GWorldFlags UpdateGWorld (GWorldPtr *offscreenGWorld, short pixelDepth,
		Rect *boundsRect, CTabHandle cTable, GDHandle aGDevice, GWorldFlags flags)
	= {0x7003,0xAB1D};
pascal void DisposeGWorld (GWorldPtr offscreenGWorld)
	= {0x7004,0xAB1D};
pascal void GetGWorld (CGrafPtr *port, GDHandle *gdh)
	= {0x7005,0xAB1D};
pascal void SetGWorld (CGrafPtr port, GDHandle gdh)
	= {0x7006,0xAB1D};
pascal void CTabChanged (CTabHandle ctab)
	= {0x7007,0xAB1D};
pascal void PixPatChanged (PixPatHandle ppat)
	= {0x7008,0xAB1D};
pascal void PortChanged (GrafPtr port)
	= {0x7009,0xAB1D};
pascal void GDeviceChanged (GDHandle gdh)
	= {0x700A,0xAB1D};
pascal void AllowPurgePixels (PixMapHandle pm)
	= {0x700B,0xAB1D};
pascal void NoPurgePixels (PixMapHandle pm)
	= {0x700C,0xAB1D};
pascal GWorldFlags GetPixelsState (PixMapHandle pm)
	= {0x700D,0xAB1D};
pascal void SetPixelsState (PixMapHandle pm, GWorldFlags state)
	= {0x700E,0xAB1D};
pascal Ptr GetPixBaseAddr (PixMapHandle pm)
	= {0x700F,0xAB1D};
pascal QDErr NewScreenBuffer (Rect *globalRect, Boolean purgeable, GDHandle *gdh,
		PixMapHandle *offscreenPixMap)
	= {0x7010,0xAB1D};
pascal void DisposeScreenBuffer (PixMapHandle offscreenPixMap)
	= {0x7011,0xAB1D};
pascal GDHandle GetGWorldDevice (GWorldPtr offscreenGWorld)
	= {0x7012,0xAB1D};
#ifdef __safe_link
}
#endif


#endif