/*******************************************************************************
*
* File:   MDemoDialogs.cp
*
* Description: Main Program
*
*
* Copyright  1988 - 1990 by Apple Computer, Inc. All rights reserved.
********************************************************************************/

#include <UMacApp.h>
#include <UPrinting.h>
#include <UGridView.h>
#include <UTEView.h>
#include <UDialog.h>

#ifndef __UDEMODIALOGS__
#include "UDemoDialogs.h"
#endif

void main()
{
	TTestApplication *gTestApplication;					// The application object

	InitToolBox();										// Essential toolbox and utilities
														//	initialization
	if (ValidateConfiguration(&gConfiguration)) {		// Make sure we can run

		// Continue with remainder of initialization
		InitUMacApp(12);								// Initialize MacApp; 12 calls to MoreMasters

		// ------------------------------------------------------
		// If you are going to use streams for debugging IO then:
		// #include <stdio.h>
		// #include <iostream.h>
		// and execute the following line since MacApp's debug output is essentialy "printf"s

		// cout.sync_with_stdio();

		InitUTEView();
		InitUDialog();
		InitUGridView();

		gTestApplication = new TTestApplication;		// Allocate a new application object
		FailNIL(gTestApplication);
		gTestApplication->ITestApplication(kFileType);	// Initialize that new object
		gTestApplication->Run();						// Run the application.
	} else
		StdAlert(phUnsupportedConfiguration);
}
