/************************************************************************
 *
 *  Function:		BuildISO.h
 *
 *  Purpose:		collect all the constants specific to building
 *					this bizzare little puppy.
 *
 *	Copyright 1990 Apple Computer, Inc.  All rights reserved.
 *
 ************************************************************************/
#define	LSBPATH		0x00000012L		/* location of the lsb path table */
#define	MSBPATH		0x00000013L		/* location of the msb path table */

#define	DIRECTORY	0x00000014L		/* location of directory table */
#define PATHTBLSIZE	0x0000000AL		/* size of each of the path tables */

#define DATASTART	0x00000015L		/* where the first data file starts */

	/* round up to the next CDBLKSIZE boundary */
#define ROUND_UP(x)	((x) + CDBLKSIZE -1) & ~(CDBLKSIZE-1)

/* defined in "BuildISO.c" */
extern OSErr	CreatePVD(short);
extern OSErr	CreateVDT(short);
extern void		DumpPVD(PVD *);
extern void		DumpDirRcd(DirRcd *);
extern void		DumpAppleExtension(AppleExtension *);
extern OSErr	CreatePathTable(short);
extern void		CreateFiles(short);
extern void		CreateDirRcd(DirRcd *, StringPtr, long, long, short, long, long, short);
extern void		AddOldAppleExtensions(DirRcd *, long, long, short);
extern void		AddAppleExtensions(DirRcd *, long, long, short);
extern void		CopyDirRcdToBuffer(DirRcd *, char *);
extern OSErr	CopyRsrcFork(short, StringPtr, short, long, long);
extern OSErr	CopyDataFork(short, StringPtr, short, long, long);
extern void		CreateFile(short);
extern void		CreateAVolume(void);

extern Str255	nullStr;
/* defined in "i/o.c" */
extern OSErr	isoOpen(StringPtr, short *);
extern OSErr	isoRead(short, Ptr, long, long);
extern OSErr	isoWrite(short, Ptr, long, long);
extern OSErr	ZeroDisk(short);
extern short	GetDriveNumber(short);

#include "support.h"

#include "mydialog.h"

/* defined in ErrorMsg.h */
void ErrorMsg(...);
