/*
** Demonstration rez input file for ISO 9660 builder.
** To build the resources for this program, enter the command
**    rez iso9660.r -i {rincludes}  -o iso9660..rsrc -c 'RSED' -t 'rsrc'
**
** Copyright  1990 Apple Computer, Inc.
*/

#include "types.r"
#include "systypes.r"

type '9660' {pstring;};

type 'TEXT' {string;};

resource 'DITL' (128) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{152, 128, 173, 228},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 101, 26, 259},
		StaticText {
			disabled,
			"ISO 9660 Demo Builder"
		},
		/* [3] */
		{31, 105, 48, 253},
		StaticText {
			disabled,
			"Author: Brian Bechtel"
		},
		/* [4] */
		{56, 23, 135, 331},
		StaticText {
			disabled,
			"Version 1.0. This demonstration program is copyright  1990 Apple Computer, Inc.  "
			"Please select help for further information."
		}
	}
};


resource 'DITL' (256) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{72, 24, 92, 83},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{72, 96, 92, 156},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{48, 24, 64, 258},
		EditText {
			enabled,
			"Your Name Here"
		},
		/* [4] */
		{8, 24, 40, 256},
		StaticText {
			disabled,
			"^0"
		}
	}
};

resource 'DITL' (257) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{106, 134, 126, 194},
		Button {
			enabled,
			"Cancel"
		},
		/* [2] */
		{104, 37, 124, 97},
		Button {
			enabled,
			"OK"
		},
		/* [3] */
		{6, 59, 87, 237},
		StaticText {
			enabled,
			"Really format volume ^0?  \n"
			"This will destroy all data currently on this disk."
		},
		/* [4] */
		{6, 17, 38, 49},
		Icon {
			enabled,
			1
		}
	}
};

resource 'DITL' (258) {
	{	/* array DITLarray: 1 elements */
		/* [1] */
		{17, 36, 96, 180},
		StaticText {
			enabled,
			"Please insert a 800K floppy disk to be formatted as an ISO 9660 volume."
		}
	}
};

resource 'DLOG' (257) {
	{40, 40, 184, 280},
	dBoxProc,
	visible,
	noGoAway,
	0x0,
	257,
	"Verify Destruction"
};

resource 'DLOG' (258) {
	{40, 40, 148, 256},
	altDBoxProc,
	visible,
	goAway,
	0x0,
	258,
	"Prompt for a floppy"
};
resource 'DITL' (129) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{94, 79, 114, 139},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 16, 76, 209},
		StaticText {
			disabled,
			"^0^1^2^3"
		}
	}
};

data 'DITL' (1001, "help", purgeable) {
	$"0002 0000 0000 00EE 00C3 0102 00FF 0402"            /* ............... */
	$"4F4B 0000 0000 000B 0194 00E1 01A4 8002"            /* OK........... */
	$"0000 0000 0000 000B 000F 00E1 0195 8002"            /* .............. */
	$"0001"                                               /* .. */
};

resource 'DLOG' (256) {
	{78, 124, 180, 406},
	altDBoxProc,
	visible,
	noGoAway,
	0x0,
	256,
	"AskForVolume"
};

resource 'DLOG' (1001, "Help") {
	{34, 42, 305, 472},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	1001,
	"Help"
};

resource 'MENU' (128) {
	128,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About iso9660...", noIcon, noKey, noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (129) {
	129,
	textMenuProc,
	0x7FFFFFFB,
	enabled,
	"File",
	{	/* array: 8 elements */
		/* [1] */
		"Help", noIcon, "H", noMark, plain,
		/* [2] */
		"Specify files for root", noIcon, noKey, noMark, plain,
		/* [3] */
		"-", noIcon, noKey, noMark, plain,
		/* [4] */
		"Quit", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (130) {
	130,
	textMenuProc,
	0x7FFFFFFC,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Undo", noIcon, "Z", noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain,
		/* [3] */
		"Cut", noIcon, "X", noMark, plain,
		/* [4] */
		"Copy", noIcon, "C", noMark, plain,
		/* [5] */
		"Paste", noIcon, "V", noMark, plain,
		/* [6] */
		"Clear", noIcon, noKey, noMark, plain
	}
};

resource 'ICN#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 0000 0000 0000 0000 007F 0000"
		$"01D5 E000 06AA B000 0D55 5800 1AAA AC00"
		$"3555 5600 2AAA AB00 557F 5500 6AC1 AB80"
		$"D59C D5C0 AB3E 6AC0 D571 55C0 AB61 6AC0"
		$"D561 3FC0 AB22 40C0 D59C 8040 6AC1 3020"
		$"5561 C81E 2ABE 3F8E 3556 300E 1AAB 000E"
		$"0D55 800E 06AA C00E 03D5 FFCE 00FF E03E"
		$"003F 80",
		/* [2] */
		$"0000 0000 0000 0000 0000 0000 007F 0000"
		$"01FF E000 07FF F000 0FFF F800 1FFF FC00"
		$"3FFF FE00 3FFF FF00 7FFF FF00 7FFF FF80"
		$"FFFF FFC0 FFFF FFC0 FFFF FFC0 FFFF FFC0"
		$"FFFF FFC0 FFFF FFC0 FFFF FFC0 7FFF FFE0"
		$"7FFF FFFE 3FFF FFFE 3FFF FFFE 1FFF FFFE"
		$"0FFF FFFE 07FF FFFE 03FF FFFE 00FF E03E"
		$"003F 80"
	}
};

resource 'BNDL' (128) {
	'9660',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		}
	}
};

resource '9660' (0) {
	"ISO 9660 floppy builder 1.0  1990 Apple Computer, Inc."
};

resource 'FREF' (128) {
	'APPL',
	0,
	""
};

resource 'ALRT' (128, purgeable) {
	{58, 76, 248, 420},
	128,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'ALRT' (129) {
	{66, 84, 214, 316},
	129,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'TEXT' (1001, "help text") {
	"ISO 9660 floppy builder\n\n"
	"a demonstration program for building ISO 9660 format disks.\n\n"
	"The ISO 9660 floppy builder builds disks conforming to the international standard "
	"ISO 9660 Information processing  "
	"Volume and file structure of CD-ROM for information interchange.  "
	"This program has a number of features.  They are listed below.  "
	"The bracketed number after each feature indicates the section in the ISO 9660 document "
	"that describes this feature.\n\n"
	"	Assumes that the logical sector size is 2048 [6.1.2]\n"
	"	Assumes that the logical block size is 2048 [6.2.2]\n"
	"	Writes a primary volume descriptor [8.4]\n"
	"	Writes a volume descriptor set terminator [8.3]\n"
	"	supports the Apple Extensions to ISO 9660 (documented in a separate paper "
	"available from Apple Computer as part of Apple Technical Report 16, "
	"available from the Apple Computer Library.)\n"
	"	allows the user to specify a volume name.  "
	"The volume name is automatically converted to the proper character subset [8.4.6]\n"
	"	lets the user choose, via a standard file dialog, files to be added to the ISO 9660 disk.  "
	"All files are currently in the root directory.\n"
	"	both the resource fork and data fork of a file are copied to the disk.  "
	"The resource fork is stored as the associated file.\n"
	"	currently doesnt allow more than one logical sector of directory records.\n\n"
	"The ISO 9660 floppy builder is a demonstration program; it doesnt do many of the difficult parts "
	"of building an ISO 9660 format disk.  Specifically, it doesnt support:\n\n"
	"	sub-directories (folders)\n"
	"  keeping the files in a directory in alphabetical order\n"
	"	a main directory whose total size exceeds 1 block of 2048 bytes.\n\n"
	"This program does not build subdirectories, and does not alphabetize the file names"
	"you must keep track of their order yourself. \n\n"
	"Start with a formatted blank floppy or hard disk.  We will unmount the disk as "
	"part of the process of making it into a ISO 9660 format disk.  All data will be "
	"lost from the disk specified.\n\n"
	"Select Specify Files for Root to put files into the root directory.\n\n"
	"Youll be asked for the names of the files to be copied over via a standard file dialog.  "
	"When youre done selecting file names, hit the cancel button.\n\n\0x00"
};

resource 'vers' (1) {
	0x1,
	0x0,
	0x0,
	0x0,
	verUs,
	"1.0",
	"1.0  1990 Apple Computer, Inc."
};

