/**********************************Comment*****************************************
 * because C++ calls new and delete inside of constructors (unnecessarily, near as I 
 * can figure), we declare do nothing versions of global operator new and global 
 * operator delete here, so the linker doesn't barf.  Note: we have to use the "mangled"
 * name because CFront has that name, and uses it to call global new/delete.
 **********************************End Comment************************************/

#ifdef __cplusplus
extern "C" {
#endif



#include <Memory.h>

/* unmangle __nw__FUi
 * Unmangled symbol: operator new(unsigned int)
 * We return a void * because new returns a pointer.	*/
void *__nw__FUi(unsigned int size)		
{													
	Ptr ptr;

	ptr = NewPtrSys(size);
	return ptr;
}
/* unmangle __dl__FPv
 * Unmangled symbol: operator delete(void *)
 * We return void just for clarity						*/

void __dl__FPv(void *obj)					
{													
	DisposPtr((Ptr) obj);
}

/* unmangle __nw__12HandleObjectSFUi
 * Unmangled symbol: static HandleObject::operator new(unsigned int)
 * We return a void ** because this version of new should return 
 * a handle.													*/

void **__nw__12HandleObjectSFUi(unsigned int size)
{
Handle	aHdl;

aHdl = NewHandleSys(size);
return aHdl;
}

/* unmangle __dl__12HandleObjectSFPPv
 * Unmangled symbol: static HandleObject::operator delete(void **) */

void __dl__12HandleObjectSFPPv(void **aHandle)
{
DisposHandle((Handle) aHandle);
}

#ifdef __cplusplus
}
#endif
