/*
	A5World.h
	
	Interface to A5 world maintenance class.
	
	by Patrick Beard.
	
	1990 by Patrick C. Beard.  All rights reserved.
 */

#ifndef __A5WORLD__
#define __A5WORLD__

#include <Memory.h>
#include <StdDef.h>

class A5World {
public:
	A5World();							// constructor sets up world.
	~A5World();							// destructor destroys it.
	
	// main functions, Enter sets A5 to point to our world.
	void Enter();						// go into our world.
	void Leave();						// restore old A5 context.
	
	// error reporting.
	OSErr Result()	{ return error; }

private:
	OSErr error;						// the last error that occurred.
	long worldSize;						// how big our globals are.
	Ptr ourA5;							// the storage for the A5 world.
	Ptr oldA5;							// old A5.
};

#endif
