/*
	Relocatable.h
	
	Base class to provide utilities for type-safe handling of
	handle-based objects.
	
	by Patrick C. Beard.

	1989,90 by Patrick Beard.
 */

#ifndef __RELOCATABLE__
#define __RELOCATABLE__

#include <Memory.h>

class Relocatable : HandleObject {
protected:
	void Lock() { HLock((Handle)this); }
	void Unlock() { HUnlock((Handle)this); }
	void MoveHigh() { MoveHHi((Handle)this); }
	SignedByte GetState() { return HGetState((Handle)this); }
	void SetState(SignedByte flags) { HSetState((Handle)this, flags); }
};

#endif __RELOCATABLE__
