/*
	WindowDefinition.h
	
	An abstract base class for implementing Window Definition
	code resources in C++.
	
	by Patrick C. Beard.
 */

#ifndef __WINDOWDEFINITION__
#define __WINDOWDEFINITION__

#ifndef __WINDOWS__
#include <Windows.h>
#endif

#include "Relocatable.h"

class WindowDefinition : public Relocatable {
public:
	virtual void New(WindowPeek theWindow)				// initialize window.
					{ itsWindow = theWindow; }
	virtual void Dispose() {}							// destroy window.
	virtual void CalcRgns() {}							// compute all relevant regions.
	virtual void DrawFrame() {}							// draw the frame of the window.
	virtual void DrawGoAwayBox() {}						// draw the goaway box (toggle state).
	virtual void DrawGIcon() {}							// draw window's grow icon.
	virtual void DrawGrowImage(Rect& growRect) {}		// draw grow image of window.
	virtual long Hit(Point& whereHit)					// do hit testing.
					{ return wNoHit; }
protected:
	WindowPeek itsWindow;								// window we are keeping track of.
};

#endif