#|
   globals.lisp

   Defines the global variables used in the Mini-Application
   sample program.

   The use of the variables below is described in the appropiate
   places in the code where the globals are initialized.

   For further info, see files "About Mini-App" and "Instructions".


   Copyright 1990, 1991 by Ruben Kleiman for Apple Computer, Inc.

   Change History.
   03-11-92 slm  Changed all occurrences of defvar to defparameter (24)
                 so that after the Mini-Application is modified, the 
                 changed files can be re-evaluated immediately.
   03-09-92 slm  Updated file header comments.

|#

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; *window-count*
;;;
;;;   This variable is used to keep a count of the instances of
;;;   draw-dialog that we create
;;;
(defparameter *window-count* 0)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; *available-tools*
;;;
;;;   This variable is used as a default by the create-palette function
;;;   to list all tools that should be included in the palette.
;;;
;;;   It is set by the example program in mini-app-example.lisp.
;;;
(defparameter *available-tools* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; *available-draw-items*
;;;
;;;   This variable is used as a default by the create-palette function
;;;   to list all draw-items that should be included in the palette.
;;;
;;;   It is set by the example program in mini-app-example.lisp.
;;;
(defparameter *available-draw-items* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; *clonable-item*
;;;
;;;   Used by select-rectangle method to figure out which
;;;   draw-item to clone on a window when the user uses this
;;;   direct manipulation technique.
;;;
(defparameter *clonable-item* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Menubar
;;;
(defparameter *mini-application-menubar* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Menu items
;;;
(defparameter *mini-application-file-menu*     nil)
(defparameter *mini-application-edit-menu*     nil)
(defparameter *mini-application-options-menu*  nil)
(defparameter *selected-object-menu-indicator* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; File menu items
;;;
(defparameter *file-new-menu-item*   nil)
(defparameter *file-close-menu-item* nil)
(defparameter *file-quit-menu-item*  nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Edit menu items
;;;
(defparameter *cut-menu-item*   nil)
(defparameter *copy-menu-item*  nil)
(defparameter *paste-menu-item* nil)
(defparameter *clear-menu-item* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Options menu items
;;;
(defparameter *palette-menu-item*             nil)

(defparameter *window-object-info-menu-item*  nil)
(defparameter *window-script-menu-item*       nil)

(defparameter *object-script-menu-item*       nil)
(defparameter *object-info-menu-item*         nil)
(defparameter *bring-to-front-menu-item*      nil)
(defparameter *create-by-rectangle-menu-item* nil)

(defparameter *go-to-lisp-menubar-menu-item*  nil)


;end of file globals.lisp
;------------------------------------------------
