#|
   start-application.lisp

   Defines the top level functions that get called to start the
   Mini-Application, and then starts it.

   For further info, see files "About Mini-App" and "Instructions".


   Copyright 1990, 1991 by Ruben Kleiman for Apple Computer, Inc.

   Change History.
   03-09-92 slm  Updated file header comments.
   03-06-92 slm  Extracted definitions from superseded file 
                    "mini-application-loader.lisp".
                 Extracted initiation call from superseded file
                    "example.lisp".

|#

;;; __________________________________________________________________________
;;; Define the application

;;; We will call this once when everything is loaded. This gets
;;; everything going.
;;;
(defun start-application ( )
  (when (welcome-accepted?) ; Display welcome message
    (show-menus)            ; Initialize the menubar
    (eval-enqueue `(format t "~%Welcome To Our Mini Application!"))))

;;; Return non-nil value if user wants the application to start.
;;;
(defun welcome-accepted? ()
  (y-or-n-dialog "Welcome To My App.  Ready, Set, Go?"
                 :yes-text "Go Dude!"
                 :no-text "Nope"))

;end of file start-application.lisp
;------------------------------------------------
